// $ANTLR 3.3 Nov 30, 2010 12:46:29 net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g 2011-08-15 17:24:56

/*
 * The contents of this file are subject to the Mozilla Public License 
 * Version 1.1 (the "License"); you may not use this file except in 
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" 
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific language governing rights and limitations 
 * under the License.
 * 
 * The Original Code is the NRL Parser, released 28 April 2006, 
 * Copyright (c) Christian Nentwich. The Initial Developer of the 
 * Original Code is Christian Nentwich. Portions created by contributors 
 * identified in the NOTICES file are Copyright (c) the contributors. 
 * All Rights Reserved. 
 */
package net.sourceforge.nrl.parser.ast.impl;
	
import net.sourceforge.nrl.parser.ast.constraints.IArithmeticExpression;
import net.sourceforge.nrl.parser.ast.constraints.IExpression;
import net.sourceforge.nrl.parser.IStatusCode;
import net.sourceforge.nrl.parser.SyntaxError;
import net.sourceforge.nrl.parser.NRLError;
import net.sourceforge.nrl.parser.ast.constraints.impl.VariableDeclarationImpl;	
import net.sourceforge.nrl.parser.ast.constraints.impl.ModelReferenceImpl;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

import org.antlr.runtime.tree.*;

public class NRLActionParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "VT_COMPOUND_REPORT", "VT_CONCATENATED_REPORT", "VT_CONDITIONAL_REPORT", "VT_MULTIPLE_CONTEXTENTRY", "VT_ENUMERATOR", "VT_EXISTS", "VT_FIRST_ORDINAL_NUMBER", "VT_MODELREFERENCE", "VT_MULTIPLE_EXISTS", "VT_MULTIPLE_NOTEXISTS", "VT_NEGATE_DECIMAL", "VT_NEGATE_INTEGER", "VT_RULEFILE", "VT_SELECTION_EXPR", "VT_SINGLE_SELECTION_EXPR", "VT_VARIABLE_DECLARATION", "VALIDATION_RULE", "DOUBLE_QUOTED_STRING", "COMMA", "VALIDATION_FRAGMENT", "RULESET", "APPLIES_TO", "WHERE", "REPRESENT", "HASHAVE", "CONTEXT", "LPAREN", "RPAREN", "IF", "THEN", "ELSE", "IFF", "IMPLIES", "OR", "AND", "OF", "THAT", "IN", "EXACTLY", "AT_LEAST", "AT_MOST", "ONE", "TWO", "THREE", "FOUR", "INTEGER_NUMBER", "NO", "PRESENT", "THERE_IS", "NOT_PRESENT", "EACH", "IN_COLLECTION", "IS_IN", "IS_NOT_IN", "EQUALS", "NOT_EQUALS", "LESS", "LESS_EQ", "GREATER", "GREATER_EQ", "KIND_OF", "FOLLOWING", "COLON", "ADD", "MINUS", "TIMES", "DIV", "MOD", "OPERATOR", "PROPERTYNAME", "FROM", "TO", "WITH", "USING", "SUM_OF", "NUMBER_OF", "UNIQUE", "BY", "AS_A", "FIRST", "SINGLE_QUOTED_STRING", "BOOLEAN", "DECIMAL_NUMBER", "ORDINAL_NUMBER", "IDENTIFIER", "REPORT", "SEMI", "VT_CONDITIONAL_ACTION", "VT_COMPOUND_ACTION", "VT_FOREACH_ACTION", "VT_MACRO_APPLICATION", "VT_OPERATOR_ACTION", "VT_REMOVE_FROM_COLLECTION", "VT_VARIABLE_DECLARATION_ACTION", "MODEL", "OPERATORS", "ACTION_RULE", "ACTION_FRAGMENT", "CREATE", "NEW", "REMOVE", "SET", "ADD_VERB"
    };
    public static final int EOF=-1;
    public static final int VT_COMPOUND_REPORT=4;
    public static final int VT_CONCATENATED_REPORT=5;
    public static final int VT_CONDITIONAL_REPORT=6;
    public static final int VT_MULTIPLE_CONTEXTENTRY=7;
    public static final int VT_ENUMERATOR=8;
    public static final int VT_EXISTS=9;
    public static final int VT_FIRST_ORDINAL_NUMBER=10;
    public static final int VT_MODELREFERENCE=11;
    public static final int VT_MULTIPLE_EXISTS=12;
    public static final int VT_MULTIPLE_NOTEXISTS=13;
    public static final int VT_NEGATE_DECIMAL=14;
    public static final int VT_NEGATE_INTEGER=15;
    public static final int VT_RULEFILE=16;
    public static final int VT_SELECTION_EXPR=17;
    public static final int VT_SINGLE_SELECTION_EXPR=18;
    public static final int VT_VARIABLE_DECLARATION=19;
    public static final int VALIDATION_RULE=20;
    public static final int DOUBLE_QUOTED_STRING=21;
    public static final int COMMA=22;
    public static final int VALIDATION_FRAGMENT=23;
    public static final int RULESET=24;
    public static final int APPLIES_TO=25;
    public static final int WHERE=26;
    public static final int REPRESENT=27;
    public static final int HASHAVE=28;
    public static final int CONTEXT=29;
    public static final int LPAREN=30;
    public static final int RPAREN=31;
    public static final int IF=32;
    public static final int THEN=33;
    public static final int ELSE=34;
    public static final int IFF=35;
    public static final int IMPLIES=36;
    public static final int OR=37;
    public static final int AND=38;
    public static final int OF=39;
    public static final int THAT=40;
    public static final int IN=41;
    public static final int EXACTLY=42;
    public static final int AT_LEAST=43;
    public static final int AT_MOST=44;
    public static final int ONE=45;
    public static final int TWO=46;
    public static final int THREE=47;
    public static final int FOUR=48;
    public static final int INTEGER_NUMBER=49;
    public static final int NO=50;
    public static final int PRESENT=51;
    public static final int THERE_IS=52;
    public static final int NOT_PRESENT=53;
    public static final int EACH=54;
    public static final int IN_COLLECTION=55;
    public static final int IS_IN=56;
    public static final int IS_NOT_IN=57;
    public static final int EQUALS=58;
    public static final int NOT_EQUALS=59;
    public static final int LESS=60;
    public static final int LESS_EQ=61;
    public static final int GREATER=62;
    public static final int GREATER_EQ=63;
    public static final int KIND_OF=64;
    public static final int FOLLOWING=65;
    public static final int COLON=66;
    public static final int ADD=67;
    public static final int MINUS=68;
    public static final int TIMES=69;
    public static final int DIV=70;
    public static final int MOD=71;
    public static final int OPERATOR=72;
    public static final int PROPERTYNAME=73;
    public static final int FROM=74;
    public static final int TO=75;
    public static final int WITH=76;
    public static final int USING=77;
    public static final int SUM_OF=78;
    public static final int NUMBER_OF=79;
    public static final int UNIQUE=80;
    public static final int BY=81;
    public static final int AS_A=82;
    public static final int FIRST=83;
    public static final int SINGLE_QUOTED_STRING=84;
    public static final int BOOLEAN=85;
    public static final int DECIMAL_NUMBER=86;
    public static final int ORDINAL_NUMBER=87;
    public static final int IDENTIFIER=88;
    public static final int REPORT=89;
    public static final int SEMI=90;
    public static final int VT_CONDITIONAL_ACTION=91;
    public static final int VT_COMPOUND_ACTION=92;
    public static final int VT_FOREACH_ACTION=93;
    public static final int VT_MACRO_APPLICATION=94;
    public static final int VT_OPERATOR_ACTION=95;
    public static final int VT_REMOVE_FROM_COLLECTION=96;
    public static final int VT_VARIABLE_DECLARATION_ACTION=97;
    public static final int MODEL=98;
    public static final int OPERATORS=99;
    public static final int ACTION_RULE=100;
    public static final int ACTION_FRAGMENT=101;
    public static final int CREATE=102;
    public static final int NEW=103;
    public static final int REMOVE=104;
    public static final int SET=105;
    public static final int ADD_VERB=106;

    // delegates
    public NRLActionParser_NRLConstraintRules gNRLConstraintRules;
    // delegators


        public NRLActionParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public NRLActionParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
            gNRLConstraintRules = new NRLActionParser_NRLConstraintRules(input, state, this);         
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
        gNRLConstraintRules.setTreeAdaptor(this.adaptor);
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return NRLActionParser.tokenNames; }
    public String getGrammarFileName() { return "net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g"; }


    	public java.util.List<NRLError> getSyntaxErrors() {
    		return gNRLConstraintRules.getSyntaxErrors();
    	}
    	
    	public boolean hasErrors() {
    		return gNRLConstraintRules.hasErrors();
    	}
    	
    	
    	public void resetErrors() {
    		gNRLConstraintRules.resetErrors();
    	}
    	
    	public void displayRecognitionError(String[] tokenNames, RecognitionException e) {
    		gNRLConstraintRules.displayRecognitionError(tokenNames, e);
    	}	

    	public void initialisePositionFromChild(Object obj, int index) {
    		if (obj instanceof Antlr3NRLBaseAst)
    			((Antlr3NRLBaseAst) obj).initialisePositionFromChild(index);
    	}


    public static class fileBody_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "fileBody"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:95:1: fileBody : modelFileReferences operatorFileReferences declarations EOF -> ^( VT_RULEFILE modelFileReferences ( operatorFileReferences )? ( declarations )? ) ;
    public final NRLActionParser.fileBody_return fileBody() throws RecognitionException {
        NRLActionParser.fileBody_return retval = new NRLActionParser.fileBody_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token EOF4=null;
        NRLActionParser.modelFileReferences_return modelFileReferences1 = null;

        NRLActionParser.operatorFileReferences_return operatorFileReferences2 = null;

        NRLActionParser.declarations_return declarations3 = null;


        CommonTree EOF4_tree=null;
        RewriteRuleTokenStream stream_EOF=new RewriteRuleTokenStream(adaptor,"token EOF");
        RewriteRuleSubtreeStream stream_operatorFileReferences=new RewriteRuleSubtreeStream(adaptor,"rule operatorFileReferences");
        RewriteRuleSubtreeStream stream_modelFileReferences=new RewriteRuleSubtreeStream(adaptor,"rule modelFileReferences");
        RewriteRuleSubtreeStream stream_declarations=new RewriteRuleSubtreeStream(adaptor,"rule declarations");
        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:96:3: ( modelFileReferences operatorFileReferences declarations EOF -> ^( VT_RULEFILE modelFileReferences ( operatorFileReferences )? ( declarations )? ) )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:96:5: modelFileReferences operatorFileReferences declarations EOF
            {
            pushFollow(FOLLOW_modelFileReferences_in_fileBody96);
            modelFileReferences1=modelFileReferences();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_modelFileReferences.add(modelFileReferences1.getTree());
            pushFollow(FOLLOW_operatorFileReferences_in_fileBody98);
            operatorFileReferences2=operatorFileReferences();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_operatorFileReferences.add(operatorFileReferences2.getTree());
            pushFollow(FOLLOW_declarations_in_fileBody100);
            declarations3=declarations();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_declarations.add(declarations3.getTree());
            EOF4=(Token)match(input,EOF,FOLLOW_EOF_in_fileBody102); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_EOF.add(EOF4);



            // AST REWRITE
            // elements: modelFileReferences, declarations, operatorFileReferences
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 97:4: -> ^( VT_RULEFILE modelFileReferences ( operatorFileReferences )? ( declarations )? )
            {
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:97:7: ^( VT_RULEFILE modelFileReferences ( operatorFileReferences )? ( declarations )? )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_RULEFILE, "VT_RULEFILE"), root_1);

                adaptor.addChild(root_1, stream_modelFileReferences.nextTree());
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:97:41: ( operatorFileReferences )?
                if ( stream_operatorFileReferences.hasNext() ) {
                    adaptor.addChild(root_1, stream_operatorFileReferences.nextTree());

                }
                stream_operatorFileReferences.reset();
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:97:65: ( declarations )?
                if ( stream_declarations.hasNext() ) {
                    adaptor.addChild(root_1, stream_declarations.nextTree());

                }
                stream_declarations.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "fileBody"

    public static class modelFileReferences_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "modelFileReferences"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:100:1: modelFileReferences : ( modelFileReference )+ ;
    public final NRLActionParser.modelFileReferences_return modelFileReferences() throws RecognitionException {
        NRLActionParser.modelFileReferences_return retval = new NRLActionParser.modelFileReferences_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser.modelFileReference_return modelFileReference5 = null;



        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:101:3: ( ( modelFileReference )+ )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:101:5: ( modelFileReference )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:101:5: ( modelFileReference )+
            int cnt1=0;
            loop1:
            do {
                int alt1=2;
                switch ( input.LA(1) ) {
                case MODEL:
                    {
                    alt1=1;
                    }
                    break;

                }

                switch (alt1) {
            	case 1 :
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:101:6: modelFileReference
            	    {
            	    pushFollow(FOLLOW_modelFileReference_in_modelFileReferences135);
            	    modelFileReference5=modelFileReference();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelFileReference5.getTree());

            	    }
            	    break;

            	default :
            	    if ( cnt1 >= 1 ) break loop1;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(1, input);
                        throw eee;
                }
                cnt1++;
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "modelFileReferences"

    public static class modelFileReference_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "modelFileReference"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:104:1: modelFileReference : MODEL DOUBLE_QUOTED_STRING ;
    public final NRLActionParser.modelFileReference_return modelFileReference() throws RecognitionException {
        NRLActionParser.modelFileReference_return retval = new NRLActionParser.modelFileReference_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token MODEL6=null;
        Token DOUBLE_QUOTED_STRING7=null;

        CommonTree MODEL6_tree=null;
        CommonTree DOUBLE_QUOTED_STRING7_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:105:3: ( MODEL DOUBLE_QUOTED_STRING )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:105:5: MODEL DOUBLE_QUOTED_STRING
            {
            root_0 = (CommonTree)adaptor.nil();

            MODEL6=(Token)match(input,MODEL,FOLLOW_MODEL_in_modelFileReference150); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            MODEL6_tree = (CommonTree)adaptor.create(MODEL6);
            root_0 = (CommonTree)adaptor.becomeRoot(MODEL6_tree, root_0);
            }
            DOUBLE_QUOTED_STRING7=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_modelFileReference153); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOUBLE_QUOTED_STRING7_tree = (CommonTree)adaptor.create(DOUBLE_QUOTED_STRING7);
            adaptor.addChild(root_0, DOUBLE_QUOTED_STRING7_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "modelFileReference"

    public static class operatorFileReferences_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "operatorFileReferences"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:108:1: operatorFileReferences : ( operatorFileReference )* ;
    public final NRLActionParser.operatorFileReferences_return operatorFileReferences() throws RecognitionException {
        NRLActionParser.operatorFileReferences_return retval = new NRLActionParser.operatorFileReferences_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser.operatorFileReference_return operatorFileReference8 = null;



        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:109:3: ( ( operatorFileReference )* )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:109:5: ( operatorFileReference )*
            {
            root_0 = (CommonTree)adaptor.nil();

            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:109:5: ( operatorFileReference )*
            loop2:
            do {
                int alt2=2;
                switch ( input.LA(1) ) {
                case OPERATORS:
                    {
                    alt2=1;
                    }
                    break;

                }

                switch (alt2) {
            	case 1 :
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:109:6: operatorFileReference
            	    {
            	    pushFollow(FOLLOW_operatorFileReference_in_operatorFileReferences169);
            	    operatorFileReference8=operatorFileReference();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, operatorFileReference8.getTree());

            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "operatorFileReferences"

    public static class operatorFileReference_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "operatorFileReference"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:112:1: operatorFileReference : OPERATORS DOUBLE_QUOTED_STRING ;
    public final NRLActionParser.operatorFileReference_return operatorFileReference() throws RecognitionException {
        NRLActionParser.operatorFileReference_return retval = new NRLActionParser.operatorFileReference_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token OPERATORS9=null;
        Token DOUBLE_QUOTED_STRING10=null;

        CommonTree OPERATORS9_tree=null;
        CommonTree DOUBLE_QUOTED_STRING10_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:113:3: ( OPERATORS DOUBLE_QUOTED_STRING )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:113:5: OPERATORS DOUBLE_QUOTED_STRING
            {
            root_0 = (CommonTree)adaptor.nil();

            OPERATORS9=(Token)match(input,OPERATORS,FOLLOW_OPERATORS_in_operatorFileReference184); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            OPERATORS9_tree = (CommonTree)adaptor.create(OPERATORS9);
            root_0 = (CommonTree)adaptor.becomeRoot(OPERATORS9_tree, root_0);
            }
            DOUBLE_QUOTED_STRING10=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_operatorFileReference187); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOUBLE_QUOTED_STRING10_tree = (CommonTree)adaptor.create(DOUBLE_QUOTED_STRING10);
            adaptor.addChild(root_0, DOUBLE_QUOTED_STRING10_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "operatorFileReference"

    public static class declarations_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "declarations"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:116:1: declarations : ( declaration )* ;
    public final NRLActionParser.declarations_return declarations() throws RecognitionException {
        NRLActionParser.declarations_return retval = new NRLActionParser.declarations_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser.declaration_return declaration11 = null;



        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:117:3: ( ( declaration )* )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:117:5: ( declaration )*
            {
            root_0 = (CommonTree)adaptor.nil();

            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:117:5: ( declaration )*
            loop3:
            do {
                int alt3=2;
                switch ( input.LA(1) ) {
                case DOUBLE_QUOTED_STRING:
                case RULESET:
                case CONTEXT:
                    {
                    alt3=1;
                    }
                    break;

                }

                switch (alt3) {
            	case 1 :
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:117:6: declaration
            	    {
            	    pushFollow(FOLLOW_declaration_in_declarations205);
            	    declaration11=declaration();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, declaration11.getTree());

            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "declarations"

    public static class declaration_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "declaration"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:120:1: declaration : ( ( context VALIDATION_RULE )=> validationRuleDeclaration | ( actionContext ACTION_RULE )=> actionRuleDeclaration | ( multipleContext ACTION_FRAGMENT )=> actionFragmentDeclaration | globalVariableDeclaration | ruleSetDeclaration | validationFragmentDeclaration );
    public final NRLActionParser.declaration_return declaration() throws RecognitionException {
        NRLActionParser.declaration_return retval = new NRLActionParser.declaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser_NRLConstraintRules.validationRuleDeclaration_return validationRuleDeclaration12 = null;

        NRLActionParser.actionRuleDeclaration_return actionRuleDeclaration13 = null;

        NRLActionParser.actionFragmentDeclaration_return actionFragmentDeclaration14 = null;

        NRLActionParser_NRLConstraintRules.globalVariableDeclaration_return globalVariableDeclaration15 = null;

        NRLActionParser_NRLConstraintRules.ruleSetDeclaration_return ruleSetDeclaration16 = null;

        NRLActionParser_NRLConstraintRules.validationFragmentDeclaration_return validationFragmentDeclaration17 = null;



        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:121:3: ( ( context VALIDATION_RULE )=> validationRuleDeclaration | ( actionContext ACTION_RULE )=> actionRuleDeclaration | ( multipleContext ACTION_FRAGMENT )=> actionFragmentDeclaration | globalVariableDeclaration | ruleSetDeclaration | validationFragmentDeclaration )
            int alt4=6;
            switch ( input.LA(1) ) {
            case CONTEXT:
                {
                int LA4_1 = input.LA(2);

                if ( (synpred1_NRLActionParser()) ) {
                    alt4=1;
                }
                else if ( (synpred2_NRLActionParser()) ) {
                    alt4=2;
                }
                else if ( (synpred3_NRLActionParser()) ) {
                    alt4=3;
                }
                else if ( (true) ) {
                    alt4=6;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 4, 1, input);

                    throw nvae;
                }
                }
                break;
            case DOUBLE_QUOTED_STRING:
                {
                alt4=4;
                }
                break;
            case RULESET:
                {
                alt4=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 4, 0, input);

                throw nvae;
            }

            switch (alt4) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:121:5: ( context VALIDATION_RULE )=> validationRuleDeclaration
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_validationRuleDeclaration_in_declaration229);
                    validationRuleDeclaration12=validationRuleDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, validationRuleDeclaration12.getTree());

                    }
                    break;
                case 2 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:122:5: ( actionContext ACTION_RULE )=> actionRuleDeclaration
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_actionRuleDeclaration_in_declaration243);
                    actionRuleDeclaration13=actionRuleDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, actionRuleDeclaration13.getTree());

                    }
                    break;
                case 3 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:123:5: ( multipleContext ACTION_FRAGMENT )=> actionFragmentDeclaration
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_actionFragmentDeclaration_in_declaration257);
                    actionFragmentDeclaration14=actionFragmentDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, actionFragmentDeclaration14.getTree());

                    }
                    break;
                case 4 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:124:5: globalVariableDeclaration
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_globalVariableDeclaration_in_declaration263);
                    globalVariableDeclaration15=globalVariableDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, globalVariableDeclaration15.getTree());

                    }
                    break;
                case 5 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:125:5: ruleSetDeclaration
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_ruleSetDeclaration_in_declaration269);
                    ruleSetDeclaration16=ruleSetDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, ruleSetDeclaration16.getTree());

                    }
                    break;
                case 6 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:126:5: validationFragmentDeclaration
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_validationFragmentDeclaration_in_declaration275);
                    validationFragmentDeclaration17=validationFragmentDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, validationFragmentDeclaration17.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "declaration"

    public static class actionRuleDeclaration_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "actionRuleDeclaration"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:131:1: actionRuleDeclaration : actionContext ACTION_RULE DOUBLE_QUOTED_STRING action ;
    public final NRLActionParser.actionRuleDeclaration_return actionRuleDeclaration() throws RecognitionException {
        NRLActionParser.actionRuleDeclaration_return retval = new NRLActionParser.actionRuleDeclaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token ACTION_RULE19=null;
        Token DOUBLE_QUOTED_STRING20=null;
        NRLActionParser.actionContext_return actionContext18 = null;

        NRLActionParser.action_return action21 = null;


        CommonTree ACTION_RULE19_tree=null;
        CommonTree DOUBLE_QUOTED_STRING20_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:132:3: ( actionContext ACTION_RULE DOUBLE_QUOTED_STRING action )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:132:5: actionContext ACTION_RULE DOUBLE_QUOTED_STRING action
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_actionContext_in_actionRuleDeclaration292);
            actionContext18=actionContext();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, actionContext18.getTree());
            ACTION_RULE19=(Token)match(input,ACTION_RULE,FOLLOW_ACTION_RULE_in_actionRuleDeclaration294); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ACTION_RULE19_tree = (CommonTree)adaptor.create(ACTION_RULE19);
            root_0 = (CommonTree)adaptor.becomeRoot(ACTION_RULE19_tree, root_0);
            }
            DOUBLE_QUOTED_STRING20=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_actionRuleDeclaration297); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOUBLE_QUOTED_STRING20_tree = (CommonTree)adaptor.create(DOUBLE_QUOTED_STRING20);
            adaptor.addChild(root_0, DOUBLE_QUOTED_STRING20_tree);
            }
            pushFollow(FOLLOW_action_in_actionRuleDeclaration299);
            action21=action();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, action21.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "actionRuleDeclaration"

    public static class actionFragmentDeclaration_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "actionFragmentDeclaration"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:135:1: actionFragmentDeclaration : multipleContext ACTION_FRAGMENT DOUBLE_QUOTED_STRING action ;
    public final NRLActionParser.actionFragmentDeclaration_return actionFragmentDeclaration() throws RecognitionException {
        NRLActionParser.actionFragmentDeclaration_return retval = new NRLActionParser.actionFragmentDeclaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token ACTION_FRAGMENT23=null;
        Token DOUBLE_QUOTED_STRING24=null;
        NRLActionParser_NRLConstraintRules.multipleContext_return multipleContext22 = null;

        NRLActionParser.action_return action25 = null;


        CommonTree ACTION_FRAGMENT23_tree=null;
        CommonTree DOUBLE_QUOTED_STRING24_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:136:3: ( multipleContext ACTION_FRAGMENT DOUBLE_QUOTED_STRING action )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:136:5: multipleContext ACTION_FRAGMENT DOUBLE_QUOTED_STRING action
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_multipleContext_in_actionFragmentDeclaration314);
            multipleContext22=multipleContext();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, multipleContext22.getTree());
            ACTION_FRAGMENT23=(Token)match(input,ACTION_FRAGMENT,FOLLOW_ACTION_FRAGMENT_in_actionFragmentDeclaration316); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ACTION_FRAGMENT23_tree = (CommonTree)adaptor.create(ACTION_FRAGMENT23);
            root_0 = (CommonTree)adaptor.becomeRoot(ACTION_FRAGMENT23_tree, root_0);
            }
            DOUBLE_QUOTED_STRING24=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_actionFragmentDeclaration319); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOUBLE_QUOTED_STRING24_tree = (CommonTree)adaptor.create(DOUBLE_QUOTED_STRING24);
            adaptor.addChild(root_0, DOUBLE_QUOTED_STRING24_tree);
            }
            pushFollow(FOLLOW_action_in_actionFragmentDeclaration321);
            action25=action();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, action25.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "actionFragmentDeclaration"

    public static class actionContext_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "actionContext"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:139:1: actionContext : ( CONTEXT modelReference | CONTEXT NO );
    public final NRLActionParser.actionContext_return actionContext() throws RecognitionException {
        NRLActionParser.actionContext_return retval = new NRLActionParser.actionContext_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token CONTEXT26=null;
        Token CONTEXT28=null;
        Token NO29=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference27 = null;


        CommonTree CONTEXT26_tree=null;
        CommonTree CONTEXT28_tree=null;
        CommonTree NO29_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:140:3: ( CONTEXT modelReference | CONTEXT NO )
            int alt5=2;
            switch ( input.LA(1) ) {
            case CONTEXT:
                {
                switch ( input.LA(2) ) {
                case NO:
                    {
                    alt5=2;
                    }
                    break;
                case IDENTIFIER:
                    {
                    alt5=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 5, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }

            switch (alt5) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:140:5: CONTEXT modelReference
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    CONTEXT26=(Token)match(input,CONTEXT,FOLLOW_CONTEXT_in_actionContext334); if (state.failed) return retval;
                    pushFollow(FOLLOW_modelReference_in_actionContext337);
                    modelReference27=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference27.getTree());

                    }
                    break;
                case 2 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:141:5: CONTEXT NO
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    CONTEXT28=(Token)match(input,CONTEXT,FOLLOW_CONTEXT_in_actionContext343); if (state.failed) return retval;
                    NO29=(Token)match(input,NO,FOLLOW_NO_in_actionContext346); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NO29_tree = (CommonTree)adaptor.create(NO29);
                    adaptor.addChild(root_0, NO29_tree);
                    }

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "actionContext"

    public static class singleActionAndEOF_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "singleActionAndEOF"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:144:1: singleActionAndEOF : action EOF ;
    public final NRLActionParser.singleActionAndEOF_return singleActionAndEOF() throws RecognitionException {
        NRLActionParser.singleActionAndEOF_return retval = new NRLActionParser.singleActionAndEOF_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token EOF31=null;
        NRLActionParser.action_return action30 = null;


        CommonTree EOF31_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:145:3: ( action EOF )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:145:5: action EOF
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_action_in_singleActionAndEOF360);
            action30=action();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, action30.getTree());
            EOF31=(Token)match(input,EOF,FOLLOW_EOF_in_singleActionAndEOF362); if (state.failed) return retval;

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "singleActionAndEOF"

    public static class action_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "action"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:148:1: action : compoundAction ;
    public final NRLActionParser.action_return action() throws RecognitionException {
        NRLActionParser.action_return retval = new NRLActionParser.action_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser.compoundAction_return compoundAction32 = null;



        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:149:3: ( compoundAction )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:149:5: compoundAction
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_compoundAction_in_action378);
            compoundAction32=compoundAction();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, compoundAction32.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "action"

    public static class conditionalAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "conditionalAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:152:1: conditionalAction : IF cif= statement THEN cthen= action ( options {greedy=true; } : ELSE celse= action )? SEMI -> ^( VT_CONDITIONAL_ACTION $cif $cthen ( $celse)? ) ;
    public final NRLActionParser.conditionalAction_return conditionalAction() throws RecognitionException {
        NRLActionParser.conditionalAction_return retval = new NRLActionParser.conditionalAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token IF33=null;
        Token THEN34=null;
        Token ELSE35=null;
        Token SEMI36=null;
        NRLActionParser_NRLConstraintRules.statement_return cif = null;

        NRLActionParser.action_return cthen = null;

        NRLActionParser.action_return celse = null;


        CommonTree IF33_tree=null;
        CommonTree THEN34_tree=null;
        CommonTree ELSE35_tree=null;
        CommonTree SEMI36_tree=null;
        RewriteRuleTokenStream stream_THEN=new RewriteRuleTokenStream(adaptor,"token THEN");
        RewriteRuleTokenStream stream_SEMI=new RewriteRuleTokenStream(adaptor,"token SEMI");
        RewriteRuleTokenStream stream_IF=new RewriteRuleTokenStream(adaptor,"token IF");
        RewriteRuleTokenStream stream_ELSE=new RewriteRuleTokenStream(adaptor,"token ELSE");
        RewriteRuleSubtreeStream stream_statement=new RewriteRuleSubtreeStream(adaptor,"rule statement");
        RewriteRuleSubtreeStream stream_action=new RewriteRuleSubtreeStream(adaptor,"rule action");
        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:154:3: ( IF cif= statement THEN cthen= action ( options {greedy=true; } : ELSE celse= action )? SEMI -> ^( VT_CONDITIONAL_ACTION $cif $cthen ( $celse)? ) )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:154:5: IF cif= statement THEN cthen= action ( options {greedy=true; } : ELSE celse= action )? SEMI
            {
            IF33=(Token)match(input,IF,FOLLOW_IF_in_conditionalAction398); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_IF.add(IF33);

            pushFollow(FOLLOW_statement_in_conditionalAction402);
            cif=statement();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_statement.add(cif.getTree());
            THEN34=(Token)match(input,THEN,FOLLOW_THEN_in_conditionalAction404); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_THEN.add(THEN34);

            pushFollow(FOLLOW_action_in_conditionalAction408);
            cthen=action();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_action.add(cthen.getTree());
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:155:4: ( options {greedy=true; } : ELSE celse= action )?
            int alt6=2;
            switch ( input.LA(1) ) {
                case ELSE:
                    {
                    alt6=1;
                    }
                    break;
            }

            switch (alt6) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:159:5: ELSE celse= action
                    {
                    ELSE35=(Token)match(input,ELSE,FOLLOW_ELSE_in_conditionalAction445); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ELSE.add(ELSE35);

                    pushFollow(FOLLOW_action_in_conditionalAction449);
                    celse=action();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_action.add(celse.getTree());

                    }
                    break;

            }

            SEMI36=(Token)match(input,SEMI,FOLLOW_SEMI_in_conditionalAction460); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_SEMI.add(SEMI36);



            // AST REWRITE
            // elements: cthen, celse, cif
            // token labels: 
            // rule labels: retval, cif, celse, cthen
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_cif=new RewriteRuleSubtreeStream(adaptor,"rule cif",cif!=null?cif.tree:null);
            RewriteRuleSubtreeStream stream_celse=new RewriteRuleSubtreeStream(adaptor,"rule celse",celse!=null?celse.tree:null);
            RewriteRuleSubtreeStream stream_cthen=new RewriteRuleSubtreeStream(adaptor,"rule cthen",cthen!=null?cthen.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 162:4: -> ^( VT_CONDITIONAL_ACTION $cif $cthen ( $celse)? )
            {
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:162:7: ^( VT_CONDITIONAL_ACTION $cif $cthen ( $celse)? )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_CONDITIONAL_ACTION, "VT_CONDITIONAL_ACTION"), root_1);

                adaptor.addChild(root_1, stream_cif.nextTree());
                adaptor.addChild(root_1, stream_cthen.nextTree());
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:162:43: ( $celse)?
                if ( stream_celse.hasNext() ) {
                    adaptor.addChild(root_1, stream_celse.nextTree());

                }
                stream_celse.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "conditionalAction"

    public static class compoundAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "compoundAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:165:1: compoundAction : simpleActionList -> ^( VT_COMPOUND_ACTION simpleActionList ) ;
    public final NRLActionParser.compoundAction_return compoundAction() throws RecognitionException {
        NRLActionParser.compoundAction_return retval = new NRLActionParser.compoundAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser.simpleActionList_return simpleActionList37 = null;


        RewriteRuleSubtreeStream stream_simpleActionList=new RewriteRuleSubtreeStream(adaptor,"rule simpleActionList");
        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:167:3: ( simpleActionList -> ^( VT_COMPOUND_ACTION simpleActionList ) )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:167:5: simpleActionList
            {
            pushFollow(FOLLOW_simpleActionList_in_compoundAction497);
            simpleActionList37=simpleActionList();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_simpleActionList.add(simpleActionList37.getTree());


            // AST REWRITE
            // elements: simpleActionList
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 168:4: -> ^( VT_COMPOUND_ACTION simpleActionList )
            {
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:168:7: ^( VT_COMPOUND_ACTION simpleActionList )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_COMPOUND_ACTION, "VT_COMPOUND_ACTION"), root_1);

                adaptor.addChild(root_1, stream_simpleActionList.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "compoundAction"

    public static class simpleActionList_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "simpleActionList"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:171:1: simpleActionList : simpleAction ( ( COMMA )? ( THEN )? simpleAction )* ;
    public final NRLActionParser.simpleActionList_return simpleActionList() throws RecognitionException {
        NRLActionParser.simpleActionList_return retval = new NRLActionParser.simpleActionList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token COMMA39=null;
        Token THEN40=null;
        NRLActionParser.simpleAction_return simpleAction38 = null;

        NRLActionParser.simpleAction_return simpleAction41 = null;


        CommonTree COMMA39_tree=null;
        CommonTree THEN40_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:172:3: ( simpleAction ( ( COMMA )? ( THEN )? simpleAction )* )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:172:5: simpleAction ( ( COMMA )? ( THEN )? simpleAction )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_simpleAction_in_simpleActionList523);
            simpleAction38=simpleAction();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, simpleAction38.getTree());
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:172:18: ( ( COMMA )? ( THEN )? simpleAction )*
            loop9:
            do {
                int alt9=2;
                alt9 = dfa9.predict(input);
                switch (alt9) {
            	case 1 :
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:172:20: ( COMMA )? ( THEN )? simpleAction
            	    {
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:172:20: ( COMMA )?
            	    int alt7=2;
            	    switch ( input.LA(1) ) {
            	        case COMMA:
            	            {
            	            alt7=1;
            	            }
            	            break;
            	    }

            	    switch (alt7) {
            	        case 1 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:172:21: COMMA
            	            {
            	            COMMA39=(Token)match(input,COMMA,FOLLOW_COMMA_in_simpleActionList528); if (state.failed) return retval;

            	            }
            	            break;

            	    }

            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:172:30: ( THEN )?
            	    int alt8=2;
            	    switch ( input.LA(1) ) {
            	        case THEN:
            	            {
            	            alt8=1;
            	            }
            	            break;
            	    }

            	    switch (alt8) {
            	        case 1 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:172:31: THEN
            	            {
            	            THEN40=(Token)match(input,THEN,FOLLOW_THEN_in_simpleActionList534); if (state.failed) return retval;

            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_simpleAction_in_simpleActionList539);
            	    simpleAction41=simpleAction();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, simpleAction41.getTree());

            	    }
            	    break;

            	default :
            	    break loop9;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "simpleActionList"

    public static class simpleAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "simpleAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:175:1: simpleAction : ( createAction | ( REMOVE modelReference FROM )=> removeFromCollectionAction | removeAction | setAction | addAction | operatorAction | macroApplicationAction | forEachAction | variableDeclarationAction | conditionalAction );
    public final NRLActionParser.simpleAction_return simpleAction() throws RecognitionException {
        NRLActionParser.simpleAction_return retval = new NRLActionParser.simpleAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser.createAction_return createAction42 = null;

        NRLActionParser.removeFromCollectionAction_return removeFromCollectionAction43 = null;

        NRLActionParser.removeAction_return removeAction44 = null;

        NRLActionParser.setAction_return setAction45 = null;

        NRLActionParser.addAction_return addAction46 = null;

        NRLActionParser.operatorAction_return operatorAction47 = null;

        NRLActionParser.macroApplicationAction_return macroApplicationAction48 = null;

        NRLActionParser.forEachAction_return forEachAction49 = null;

        NRLActionParser.variableDeclarationAction_return variableDeclarationAction50 = null;

        NRLActionParser.conditionalAction_return conditionalAction51 = null;



        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:176:3: ( createAction | ( REMOVE modelReference FROM )=> removeFromCollectionAction | removeAction | setAction | addAction | operatorAction | macroApplicationAction | forEachAction | variableDeclarationAction | conditionalAction )
            int alt10=10;
            alt10 = dfa10.predict(input);
            switch (alt10) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:176:5: createAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_createAction_in_simpleAction557);
                    createAction42=createAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, createAction42.getTree());

                    }
                    break;
                case 2 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:177:5: ( REMOVE modelReference FROM )=> removeFromCollectionAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_removeFromCollectionAction_in_simpleAction573);
                    removeFromCollectionAction43=removeFromCollectionAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, removeFromCollectionAction43.getTree());

                    }
                    break;
                case 3 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:178:5: removeAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_removeAction_in_simpleAction579);
                    removeAction44=removeAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, removeAction44.getTree());

                    }
                    break;
                case 4 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:179:5: setAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_setAction_in_simpleAction585);
                    setAction45=setAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, setAction45.getTree());

                    }
                    break;
                case 5 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:180:5: addAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_addAction_in_simpleAction591);
                    addAction46=addAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, addAction46.getTree());

                    }
                    break;
                case 6 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:181:5: operatorAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_operatorAction_in_simpleAction597);
                    operatorAction47=operatorAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, operatorAction47.getTree());

                    }
                    break;
                case 7 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:182:5: macroApplicationAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_macroApplicationAction_in_simpleAction603);
                    macroApplicationAction48=macroApplicationAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, macroApplicationAction48.getTree());

                    }
                    break;
                case 8 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:183:5: forEachAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_forEachAction_in_simpleAction609);
                    forEachAction49=forEachAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, forEachAction49.getTree());

                    }
                    break;
                case 9 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:184:5: variableDeclarationAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_variableDeclarationAction_in_simpleAction615);
                    variableDeclarationAction50=variableDeclarationAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, variableDeclarationAction50.getTree());

                    }
                    break;
                case 10 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:185:5: conditionalAction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_conditionalAction_in_simpleAction621);
                    conditionalAction51=conditionalAction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, conditionalAction51.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "simpleAction"

    public static class createAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "createAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:188:1: createAction : CREATE NEW modelReference ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN )? ;
    public final NRLActionParser.createAction_return createAction() throws RecognitionException {
        NRLActionParser.createAction_return retval = new NRLActionParser.createAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token var=null;
        Token CREATE52=null;
        Token NEW53=null;
        Token LPAREN55=null;
        Token RPAREN56=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference54 = null;


        CommonTree var_tree=null;
        CommonTree CREATE52_tree=null;
        CommonTree NEW53_tree=null;
        CommonTree LPAREN55_tree=null;
        CommonTree RPAREN56_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:189:3: ( CREATE NEW modelReference ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN )? )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:189:5: CREATE NEW modelReference ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN )?
            {
            root_0 = (CommonTree)adaptor.nil();

            CREATE52=(Token)match(input,CREATE,FOLLOW_CREATE_in_createAction637); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            CREATE52_tree = (CommonTree)adaptor.create(CREATE52);
            root_0 = (CommonTree)adaptor.becomeRoot(CREATE52_tree, root_0);
            }
            NEW53=(Token)match(input,NEW,FOLLOW_NEW_in_createAction640); if (state.failed) return retval;
            pushFollow(FOLLOW_modelReference_in_createAction643);
            modelReference54=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference54.getTree());
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:189:33: ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN )?
            int alt11=2;
            switch ( input.LA(1) ) {
                case LPAREN:
                    {
                    alt11=1;
                    }
                    break;
            }

            switch (alt11) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:189:34: LPAREN var= DOUBLE_QUOTED_STRING RPAREN
                    {
                    LPAREN55=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_createAction646); if (state.failed) return retval;
                    var=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_createAction651); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    var_tree = (CommonTree)adaptor.create(var);
                    adaptor.addChild(root_0, var_tree);
                    }
                    RPAREN56=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_createAction653); if (state.failed) return retval;

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "createAction"

    public static class removeAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "removeAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:192:1: removeAction : REMOVE ( EACH )? ( OF )? modelReference ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN WHERE constraint )? ;
    public final NRLActionParser.removeAction_return removeAction() throws RecognitionException {
        NRLActionParser.removeAction_return retval = new NRLActionParser.removeAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token var=null;
        Token REMOVE57=null;
        Token EACH58=null;
        Token OF59=null;
        Token LPAREN61=null;
        Token RPAREN62=null;
        Token WHERE63=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference60 = null;

        NRLActionParser_NRLConstraintRules.constraint_return constraint64 = null;


        CommonTree var_tree=null;
        CommonTree REMOVE57_tree=null;
        CommonTree EACH58_tree=null;
        CommonTree OF59_tree=null;
        CommonTree LPAREN61_tree=null;
        CommonTree RPAREN62_tree=null;
        CommonTree WHERE63_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:193:3: ( REMOVE ( EACH )? ( OF )? modelReference ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN WHERE constraint )? )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:193:5: REMOVE ( EACH )? ( OF )? modelReference ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN WHERE constraint )?
            {
            root_0 = (CommonTree)adaptor.nil();

            REMOVE57=(Token)match(input,REMOVE,FOLLOW_REMOVE_in_removeAction671); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            REMOVE57_tree = (CommonTree)adaptor.create(REMOVE57);
            root_0 = (CommonTree)adaptor.becomeRoot(REMOVE57_tree, root_0);
            }
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:193:13: ( EACH )?
            int alt12=2;
            switch ( input.LA(1) ) {
                case EACH:
                    {
                    alt12=1;
                    }
                    break;
            }

            switch (alt12) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:193:14: EACH
                    {
                    EACH58=(Token)match(input,EACH,FOLLOW_EACH_in_removeAction675); if (state.failed) return retval;

                    }
                    break;

            }

            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:193:22: ( OF )?
            int alt13=2;
            switch ( input.LA(1) ) {
                case OF:
                    {
                    alt13=1;
                    }
                    break;
            }

            switch (alt13) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:193:23: OF
                    {
                    OF59=(Token)match(input,OF,FOLLOW_OF_in_removeAction681); if (state.failed) return retval;

                    }
                    break;

            }

            pushFollow(FOLLOW_modelReference_in_removeAction686);
            modelReference60=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference60.getTree());
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:193:44: ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN WHERE constraint )?
            int alt14=2;
            switch ( input.LA(1) ) {
                case LPAREN:
                    {
                    alt14=1;
                    }
                    break;
            }

            switch (alt14) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:193:45: LPAREN var= DOUBLE_QUOTED_STRING RPAREN WHERE constraint
                    {
                    LPAREN61=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_removeAction689); if (state.failed) return retval;
                    var=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_removeAction694); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    var_tree = (CommonTree)adaptor.create(var);
                    adaptor.addChild(root_0, var_tree);
                    }
                    RPAREN62=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_removeAction696); if (state.failed) return retval;
                    WHERE63=(Token)match(input,WHERE,FOLLOW_WHERE_in_removeAction699); if (state.failed) return retval;
                    pushFollow(FOLLOW_constraint_in_removeAction702);
                    constraint64=constraint();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, constraint64.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "removeAction"

    public static class removeFromCollectionAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "removeFromCollectionAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:196:1: removeFromCollectionAction : REMOVE source= modelReference FROM target= modelReference -> ^( VT_REMOVE_FROM_COLLECTION $source $target) ;
    public final NRLActionParser.removeFromCollectionAction_return removeFromCollectionAction() throws RecognitionException {
        NRLActionParser.removeFromCollectionAction_return retval = new NRLActionParser.removeFromCollectionAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token REMOVE65=null;
        Token FROM66=null;
        NRLActionParser_NRLConstraintRules.modelReference_return source = null;

        NRLActionParser_NRLConstraintRules.modelReference_return target = null;


        CommonTree REMOVE65_tree=null;
        CommonTree FROM66_tree=null;
        RewriteRuleTokenStream stream_FROM=new RewriteRuleTokenStream(adaptor,"token FROM");
        RewriteRuleTokenStream stream_REMOVE=new RewriteRuleTokenStream(adaptor,"token REMOVE");
        RewriteRuleSubtreeStream stream_modelReference=new RewriteRuleSubtreeStream(adaptor,"rule modelReference");
        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:198:3: ( REMOVE source= modelReference FROM target= modelReference -> ^( VT_REMOVE_FROM_COLLECTION $source $target) )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:198:5: REMOVE source= modelReference FROM target= modelReference
            {
            REMOVE65=(Token)match(input,REMOVE,FOLLOW_REMOVE_in_removeFromCollectionAction724); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_REMOVE.add(REMOVE65);

            pushFollow(FOLLOW_modelReference_in_removeFromCollectionAction728);
            source=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_modelReference.add(source.getTree());
            FROM66=(Token)match(input,FROM,FOLLOW_FROM_in_removeFromCollectionAction730); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_FROM.add(FROM66);

            pushFollow(FOLLOW_modelReference_in_removeFromCollectionAction734);
            target=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_modelReference.add(target.getTree());


            // AST REWRITE
            // elements: source, target
            // token labels: 
            // rule labels: retval, source, target
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_source=new RewriteRuleSubtreeStream(adaptor,"rule source",source!=null?source.tree:null);
            RewriteRuleSubtreeStream stream_target=new RewriteRuleSubtreeStream(adaptor,"rule target",target!=null?target.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 199:4: -> ^( VT_REMOVE_FROM_COLLECTION $source $target)
            {
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:199:7: ^( VT_REMOVE_FROM_COLLECTION $source $target)
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_REMOVE_FROM_COLLECTION, "VT_REMOVE_FROM_COLLECTION"), root_1);

                adaptor.addChild(root_1, stream_source.nextTree());
                adaptor.addChild(root_1, stream_target.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "removeFromCollectionAction"

    public static class setAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "setAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:202:1: setAction : SET modelReference TO expression ;
    public final NRLActionParser.setAction_return setAction() throws RecognitionException {
        NRLActionParser.setAction_return retval = new NRLActionParser.setAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token SET67=null;
        Token TO69=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference68 = null;

        NRLActionParser_NRLConstraintRules.expression_return expression70 = null;


        CommonTree SET67_tree=null;
        CommonTree TO69_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:203:3: ( SET modelReference TO expression )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:203:5: SET modelReference TO expression
            {
            root_0 = (CommonTree)adaptor.nil();

            SET67=(Token)match(input,SET,FOLLOW_SET_in_setAction764); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            SET67_tree = (CommonTree)adaptor.create(SET67);
            root_0 = (CommonTree)adaptor.becomeRoot(SET67_tree, root_0);
            }
            pushFollow(FOLLOW_modelReference_in_setAction767);
            modelReference68=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference68.getTree());
            TO69=(Token)match(input,TO,FOLLOW_TO_in_setAction769); if (state.failed) return retval;
            pushFollow(FOLLOW_expression_in_setAction772);
            expression70=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, expression70.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "setAction"

    public static class addAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "addAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:206:1: addAction : ADD_VERB modelReference TO modelReference ;
    public final NRLActionParser.addAction_return addAction() throws RecognitionException {
        NRLActionParser.addAction_return retval = new NRLActionParser.addAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token ADD_VERB71=null;
        Token TO73=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference72 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference74 = null;


        CommonTree ADD_VERB71_tree=null;
        CommonTree TO73_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:207:3: ( ADD_VERB modelReference TO modelReference )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:207:5: ADD_VERB modelReference TO modelReference
            {
            root_0 = (CommonTree)adaptor.nil();

            ADD_VERB71=(Token)match(input,ADD_VERB,FOLLOW_ADD_VERB_in_addAction787); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ADD_VERB71_tree = (CommonTree)adaptor.create(ADD_VERB71);
            root_0 = (CommonTree)adaptor.becomeRoot(ADD_VERB71_tree, root_0);
            }
            pushFollow(FOLLOW_modelReference_in_addAction790);
            modelReference72=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference72.getTree());
            TO73=(Token)match(input,TO,FOLLOW_TO_in_addAction792); if (state.failed) return retval;
            pushFollow(FOLLOW_modelReference_in_addAction795);
            modelReference74=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference74.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "addAction"

    public static class macroApplicationAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "macroApplicationAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:210:1: macroApplicationAction : id= PROPERTYNAME params= macroApplicationParams -> ^( VT_MACRO_APPLICATION $id $params) ;
    public final NRLActionParser.macroApplicationAction_return macroApplicationAction() throws RecognitionException {
        NRLActionParser.macroApplicationAction_return retval = new NRLActionParser.macroApplicationAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token id=null;
        NRLActionParser.macroApplicationParams_return params = null;


        CommonTree id_tree=null;
        RewriteRuleTokenStream stream_PROPERTYNAME=new RewriteRuleTokenStream(adaptor,"token PROPERTYNAME");
        RewriteRuleSubtreeStream stream_macroApplicationParams=new RewriteRuleSubtreeStream(adaptor,"rule macroApplicationParams");
        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:212:3: (id= PROPERTYNAME params= macroApplicationParams -> ^( VT_MACRO_APPLICATION $id $params) )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:212:5: id= PROPERTYNAME params= macroApplicationParams
            {
            id=(Token)match(input,PROPERTYNAME,FOLLOW_PROPERTYNAME_in_macroApplicationAction817); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_PROPERTYNAME.add(id);

            pushFollow(FOLLOW_macroApplicationParams_in_macroApplicationAction821);
            params=macroApplicationParams();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_macroApplicationParams.add(params.getTree());


            // AST REWRITE
            // elements: params, id
            // token labels: id
            // rule labels: retval, params
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleTokenStream stream_id=new RewriteRuleTokenStream(adaptor,"token id",id);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_params=new RewriteRuleSubtreeStream(adaptor,"rule params",params!=null?params.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 213:4: -> ^( VT_MACRO_APPLICATION $id $params)
            {
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:213:7: ^( VT_MACRO_APPLICATION $id $params)
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_MACRO_APPLICATION, "VT_MACRO_APPLICATION"), root_1);

                adaptor.addChild(root_1, stream_id.nextNode());
                adaptor.addChild(root_1, stream_params.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "macroApplicationAction"

    public static class macroApplicationParams_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "macroApplicationParams"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:216:1: macroApplicationParams : expression ( ( AND | FROM | TO | WITH | USING ) expression )* ;
    public final NRLActionParser.macroApplicationParams_return macroApplicationParams() throws RecognitionException {
        NRLActionParser.macroApplicationParams_return retval = new NRLActionParser.macroApplicationParams_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token AND76=null;
        Token FROM77=null;
        Token TO78=null;
        Token WITH79=null;
        Token USING80=null;
        NRLActionParser_NRLConstraintRules.expression_return expression75 = null;

        NRLActionParser_NRLConstraintRules.expression_return expression81 = null;


        CommonTree AND76_tree=null;
        CommonTree FROM77_tree=null;
        CommonTree TO78_tree=null;
        CommonTree WITH79_tree=null;
        CommonTree USING80_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:217:3: ( expression ( ( AND | FROM | TO | WITH | USING ) expression )* )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:217:5: expression ( ( AND | FROM | TO | WITH | USING ) expression )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_expression_in_macroApplicationParams851);
            expression75=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, expression75.getTree());
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:217:16: ( ( AND | FROM | TO | WITH | USING ) expression )*
            loop16:
            do {
                int alt16=2;
                switch ( input.LA(1) ) {
                case AND:
                case FROM:
                case TO:
                case WITH:
                case USING:
                    {
                    alt16=1;
                    }
                    break;

                }

                switch (alt16) {
            	case 1 :
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:217:18: ( AND | FROM | TO | WITH | USING ) expression
            	    {
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:217:18: ( AND | FROM | TO | WITH | USING )
            	    int alt15=5;
            	    switch ( input.LA(1) ) {
            	    case AND:
            	        {
            	        alt15=1;
            	        }
            	        break;
            	    case FROM:
            	        {
            	        alt15=2;
            	        }
            	        break;
            	    case TO:
            	        {
            	        alt15=3;
            	        }
            	        break;
            	    case WITH:
            	        {
            	        alt15=4;
            	        }
            	        break;
            	    case USING:
            	        {
            	        alt15=5;
            	        }
            	        break;
            	    default:
            	        if (state.backtracking>0) {state.failed=true; return retval;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 15, 0, input);

            	        throw nvae;
            	    }

            	    switch (alt15) {
            	        case 1 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:217:19: AND
            	            {
            	            AND76=(Token)match(input,AND,FOLLOW_AND_in_macroApplicationParams856); if (state.failed) return retval;

            	            }
            	            break;
            	        case 2 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:217:24: FROM
            	            {
            	            FROM77=(Token)match(input,FROM,FOLLOW_FROM_in_macroApplicationParams859); if (state.failed) return retval;

            	            }
            	            break;
            	        case 3 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:217:30: TO
            	            {
            	            TO78=(Token)match(input,TO,FOLLOW_TO_in_macroApplicationParams862); if (state.failed) return retval;

            	            }
            	            break;
            	        case 4 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:217:34: WITH
            	            {
            	            WITH79=(Token)match(input,WITH,FOLLOW_WITH_in_macroApplicationParams865); if (state.failed) return retval;

            	            }
            	            break;
            	        case 5 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:217:40: USING
            	            {
            	            USING80=(Token)match(input,USING,FOLLOW_USING_in_macroApplicationParams868); if (state.failed) return retval;

            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_expression_in_macroApplicationParams872);
            	    expression81=expression();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, expression81.getTree());

            	    }
            	    break;

            	default :
            	    break loop16;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "macroApplicationParams"

    public static class operatorAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "operatorAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:220:1: operatorAction : OPERATOR ( operatorActionParams )? -> ^( VT_OPERATOR_ACTION OPERATOR ( operatorActionParams )? ) ;
    public final NRLActionParser.operatorAction_return operatorAction() throws RecognitionException {
        NRLActionParser.operatorAction_return retval = new NRLActionParser.operatorAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token OPERATOR82=null;
        NRLActionParser.operatorActionParams_return operatorActionParams83 = null;


        CommonTree OPERATOR82_tree=null;
        RewriteRuleTokenStream stream_OPERATOR=new RewriteRuleTokenStream(adaptor,"token OPERATOR");
        RewriteRuleSubtreeStream stream_operatorActionParams=new RewriteRuleSubtreeStream(adaptor,"rule operatorActionParams");
        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:222:3: ( OPERATOR ( operatorActionParams )? -> ^( VT_OPERATOR_ACTION OPERATOR ( operatorActionParams )? ) )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:222:5: OPERATOR ( operatorActionParams )?
            {
            OPERATOR82=(Token)match(input,OPERATOR,FOLLOW_OPERATOR_in_operatorAction895); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_OPERATOR.add(OPERATOR82);

            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:222:14: ( operatorActionParams )?
            int alt17=2;
            alt17 = dfa17.predict(input);
            switch (alt17) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:222:14: operatorActionParams
                    {
                    pushFollow(FOLLOW_operatorActionParams_in_operatorAction897);
                    operatorActionParams83=operatorActionParams();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_operatorActionParams.add(operatorActionParams83.getTree());

                    }
                    break;

            }



            // AST REWRITE
            // elements: operatorActionParams, OPERATOR
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 223:4: -> ^( VT_OPERATOR_ACTION OPERATOR ( operatorActionParams )? )
            {
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:223:7: ^( VT_OPERATOR_ACTION OPERATOR ( operatorActionParams )? )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_OPERATOR_ACTION, "VT_OPERATOR_ACTION"), root_1);

                adaptor.addChild(root_1, stream_OPERATOR.nextNode());
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:223:37: ( operatorActionParams )?
                if ( stream_operatorActionParams.hasNext() ) {
                    adaptor.addChild(root_1, stream_operatorActionParams.nextTree());

                }
                stream_operatorActionParams.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "operatorAction"

    public static class operatorActionParams_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "operatorActionParams"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:226:1: operatorActionParams : expression ( ( AND | FROM | TO | WITH | USING ) expression )* ;
    public final NRLActionParser.operatorActionParams_return operatorActionParams() throws RecognitionException {
        NRLActionParser.operatorActionParams_return retval = new NRLActionParser.operatorActionParams_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token AND85=null;
        Token FROM86=null;
        Token TO87=null;
        Token WITH88=null;
        Token USING89=null;
        NRLActionParser_NRLConstraintRules.expression_return expression84 = null;

        NRLActionParser_NRLConstraintRules.expression_return expression90 = null;


        CommonTree AND85_tree=null;
        CommonTree FROM86_tree=null;
        CommonTree TO87_tree=null;
        CommonTree WITH88_tree=null;
        CommonTree USING89_tree=null;

        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:226:21: ( expression ( ( AND | FROM | TO | WITH | USING ) expression )* )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:227:4: expression ( ( AND | FROM | TO | WITH | USING ) expression )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_expression_in_operatorActionParams927);
            expression84=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, expression84.getTree());
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:227:15: ( ( AND | FROM | TO | WITH | USING ) expression )*
            loop19:
            do {
                int alt19=2;
                switch ( input.LA(1) ) {
                case AND:
                case FROM:
                case TO:
                case WITH:
                case USING:
                    {
                    alt19=1;
                    }
                    break;

                }

                switch (alt19) {
            	case 1 :
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:227:17: ( AND | FROM | TO | WITH | USING ) expression
            	    {
            	    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:227:17: ( AND | FROM | TO | WITH | USING )
            	    int alt18=5;
            	    switch ( input.LA(1) ) {
            	    case AND:
            	        {
            	        alt18=1;
            	        }
            	        break;
            	    case FROM:
            	        {
            	        alt18=2;
            	        }
            	        break;
            	    case TO:
            	        {
            	        alt18=3;
            	        }
            	        break;
            	    case WITH:
            	        {
            	        alt18=4;
            	        }
            	        break;
            	    case USING:
            	        {
            	        alt18=5;
            	        }
            	        break;
            	    default:
            	        if (state.backtracking>0) {state.failed=true; return retval;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 18, 0, input);

            	        throw nvae;
            	    }

            	    switch (alt18) {
            	        case 1 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:227:18: AND
            	            {
            	            AND85=(Token)match(input,AND,FOLLOW_AND_in_operatorActionParams932); if (state.failed) return retval;

            	            }
            	            break;
            	        case 2 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:227:23: FROM
            	            {
            	            FROM86=(Token)match(input,FROM,FOLLOW_FROM_in_operatorActionParams935); if (state.failed) return retval;

            	            }
            	            break;
            	        case 3 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:227:29: TO
            	            {
            	            TO87=(Token)match(input,TO,FOLLOW_TO_in_operatorActionParams938); if (state.failed) return retval;

            	            }
            	            break;
            	        case 4 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:227:33: WITH
            	            {
            	            WITH88=(Token)match(input,WITH,FOLLOW_WITH_in_operatorActionParams941); if (state.failed) return retval;

            	            }
            	            break;
            	        case 5 :
            	            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:227:39: USING
            	            {
            	            USING89=(Token)match(input,USING,FOLLOW_USING_in_operatorActionParams944); if (state.failed) return retval;

            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_expression_in_operatorActionParams948);
            	    expression90=expression();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, expression90.getTree());

            	    }
            	    break;

            	default :
            	    break loop19;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "operatorActionParams"

    public static class forEachAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "forEachAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:230:1: forEachAction : ( EACH ( OF )? modelReference ( COMMA )? action SEMI -> ^( VT_FOREACH_ACTION modelReference action ) | EACH var= DOUBLE_QUOTED_STRING ( IN_COLLECTION )? ( OF )? modelReference ( COMMA )? action SEMI -> ^( VT_FOREACH_ACTION $var modelReference action ) );
    public final NRLActionParser.forEachAction_return forEachAction() throws RecognitionException {
        NRLActionParser.forEachAction_return retval = new NRLActionParser.forEachAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token var=null;
        Token EACH91=null;
        Token OF92=null;
        Token COMMA94=null;
        Token SEMI96=null;
        Token EACH97=null;
        Token IN_COLLECTION98=null;
        Token OF99=null;
        Token COMMA101=null;
        Token SEMI103=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference93 = null;

        NRLActionParser.action_return action95 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference100 = null;

        NRLActionParser.action_return action102 = null;


        CommonTree var_tree=null;
        CommonTree EACH91_tree=null;
        CommonTree OF92_tree=null;
        CommonTree COMMA94_tree=null;
        CommonTree SEMI96_tree=null;
        CommonTree EACH97_tree=null;
        CommonTree IN_COLLECTION98_tree=null;
        CommonTree OF99_tree=null;
        CommonTree COMMA101_tree=null;
        CommonTree SEMI103_tree=null;
        RewriteRuleTokenStream stream_DOUBLE_QUOTED_STRING=new RewriteRuleTokenStream(adaptor,"token DOUBLE_QUOTED_STRING");
        RewriteRuleTokenStream stream_IN_COLLECTION=new RewriteRuleTokenStream(adaptor,"token IN_COLLECTION");
        RewriteRuleTokenStream stream_EACH=new RewriteRuleTokenStream(adaptor,"token EACH");
        RewriteRuleTokenStream stream_OF=new RewriteRuleTokenStream(adaptor,"token OF");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_SEMI=new RewriteRuleTokenStream(adaptor,"token SEMI");
        RewriteRuleSubtreeStream stream_action=new RewriteRuleSubtreeStream(adaptor,"rule action");
        RewriteRuleSubtreeStream stream_modelReference=new RewriteRuleSubtreeStream(adaptor,"rule modelReference");
        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:232:3: ( EACH ( OF )? modelReference ( COMMA )? action SEMI -> ^( VT_FOREACH_ACTION modelReference action ) | EACH var= DOUBLE_QUOTED_STRING ( IN_COLLECTION )? ( OF )? modelReference ( COMMA )? action SEMI -> ^( VT_FOREACH_ACTION $var modelReference action ) )
            int alt25=2;
            switch ( input.LA(1) ) {
            case EACH:
                {
                switch ( input.LA(2) ) {
                case DOUBLE_QUOTED_STRING:
                    {
                    alt25=2;
                    }
                    break;
                case OF:
                case IDENTIFIER:
                    {
                    alt25=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 25, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 25, 0, input);

                throw nvae;
            }

            switch (alt25) {
                case 1 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:232:5: EACH ( OF )? modelReference ( COMMA )? action SEMI
                    {
                    EACH91=(Token)match(input,EACH,FOLLOW_EACH_in_forEachAction972); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_EACH.add(EACH91);

                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:232:10: ( OF )?
                    int alt20=2;
                    switch ( input.LA(1) ) {
                        case OF:
                            {
                            alt20=1;
                            }
                            break;
                    }

                    switch (alt20) {
                        case 1 :
                            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:232:10: OF
                            {
                            OF92=(Token)match(input,OF,FOLLOW_OF_in_forEachAction974); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_OF.add(OF92);


                            }
                            break;

                    }

                    pushFollow(FOLLOW_modelReference_in_forEachAction977);
                    modelReference93=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_modelReference.add(modelReference93.getTree());
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:232:29: ( COMMA )?
                    int alt21=2;
                    switch ( input.LA(1) ) {
                        case COMMA:
                            {
                            alt21=1;
                            }
                            break;
                    }

                    switch (alt21) {
                        case 1 :
                            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:232:29: COMMA
                            {
                            COMMA94=(Token)match(input,COMMA,FOLLOW_COMMA_in_forEachAction979); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_COMMA.add(COMMA94);


                            }
                            break;

                    }

                    pushFollow(FOLLOW_action_in_forEachAction982);
                    action95=action();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_action.add(action95.getTree());
                    SEMI96=(Token)match(input,SEMI,FOLLOW_SEMI_in_forEachAction984); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_SEMI.add(SEMI96);



                    // AST REWRITE
                    // elements: modelReference, action
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 233:4: -> ^( VT_FOREACH_ACTION modelReference action )
                    {
                        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:233:7: ^( VT_FOREACH_ACTION modelReference action )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_FOREACH_ACTION, "VT_FOREACH_ACTION"), root_1);

                        adaptor.addChild(root_1, stream_modelReference.nextTree());
                        adaptor.addChild(root_1, stream_action.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:234:5: EACH var= DOUBLE_QUOTED_STRING ( IN_COLLECTION )? ( OF )? modelReference ( COMMA )? action SEMI
                    {
                    EACH97=(Token)match(input,EACH,FOLLOW_EACH_in_forEachAction1004); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_EACH.add(EACH97);

                    var=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_forEachAction1008); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_DOUBLE_QUOTED_STRING.add(var);

                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:234:35: ( IN_COLLECTION )?
                    int alt22=2;
                    switch ( input.LA(1) ) {
                        case IN_COLLECTION:
                            {
                            alt22=1;
                            }
                            break;
                    }

                    switch (alt22) {
                        case 1 :
                            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:234:35: IN_COLLECTION
                            {
                            IN_COLLECTION98=(Token)match(input,IN_COLLECTION,FOLLOW_IN_COLLECTION_in_forEachAction1010); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_IN_COLLECTION.add(IN_COLLECTION98);


                            }
                            break;

                    }

                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:234:50: ( OF )?
                    int alt23=2;
                    switch ( input.LA(1) ) {
                        case OF:
                            {
                            alt23=1;
                            }
                            break;
                    }

                    switch (alt23) {
                        case 1 :
                            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:234:50: OF
                            {
                            OF99=(Token)match(input,OF,FOLLOW_OF_in_forEachAction1013); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_OF.add(OF99);


                            }
                            break;

                    }

                    pushFollow(FOLLOW_modelReference_in_forEachAction1016);
                    modelReference100=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_modelReference.add(modelReference100.getTree());
                    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:234:69: ( COMMA )?
                    int alt24=2;
                    switch ( input.LA(1) ) {
                        case COMMA:
                            {
                            alt24=1;
                            }
                            break;
                    }

                    switch (alt24) {
                        case 1 :
                            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:234:69: COMMA
                            {
                            COMMA101=(Token)match(input,COMMA,FOLLOW_COMMA_in_forEachAction1018); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_COMMA.add(COMMA101);


                            }
                            break;

                    }

                    pushFollow(FOLLOW_action_in_forEachAction1021);
                    action102=action();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_action.add(action102.getTree());
                    SEMI103=(Token)match(input,SEMI,FOLLOW_SEMI_in_forEachAction1023); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_SEMI.add(SEMI103);



                    // AST REWRITE
                    // elements: var, modelReference, action
                    // token labels: var
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleTokenStream stream_var=new RewriteRuleTokenStream(adaptor,"token var",var);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 235:4: -> ^( VT_FOREACH_ACTION $var modelReference action )
                    {
                        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:235:7: ^( VT_FOREACH_ACTION $var modelReference action )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_FOREACH_ACTION, "VT_FOREACH_ACTION"), root_1);

                        adaptor.addChild(root_1, stream_var.nextNode());
                        adaptor.addChild(root_1, stream_modelReference.nextTree());
                        adaptor.addChild(root_1, stream_action.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "forEachAction"

    public static class variableDeclarationAction_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "variableDeclarationAction"
    // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:238:1: variableDeclarationAction : simpleVariableDeclaration -> ^( VT_VARIABLE_DECLARATION_ACTION simpleVariableDeclaration ) ;
    public final NRLActionParser.variableDeclarationAction_return variableDeclarationAction() throws RecognitionException {
        NRLActionParser.variableDeclarationAction_return retval = new NRLActionParser.variableDeclarationAction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser_NRLConstraintRules.simpleVariableDeclaration_return simpleVariableDeclaration104 = null;


        RewriteRuleSubtreeStream stream_simpleVariableDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule simpleVariableDeclaration");
        try {
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:240:3: ( simpleVariableDeclaration -> ^( VT_VARIABLE_DECLARATION_ACTION simpleVariableDeclaration ) )
            // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:240:5: simpleVariableDeclaration
            {
            pushFollow(FOLLOW_simpleVariableDeclaration_in_variableDeclarationAction1059);
            simpleVariableDeclaration104=simpleVariableDeclaration();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_simpleVariableDeclaration.add(simpleVariableDeclaration104.getTree());


            // AST REWRITE
            // elements: simpleVariableDeclaration
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 241:4: -> ^( VT_VARIABLE_DECLARATION_ACTION simpleVariableDeclaration )
            {
                // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:241:7: ^( VT_VARIABLE_DECLARATION_ACTION simpleVariableDeclaration )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_VARIABLE_DECLARATION_ACTION, "VT_VARIABLE_DECLARATION_ACTION"), root_1);

                adaptor.addChild(root_1, stream_simpleVariableDeclaration.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "variableDeclarationAction"

    // $ANTLR start synpred1_NRLActionParser
    public final void synpred1_NRLActionParser_fragment() throws RecognitionException {   
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:121:5: ( context VALIDATION_RULE )
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:121:6: context VALIDATION_RULE
        {
        pushFollow(FOLLOW_context_in_synpred1_NRLActionParser222);
        context();

        state._fsp--;
        if (state.failed) return ;
        match(input,VALIDATION_RULE,FOLLOW_VALIDATION_RULE_in_synpred1_NRLActionParser224); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred1_NRLActionParser

    // $ANTLR start synpred2_NRLActionParser
    public final void synpred2_NRLActionParser_fragment() throws RecognitionException {   
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:122:5: ( actionContext ACTION_RULE )
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:122:6: actionContext ACTION_RULE
        {
        pushFollow(FOLLOW_actionContext_in_synpred2_NRLActionParser236);
        actionContext();

        state._fsp--;
        if (state.failed) return ;
        match(input,ACTION_RULE,FOLLOW_ACTION_RULE_in_synpred2_NRLActionParser238); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred2_NRLActionParser

    // $ANTLR start synpred3_NRLActionParser
    public final void synpred3_NRLActionParser_fragment() throws RecognitionException {   
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:123:5: ( multipleContext ACTION_FRAGMENT )
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:123:6: multipleContext ACTION_FRAGMENT
        {
        pushFollow(FOLLOW_multipleContext_in_synpred3_NRLActionParser250);
        multipleContext();

        state._fsp--;
        if (state.failed) return ;
        match(input,ACTION_FRAGMENT,FOLLOW_ACTION_FRAGMENT_in_synpred3_NRLActionParser252); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred3_NRLActionParser

    // $ANTLR start synpred4_NRLActionParser
    public final void synpred4_NRLActionParser_fragment() throws RecognitionException {   
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:177:5: ( REMOVE modelReference FROM )
        // net\\sourceforge\\nrl\\parser\\ast\\impl\\NRLActionParser.g:177:6: REMOVE modelReference FROM
        {
        match(input,REMOVE,FOLLOW_REMOVE_in_synpred4_NRLActionParser564); if (state.failed) return ;
        pushFollow(FOLLOW_modelReference_in_synpred4_NRLActionParser566);
        modelReference();

        state._fsp--;
        if (state.failed) return ;
        match(input,FROM,FOLLOW_FROM_in_synpred4_NRLActionParser568); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred4_NRLActionParser

    // Delegated rules
    public NRLActionParser_NRLConstraintRules.validationRuleDeclaration_return validationRuleDeclaration() throws RecognitionException { return gNRLConstraintRules.validationRuleDeclaration(); }
    public NRLActionParser_NRLConstraintRules.andStatement_return andStatement() throws RecognitionException { return gNRLConstraintRules.andStatement(); }
    public NRLActionParser_NRLConstraintRules.infixPropertyApplication_return infixPropertyApplication() throws RecognitionException { return gNRLConstraintRules.infixPropertyApplication(); }
    public NRLActionParser_NRLConstraintRules.operatorInvocation_return operatorInvocation() throws RecognitionException { return gNRLConstraintRules.operatorInvocation(); }
    public NRLActionParser_NRLConstraintRules.statement_return statement() throws RecognitionException { return gNRLConstraintRules.statement(); }
    public NRLActionParser_NRLConstraintRules.addExpression_return addExpression() throws RecognitionException { return gNRLConstraintRules.addExpression(); }
    public NRLActionParser_NRLConstraintRules.existsStatement_return existsStatement() throws RecognitionException { return gNRLConstraintRules.existsStatement(); }
    public NRLActionParser_NRLConstraintRules.operatorParameterList_return operatorParameterList() throws RecognitionException { return gNRLConstraintRules.operatorParameterList(); }
    public NRLActionParser_NRLConstraintRules.simpleReport_return simpleReport() throws RecognitionException { return gNRLConstraintRules.simpleReport(); }
    public NRLActionParser_NRLConstraintRules.infixOperatorExpression_return infixOperatorExpression() throws RecognitionException { return gNRLConstraintRules.infixOperatorExpression(); }
    public NRLActionParser_NRLConstraintRules.globalVariableDeclaration_return globalVariableDeclaration() throws RecognitionException { return gNRLConstraintRules.globalVariableDeclaration(); }
    public NRLActionParser_NRLConstraintRules.orStatement_return orStatement() throws RecognitionException { return gNRLConstraintRules.orStatement(); }
    public NRLActionParser_NRLConstraintRules.concatenatedReportTerms_return concatenatedReportTerms() throws RecognitionException { return gNRLConstraintRules.concatenatedReportTerms(); }
    public NRLActionParser_NRLConstraintRules.constraint_return constraint() throws RecognitionException { return gNRLConstraintRules.constraint(); }
    public NRLActionParser_NRLConstraintRules.simpleOrComplexConstraint_return simpleOrComplexConstraint() throws RecognitionException { return gNRLConstraintRules.simpleOrComplexConstraint(); }
    public NRLActionParser_NRLConstraintRules.expression_return expression() throws RecognitionException { return gNRLConstraintRules.expression(); }
    public NRLActionParser_NRLConstraintRules.forallStart_return forallStart() throws RecognitionException { return gNRLConstraintRules.forallStart(); }
    public NRLActionParser_NRLConstraintRules.modelReference_return modelReference() throws RecognitionException { return gNRLConstraintRules.modelReference(); }
    public NRLActionParser_NRLConstraintRules.castExpression_return castExpression() throws RecognitionException { return gNRLConstraintRules.castExpression(); }
    public NRLActionParser_NRLConstraintRules.iffStatement_return iffStatement() throws RecognitionException { return gNRLConstraintRules.iffStatement(); }
    public NRLActionParser_NRLConstraintRules.simpleVariableDeclaration_return simpleVariableDeclaration() throws RecognitionException { return gNRLConstraintRules.simpleVariableDeclaration(); }
    public NRLActionParser_NRLConstraintRules.validationRuleVariableDeclaration_return validationRuleVariableDeclaration() throws RecognitionException { return gNRLConstraintRules.validationRuleVariableDeclaration(); }
    public NRLActionParser_NRLConstraintRules.term_return term() throws RecognitionException { return gNRLConstraintRules.term(); }
    public NRLActionParser_NRLConstraintRules.conditionalReport_return conditionalReport() throws RecognitionException { return gNRLConstraintRules.conditionalReport(); }
    public NRLActionParser_NRLConstraintRules.predicateStatement_return predicateStatement() throws RecognitionException { return gNRLConstraintRules.predicateStatement(); }
    public NRLActionParser_NRLConstraintRules.forallStatement_return forallStatement() throws RecognitionException { return gNRLConstraintRules.forallStatement(); }
    public NRLActionParser_NRLConstraintRules.collectionIndex_return collectionIndex() throws RecognitionException { return gNRLConstraintRules.collectionIndex(); }
    public NRLActionParser_NRLConstraintRules.selectionExpression_return selectionExpression() throws RecognitionException { return gNRLConstraintRules.selectionExpression(); }
    public NRLActionParser_NRLConstraintRules.compoundReport_return compoundReport() throws RecognitionException { return gNRLConstraintRules.compoundReport(); }
    public NRLActionParser_NRLConstraintRules.notExistsStatement_return notExistsStatement() throws RecognitionException { return gNRLConstraintRules.notExistsStatement(); }
    public NRLActionParser_NRLConstraintRules.concatenatedReport_return concatenatedReport() throws RecognitionException { return gNRLConstraintRules.concatenatedReport(); }
    public NRLActionParser_NRLConstraintRules.enumeratorStart_return enumeratorStart() throws RecognitionException { return gNRLConstraintRules.enumeratorStart(); }
    public NRLActionParser_NRLConstraintRules.multipleExistsStatement_return multipleExistsStatement() throws RecognitionException { return gNRLConstraintRules.multipleExistsStatement(); }
    public NRLActionParser_NRLConstraintRules.identifier_return identifier() throws RecognitionException { return gNRLConstraintRules.identifier(); }
    public NRLActionParser_NRLConstraintRules.validationFragmentDeclaration_return validationFragmentDeclaration() throws RecognitionException { return gNRLConstraintRules.validationFragmentDeclaration(); }
    public NRLActionParser_NRLConstraintRules.enumerator_return enumerator() throws RecognitionException { return gNRLConstraintRules.enumerator(); }
    public NRLActionParser_NRLConstraintRules.multipleContextEntry_return multipleContextEntry() throws RecognitionException { return gNRLConstraintRules.multipleContextEntry(); }
    public NRLActionParser_NRLConstraintRules.multiplyExpression_return multiplyExpression() throws RecognitionException { return gNRLConstraintRules.multiplyExpression(); }
    public NRLActionParser_NRLConstraintRules.globalExistsStatement_return globalExistsStatement() throws RecognitionException { return gNRLConstraintRules.globalExistsStatement(); }
    public NRLActionParser_NRLConstraintRules.identifierSequence_return identifierSequence() throws RecognitionException { return gNRLConstraintRules.identifierSequence(); }
    public NRLActionParser_NRLConstraintRules.context_return context() throws RecognitionException { return gNRLConstraintRules.context(); }
    public NRLActionParser_NRLConstraintRules.multipleContext_return multipleContext() throws RecognitionException { return gNRLConstraintRules.multipleContext(); }
    public NRLActionParser_NRLConstraintRules.ruleSetDeclaration_return ruleSetDeclaration() throws RecognitionException { return gNRLConstraintRules.ruleSetDeclaration(); }
    public NRLActionParser_NRLConstraintRules.multipleNotExistsStatement_return multipleNotExistsStatement() throws RecognitionException { return gNRLConstraintRules.multipleNotExistsStatement(); }
    public NRLActionParser_NRLConstraintRules.simpleReports_return simpleReports() throws RecognitionException { return gNRLConstraintRules.simpleReports(); }
    public NRLActionParser_NRLConstraintRules.number_return number() throws RecognitionException { return gNRLConstraintRules.number(); }
    public NRLActionParser_NRLConstraintRules.listDefinition_return listDefinition() throws RecognitionException { return gNRLConstraintRules.listDefinition(); }
    public NRLActionParser_NRLConstraintRules.simpleTerm_return simpleTerm() throws RecognitionException { return gNRLConstraintRules.simpleTerm(); }
    public NRLActionParser_NRLConstraintRules.isSubtypePredicate_return isSubtypePredicate() throws RecognitionException { return gNRLConstraintRules.isSubtypePredicate(); }
    public NRLActionParser_NRLConstraintRules.enumeratorDisambiguation_return enumeratorDisambiguation() throws RecognitionException { return gNRLConstraintRules.enumeratorDisambiguation(); }
    public NRLActionParser_NRLConstraintRules.constraintRuleReport_return constraintRuleReport() throws RecognitionException { return gNRLConstraintRules.constraintRuleReport(); }
    public NRLActionParser_NRLConstraintRules.modelReferenceList_return modelReferenceList() throws RecognitionException { return gNRLConstraintRules.modelReferenceList(); }
    public NRLActionParser_NRLConstraintRules.functionalExpression_return functionalExpression() throws RecognitionException { return gNRLConstraintRules.functionalExpression(); }
    public NRLActionParser_NRLConstraintRules.logicalStatement_return logicalStatement() throws RecognitionException { return gNRLConstraintRules.logicalStatement(); }
    public NRLActionParser_NRLConstraintRules.impliesStatement_return impliesStatement() throws RecognitionException { return gNRLConstraintRules.impliesStatement(); }
    public NRLActionParser_NRLConstraintRules.propertyApplication_return propertyApplication() throws RecognitionException { return gNRLConstraintRules.propertyApplication(); }

    public final boolean synpred2_NRLActionParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred2_NRLActionParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred1_NRLActionParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred1_NRLActionParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred3_NRLActionParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred3_NRLActionParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred4_NRLActionParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred4_NRLActionParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }


    protected DFA9 dfa9 = new DFA9(this);
    protected DFA10 dfa10 = new DFA10(this);
    protected DFA17 dfa17 = new DFA17(this);
    static final String DFA9_eotS =
        "\21\uffff";
    static final String DFA9_eofS =
        "\1\1\20\uffff";
    static final String DFA9_minS =
        "\1\25\20\uffff";
    static final String DFA9_maxS =
        "\1\152\20\uffff";
    static final String DFA9_acceptS =
        "\1\uffff\1\2\1\uffff\1\1\3\uffff\1\1\11\uffff";
    static final String DFA9_specialS =
        "\21\uffff}>";
    static final String[] DFA9_transitionS = {
            "\1\3\1\7\1\uffff\1\1\4\uffff\1\1\2\uffff\2\7\1\1\23\uffff\1"+
            "\7\21\uffff\2\7\20\uffff\1\1\13\uffff\1\7\1\uffff\3\7",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA9_eot = DFA.unpackEncodedString(DFA9_eotS);
    static final short[] DFA9_eof = DFA.unpackEncodedString(DFA9_eofS);
    static final char[] DFA9_min = DFA.unpackEncodedStringToUnsignedChars(DFA9_minS);
    static final char[] DFA9_max = DFA.unpackEncodedStringToUnsignedChars(DFA9_maxS);
    static final short[] DFA9_accept = DFA.unpackEncodedString(DFA9_acceptS);
    static final short[] DFA9_special = DFA.unpackEncodedString(DFA9_specialS);
    static final short[][] DFA9_transition;

    static {
        int numStates = DFA9_transitionS.length;
        DFA9_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA9_transition[i] = DFA.unpackEncodedString(DFA9_transitionS[i]);
        }
    }

    class DFA9 extends DFA {

        public DFA9(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 9;
            this.eot = DFA9_eot;
            this.eof = DFA9_eof;
            this.min = DFA9_min;
            this.max = DFA9_max;
            this.accept = DFA9_accept;
            this.special = DFA9_special;
            this.transition = DFA9_transition;
        }
        public String getDescription() {
            return "()* loopback of 172:18: ( ( COMMA )? ( THEN )? simpleAction )*";
        }
    }
    static final String DFA10_eotS =
        "\14\uffff";
    static final String DFA10_eofS =
        "\14\uffff";
    static final String DFA10_minS =
        "\1\25\1\uffff\1\0\11\uffff";
    static final String DFA10_maxS =
        "\1\152\1\uffff\1\0\11\uffff";
    static final String DFA10_acceptS =
        "\1\uffff\1\1\1\uffff\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\2\1\3";
    static final String DFA10_specialS =
        "\2\uffff\1\0\11\uffff}>";
    static final String[] DFA10_transitionS = {
            "\1\10\12\uffff\1\11\25\uffff\1\7\21\uffff\1\5\1\6\34\uffff"+
            "\1\1\1\uffff\1\2\1\3\1\4",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA10_eot = DFA.unpackEncodedString(DFA10_eotS);
    static final short[] DFA10_eof = DFA.unpackEncodedString(DFA10_eofS);
    static final char[] DFA10_min = DFA.unpackEncodedStringToUnsignedChars(DFA10_minS);
    static final char[] DFA10_max = DFA.unpackEncodedStringToUnsignedChars(DFA10_maxS);
    static final short[] DFA10_accept = DFA.unpackEncodedString(DFA10_acceptS);
    static final short[] DFA10_special = DFA.unpackEncodedString(DFA10_specialS);
    static final short[][] DFA10_transition;

    static {
        int numStates = DFA10_transitionS.length;
        DFA10_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA10_transition[i] = DFA.unpackEncodedString(DFA10_transitionS[i]);
        }
    }

    class DFA10 extends DFA {

        public DFA10(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 10;
            this.eot = DFA10_eot;
            this.eof = DFA10_eof;
            this.min = DFA10_min;
            this.max = DFA10_max;
            this.accept = DFA10_accept;
            this.special = DFA10_special;
            this.transition = DFA10_transition;
        }
        public String getDescription() {
            return "175:1: simpleAction : ( createAction | ( REMOVE modelReference FROM )=> removeFromCollectionAction | removeAction | setAction | addAction | operatorAction | macroApplicationAction | forEachAction | variableDeclarationAction | conditionalAction );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA10_2 = input.LA(1);

                         
                        int index10_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred4_NRLActionParser()) ) {s = 10;}

                        else if ( (true) ) {s = 11;}

                         
                        input.seek(index10_2);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 10, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA17_eotS =
        "\34\uffff";
    static final String DFA17_eofS =
        "\1\16\33\uffff";
    static final String DFA17_minS =
        "\1\25\33\uffff";
    static final String DFA17_maxS =
        "\1\152\33\uffff";
    static final String DFA17_acceptS =
        "\1\uffff\2\1\13\uffff\1\2\15\uffff";
    static final String DFA17_specialS =
        "\34\uffff}>";
    static final String[] DFA17_transitionS = {
            "\2\16\1\uffff\1\16\4\uffff\1\16\1\1\1\uffff\3\16\16\uffff\1"+
            "\1\4\uffff\1\16\15\uffff\1\1\3\uffff\1\1\1\2\4\uffff\2\1\3\uffff"+
            "\6\1\1\uffff\1\16\13\uffff\1\16\1\uffff\3\16",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA17_eot = DFA.unpackEncodedString(DFA17_eotS);
    static final short[] DFA17_eof = DFA.unpackEncodedString(DFA17_eofS);
    static final char[] DFA17_min = DFA.unpackEncodedStringToUnsignedChars(DFA17_minS);
    static final char[] DFA17_max = DFA.unpackEncodedStringToUnsignedChars(DFA17_maxS);
    static final short[] DFA17_accept = DFA.unpackEncodedString(DFA17_acceptS);
    static final short[] DFA17_special = DFA.unpackEncodedString(DFA17_specialS);
    static final short[][] DFA17_transition;

    static {
        int numStates = DFA17_transitionS.length;
        DFA17_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA17_transition[i] = DFA.unpackEncodedString(DFA17_transitionS[i]);
        }
    }

    class DFA17 extends DFA {

        public DFA17(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 17;
            this.eot = DFA17_eot;
            this.eof = DFA17_eof;
            this.min = DFA17_min;
            this.max = DFA17_max;
            this.accept = DFA17_accept;
            this.special = DFA17_special;
            this.transition = DFA17_transition;
        }
        public String getDescription() {
            return "222:14: ( operatorActionParams )?";
        }
    }
 

    public static final BitSet FOLLOW_modelFileReferences_in_fileBody96 = new BitSet(new long[]{0x0000000021200000L,0x0000000800000000L});
    public static final BitSet FOLLOW_operatorFileReferences_in_fileBody98 = new BitSet(new long[]{0x0000000021200000L});
    public static final BitSet FOLLOW_declarations_in_fileBody100 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_fileBody102 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modelFileReference_in_modelFileReferences135 = new BitSet(new long[]{0x0000000000000002L,0x0000000400000000L});
    public static final BitSet FOLLOW_MODEL_in_modelFileReference150 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_modelFileReference153 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_operatorFileReference_in_operatorFileReferences169 = new BitSet(new long[]{0x0000000000000002L,0x0000000800000000L});
    public static final BitSet FOLLOW_OPERATORS_in_operatorFileReference184 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_operatorFileReference187 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_declaration_in_declarations205 = new BitSet(new long[]{0x0000000021200002L});
    public static final BitSet FOLLOW_validationRuleDeclaration_in_declaration229 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionRuleDeclaration_in_declaration243 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionFragmentDeclaration_in_declaration257 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_globalVariableDeclaration_in_declaration263 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleSetDeclaration_in_declaration269 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_validationFragmentDeclaration_in_declaration275 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionContext_in_actionRuleDeclaration292 = new BitSet(new long[]{0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_ACTION_RULE_in_actionRuleDeclaration294 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_actionRuleDeclaration297 = new BitSet(new long[]{0x0040000100200000L,0x0000074000000300L});
    public static final BitSet FOLLOW_action_in_actionRuleDeclaration299 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_multipleContext_in_actionFragmentDeclaration314 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_ACTION_FRAGMENT_in_actionFragmentDeclaration316 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_actionFragmentDeclaration319 = new BitSet(new long[]{0x0040000100200000L,0x0000074000000300L});
    public static final BitSet FOLLOW_action_in_actionFragmentDeclaration321 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CONTEXT_in_actionContext334 = new BitSet(new long[]{0x0000000000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_actionContext337 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CONTEXT_in_actionContext343 = new BitSet(new long[]{0x0004000000000000L});
    public static final BitSet FOLLOW_NO_in_actionContext346 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_action_in_singleActionAndEOF360 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_singleActionAndEOF362 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_compoundAction_in_action378 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IF_in_conditionalAction398 = new BitSet(new long[]{0x0057FE0140000000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_statement_in_conditionalAction402 = new BitSet(new long[]{0x0000000200000000L});
    public static final BitSet FOLLOW_THEN_in_conditionalAction404 = new BitSet(new long[]{0x0040000100200000L,0x0000074000000300L});
    public static final BitSet FOLLOW_action_in_conditionalAction408 = new BitSet(new long[]{0x0000000400000000L,0x0000000004000000L});
    public static final BitSet FOLLOW_ELSE_in_conditionalAction445 = new BitSet(new long[]{0x0040000100200000L,0x0000074000000300L});
    public static final BitSet FOLLOW_action_in_conditionalAction449 = new BitSet(new long[]{0x0000000000000000L,0x0000000004000000L});
    public static final BitSet FOLLOW_SEMI_in_conditionalAction460 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleActionList_in_compoundAction497 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleAction_in_simpleActionList523 = new BitSet(new long[]{0x0040000300600002L,0x0000074000000300L});
    public static final BitSet FOLLOW_COMMA_in_simpleActionList528 = new BitSet(new long[]{0x0040000300200000L,0x0000074000000300L});
    public static final BitSet FOLLOW_THEN_in_simpleActionList534 = new BitSet(new long[]{0x0040000100200000L,0x0000074000000300L});
    public static final BitSet FOLLOW_simpleAction_in_simpleActionList539 = new BitSet(new long[]{0x0040000300600002L,0x0000074000000300L});
    public static final BitSet FOLLOW_createAction_in_simpleAction557 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_removeFromCollectionAction_in_simpleAction573 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_removeAction_in_simpleAction579 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_setAction_in_simpleAction585 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_addAction_in_simpleAction591 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_operatorAction_in_simpleAction597 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_macroApplicationAction_in_simpleAction603 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_forEachAction_in_simpleAction609 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variableDeclarationAction_in_simpleAction615 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionalAction_in_simpleAction621 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CREATE_in_createAction637 = new BitSet(new long[]{0x0000000000000000L,0x0000008000000000L});
    public static final BitSet FOLLOW_NEW_in_createAction640 = new BitSet(new long[]{0x0000000000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_createAction643 = new BitSet(new long[]{0x0000000040000002L});
    public static final BitSet FOLLOW_LPAREN_in_createAction646 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_createAction651 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_RPAREN_in_createAction653 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REMOVE_in_removeAction671 = new BitSet(new long[]{0x0040008000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_EACH_in_removeAction675 = new BitSet(new long[]{0x0000008000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_OF_in_removeAction681 = new BitSet(new long[]{0x0000000000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_removeAction686 = new BitSet(new long[]{0x0000000040000002L});
    public static final BitSet FOLLOW_LPAREN_in_removeAction689 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_removeAction694 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_RPAREN_in_removeAction696 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_WHERE_in_removeAction699 = new BitSet(new long[]{0x0057FE0140000000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_constraint_in_removeAction702 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REMOVE_in_removeFromCollectionAction724 = new BitSet(new long[]{0x0000000000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_removeFromCollectionAction728 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_FROM_in_removeFromCollectionAction730 = new BitSet(new long[]{0x0000000000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_removeFromCollectionAction734 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SET_in_setAction764 = new BitSet(new long[]{0x0000000000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_setAction767 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_TO_in_setAction769 = new BitSet(new long[]{0x0002000040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_expression_in_setAction772 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ADD_VERB_in_addAction787 = new BitSet(new long[]{0x0000000000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_addAction790 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_TO_in_addAction792 = new BitSet(new long[]{0x0000000000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_addAction795 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PROPERTYNAME_in_macroApplicationAction817 = new BitSet(new long[]{0x0002000040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_macroApplicationParams_in_macroApplicationAction821 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_macroApplicationParams851 = new BitSet(new long[]{0x0000004000000002L,0x0000000000003C00L});
    public static final BitSet FOLLOW_AND_in_macroApplicationParams856 = new BitSet(new long[]{0x0002000040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_FROM_in_macroApplicationParams859 = new BitSet(new long[]{0x0002000040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_TO_in_macroApplicationParams862 = new BitSet(new long[]{0x0002000040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_WITH_in_macroApplicationParams865 = new BitSet(new long[]{0x0002000040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_USING_in_macroApplicationParams868 = new BitSet(new long[]{0x0002000040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_expression_in_macroApplicationParams872 = new BitSet(new long[]{0x0000004000000002L,0x0000000000003C00L});
    public static final BitSet FOLLOW_OPERATOR_in_operatorAction895 = new BitSet(new long[]{0x0002000040000002L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_operatorActionParams_in_operatorAction897 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_operatorActionParams927 = new BitSet(new long[]{0x0000004000000002L,0x0000000000003C00L});
    public static final BitSet FOLLOW_AND_in_operatorActionParams932 = new BitSet(new long[]{0x0002000040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_FROM_in_operatorActionParams935 = new BitSet(new long[]{0x0002000040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_TO_in_operatorActionParams938 = new BitSet(new long[]{0x0002000040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_WITH_in_operatorActionParams941 = new BitSet(new long[]{0x0002000040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_USING_in_operatorActionParams944 = new BitSet(new long[]{0x0002000040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_expression_in_operatorActionParams948 = new BitSet(new long[]{0x0000004000000002L,0x0000000000003C00L});
    public static final BitSet FOLLOW_EACH_in_forEachAction972 = new BitSet(new long[]{0x0000008000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_OF_in_forEachAction974 = new BitSet(new long[]{0x0000000000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_forEachAction977 = new BitSet(new long[]{0x0040000100600000L,0x0000074000000300L});
    public static final BitSet FOLLOW_COMMA_in_forEachAction979 = new BitSet(new long[]{0x0040000100200000L,0x0000074000000300L});
    public static final BitSet FOLLOW_action_in_forEachAction982 = new BitSet(new long[]{0x0000000000000000L,0x0000000004000000L});
    public static final BitSet FOLLOW_SEMI_in_forEachAction984 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EACH_in_forEachAction1004 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_forEachAction1008 = new BitSet(new long[]{0x0080008000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_IN_COLLECTION_in_forEachAction1010 = new BitSet(new long[]{0x0000008000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_OF_in_forEachAction1013 = new BitSet(new long[]{0x0000000000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_forEachAction1016 = new BitSet(new long[]{0x0040000100600000L,0x0000074000000300L});
    public static final BitSet FOLLOW_COMMA_in_forEachAction1018 = new BitSet(new long[]{0x0040000100200000L,0x0000074000000300L});
    public static final BitSet FOLLOW_action_in_forEachAction1021 = new BitSet(new long[]{0x0000000000000000L,0x0000000004000000L});
    public static final BitSet FOLLOW_SEMI_in_forEachAction1023 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleVariableDeclaration_in_variableDeclarationAction1059 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_context_in_synpred1_NRLActionParser222 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_VALIDATION_RULE_in_synpred1_NRLActionParser224 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionContext_in_synpred2_NRLActionParser236 = new BitSet(new long[]{0x0000000000000000L,0x0000001000000000L});
    public static final BitSet FOLLOW_ACTION_RULE_in_synpred2_NRLActionParser238 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_multipleContext_in_synpred3_NRLActionParser250 = new BitSet(new long[]{0x0000000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_ACTION_FRAGMENT_in_synpred3_NRLActionParser252 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REMOVE_in_synpred4_NRLActionParser564 = new BitSet(new long[]{0x0000000000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_synpred4_NRLActionParser566 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_FROM_in_synpred4_NRLActionParser568 = new BitSet(new long[]{0x0000000000000002L});

}