// $ANTLR 3.3 Nov 30, 2010 12:46:29 NRLConstraintRules.g 2011-08-15 17:24:57

/*
 * The contents of this file are subject to the Mozilla Public License 
 * Version 1.1 (the "License"); you may not use this file except in 
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" 
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific language governing rights and limitations 
 * under the License.
 * 
 * The Original Code is the NRL Parser, released 28 April 2006, 
 * Copyright (c) Christian Nentwich. The Initial Developer of the 
 * Original Code is Christian Nentwich. Portions created by contributors 
 * identified in the NOTICES file are Copyright (c) the contributors. 
 * All Rights Reserved. 
 */
package net.sourceforge.nrl.parser.ast.impl;
	
import net.sourceforge.nrl.parser.ast.constraints.IArithmeticExpression;
import net.sourceforge.nrl.parser.ast.constraints.IExpression;
import net.sourceforge.nrl.parser.IStatusCode;
import net.sourceforge.nrl.parser.SyntaxError;
import net.sourceforge.nrl.parser.NRLError;
import net.sourceforge.nrl.parser.ast.constraints.impl.VariableDeclarationImpl;	
import net.sourceforge.nrl.parser.ast.constraints.impl.ModelReferenceImpl;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

import org.antlr.runtime.tree.*;

public class NRLActionParser_NRLConstraintRules extends Parser {
    public static final int EOF=-1;
    public static final int VT_COMPOUND_REPORT=4;
    public static final int VT_CONCATENATED_REPORT=5;
    public static final int VT_CONDITIONAL_REPORT=6;
    public static final int VT_MULTIPLE_CONTEXTENTRY=7;
    public static final int VT_ENUMERATOR=8;
    public static final int VT_EXISTS=9;
    public static final int VT_FIRST_ORDINAL_NUMBER=10;
    public static final int VT_MODELREFERENCE=11;
    public static final int VT_MULTIPLE_EXISTS=12;
    public static final int VT_MULTIPLE_NOTEXISTS=13;
    public static final int VT_NEGATE_DECIMAL=14;
    public static final int VT_NEGATE_INTEGER=15;
    public static final int VT_RULEFILE=16;
    public static final int VT_SELECTION_EXPR=17;
    public static final int VT_SINGLE_SELECTION_EXPR=18;
    public static final int VT_VARIABLE_DECLARATION=19;
    public static final int VALIDATION_RULE=20;
    public static final int DOUBLE_QUOTED_STRING=21;
    public static final int COMMA=22;
    public static final int VALIDATION_FRAGMENT=23;
    public static final int RULESET=24;
    public static final int APPLIES_TO=25;
    public static final int WHERE=26;
    public static final int REPRESENT=27;
    public static final int HASHAVE=28;
    public static final int CONTEXT=29;
    public static final int LPAREN=30;
    public static final int RPAREN=31;
    public static final int IF=32;
    public static final int THEN=33;
    public static final int ELSE=34;
    public static final int IFF=35;
    public static final int IMPLIES=36;
    public static final int OR=37;
    public static final int AND=38;
    public static final int OF=39;
    public static final int THAT=40;
    public static final int IN=41;
    public static final int EXACTLY=42;
    public static final int AT_LEAST=43;
    public static final int AT_MOST=44;
    public static final int ONE=45;
    public static final int TWO=46;
    public static final int THREE=47;
    public static final int FOUR=48;
    public static final int INTEGER_NUMBER=49;
    public static final int NO=50;
    public static final int PRESENT=51;
    public static final int THERE_IS=52;
    public static final int NOT_PRESENT=53;
    public static final int EACH=54;
    public static final int IN_COLLECTION=55;
    public static final int IS_IN=56;
    public static final int IS_NOT_IN=57;
    public static final int EQUALS=58;
    public static final int NOT_EQUALS=59;
    public static final int LESS=60;
    public static final int LESS_EQ=61;
    public static final int GREATER=62;
    public static final int GREATER_EQ=63;
    public static final int KIND_OF=64;
    public static final int FOLLOWING=65;
    public static final int COLON=66;
    public static final int ADD=67;
    public static final int MINUS=68;
    public static final int TIMES=69;
    public static final int DIV=70;
    public static final int MOD=71;
    public static final int OPERATOR=72;
    public static final int PROPERTYNAME=73;
    public static final int FROM=74;
    public static final int TO=75;
    public static final int WITH=76;
    public static final int USING=77;
    public static final int SUM_OF=78;
    public static final int NUMBER_OF=79;
    public static final int UNIQUE=80;
    public static final int BY=81;
    public static final int AS_A=82;
    public static final int FIRST=83;
    public static final int SINGLE_QUOTED_STRING=84;
    public static final int BOOLEAN=85;
    public static final int DECIMAL_NUMBER=86;
    public static final int ORDINAL_NUMBER=87;
    public static final int IDENTIFIER=88;
    public static final int REPORT=89;
    public static final int SEMI=90;
    public static final int VT_CONDITIONAL_ACTION=91;
    public static final int VT_COMPOUND_ACTION=92;
    public static final int VT_FOREACH_ACTION=93;
    public static final int VT_MACRO_APPLICATION=94;
    public static final int VT_OPERATOR_ACTION=95;
    public static final int VT_REMOVE_FROM_COLLECTION=96;
    public static final int VT_VARIABLE_DECLARATION_ACTION=97;
    public static final int MODEL=98;
    public static final int OPERATORS=99;
    public static final int ACTION_RULE=100;
    public static final int ACTION_FRAGMENT=101;
    public static final int CREATE=102;
    public static final int NEW=103;
    public static final int REMOVE=104;
    public static final int SET=105;
    public static final int ADD_VERB=106;

    // delegates
    // delegators
    public NRLActionParser gNRLActionParser;
    public NRLActionParser gParent;


        public NRLActionParser_NRLConstraintRules(TokenStream input, NRLActionParser gNRLActionParser) {
            this(input, new RecognizerSharedState(), gNRLActionParser);
        }
        public NRLActionParser_NRLConstraintRules(TokenStream input, RecognizerSharedState state, NRLActionParser gNRLActionParser) {
            super(input, state);
            this.gNRLActionParser = gNRLActionParser;
             
            gParent = gNRLActionParser;
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return NRLActionParser.tokenNames; }
    public String getGrammarFileName() { return "NRLConstraintRules.g"; }


    	private java.util.List<NRLError> syntaxErrors = new java.util.ArrayList<NRLError>();
    	
    	public java.util.List<NRLError> getSyntaxErrors() {
    		return syntaxErrors;
    	}
    	
    	public boolean hasErrors() {
    		return !syntaxErrors.isEmpty();
    	}
    	
    	
    	public void resetErrors() {
    		syntaxErrors.clear();
    	}
    	
    	public void displayRecognitionError(String[] tokenNames, RecognitionException e) {
            String msg = getErrorMessage(e, tokenNames);
    	
    		// Fix for EOF tokens: ANTLR always reports these at line -1, which causes problems.
    		// Take the position of the second-to-last token instead.
    		if (e.token.getType() == Token.EOF && getTokenStream().size() > 0) {
    			Token last = getTokenStream().get(getTokenStream().size() - 1);
    			syntaxErrors.add(new SyntaxError(IStatusCode.PARSER_ERROR, last.getLine(), last
    					.getCharPositionInLine()
    					+ last.getText().length(), msg));
    		} else {
    			syntaxErrors.add(new SyntaxError(IStatusCode.PARSER_ERROR, e.line,
    					e.charPositionInLine, msg));
    		}
    	}
    	
    	public void initialisePositionFromChild(Object obj, int index) {
    		if (obj instanceof Antlr3NRLBaseAst)
    			((Antlr3NRLBaseAst) obj).initialisePositionFromChild(index);
    	}
    	
    	private void validateChildType(Tree tree, Class<?> clazz) throws RecognitionException {
    		for (int i = 0; i < tree.getChildCount(); i++) {
    			Object obj = tree.getChild(i);
    			if (obj != null && !clazz.isAssignableFrom(obj.getClass()))
    				throw new FailedPredicateException(input, "Invalid child", "");
    		}		
    	}


    public static class validationRuleDeclaration_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "validationRuleDeclaration"
    // NRLConstraintRules.g:104:1: validationRuleDeclaration : context VALIDATION_RULE DOUBLE_QUOTED_STRING ( validationRuleVariableDeclaration )* constraint ( constraintRuleReport )? ;
    public final NRLActionParser_NRLConstraintRules.validationRuleDeclaration_return validationRuleDeclaration() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.validationRuleDeclaration_return retval = new NRLActionParser_NRLConstraintRules.validationRuleDeclaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token VALIDATION_RULE2=null;
        Token DOUBLE_QUOTED_STRING3=null;
        NRLActionParser_NRLConstraintRules.context_return context1 = null;

        NRLActionParser_NRLConstraintRules.validationRuleVariableDeclaration_return validationRuleVariableDeclaration4 = null;

        NRLActionParser_NRLConstraintRules.constraint_return constraint5 = null;

        NRLActionParser_NRLConstraintRules.constraintRuleReport_return constraintRuleReport6 = null;


        CommonTree VALIDATION_RULE2_tree=null;
        CommonTree DOUBLE_QUOTED_STRING3_tree=null;

        try {
            // NRLConstraintRules.g:105:3: ( context VALIDATION_RULE DOUBLE_QUOTED_STRING ( validationRuleVariableDeclaration )* constraint ( constraintRuleReport )? )
            // NRLConstraintRules.g:105:5: context VALIDATION_RULE DOUBLE_QUOTED_STRING ( validationRuleVariableDeclaration )* constraint ( constraintRuleReport )?
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_context_in_validationRuleDeclaration165);
            context1=context();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, context1.getTree());
            VALIDATION_RULE2=(Token)match(input,VALIDATION_RULE,FOLLOW_VALIDATION_RULE_in_validationRuleDeclaration167); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            VALIDATION_RULE2_tree = (CommonTree)adaptor.create(VALIDATION_RULE2);
            root_0 = (CommonTree)adaptor.becomeRoot(VALIDATION_RULE2_tree, root_0);
            }
            DOUBLE_QUOTED_STRING3=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_validationRuleDeclaration170); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOUBLE_QUOTED_STRING3_tree = (CommonTree)adaptor.create(DOUBLE_QUOTED_STRING3);
            adaptor.addChild(root_0, DOUBLE_QUOTED_STRING3_tree);
            }
            // NRLConstraintRules.g:105:51: ( validationRuleVariableDeclaration )*
            loop2:
            do {
                int alt2=2;
                switch ( input.LA(1) ) {
                case DOUBLE_QUOTED_STRING:
                    {
                    alt2=1;
                    }
                    break;

                }

                switch (alt2) {
            	case 1 :
            	    // NRLConstraintRules.g:105:51: validationRuleVariableDeclaration
            	    {
            	    pushFollow(FOLLOW_validationRuleVariableDeclaration_in_validationRuleDeclaration172);
            	    validationRuleVariableDeclaration4=validationRuleVariableDeclaration();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, validationRuleVariableDeclaration4.getTree());

            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

            pushFollow(FOLLOW_constraint_in_validationRuleDeclaration175);
            constraint5=constraint();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, constraint5.getTree());
            // NRLConstraintRules.g:105:97: ( constraintRuleReport )?
            int alt3=2;
            switch ( input.LA(1) ) {
                case REPORT:
                    {
                    alt3=1;
                    }
                    break;
            }

            switch (alt3) {
                case 1 :
                    // NRLConstraintRules.g:105:99: constraintRuleReport
                    {
                    pushFollow(FOLLOW_constraintRuleReport_in_validationRuleDeclaration179);
                    constraintRuleReport6=constraintRuleReport();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, constraintRuleReport6.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "validationRuleDeclaration"

    public static class validationRuleVariableDeclaration_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "validationRuleVariableDeclaration"
    // NRLConstraintRules.g:108:1: validationRuleVariableDeclaration : simpleVariableDeclaration ( COMMA )? -> ^( VT_VARIABLE_DECLARATION simpleVariableDeclaration ) ;
    public final NRLActionParser_NRLConstraintRules.validationRuleVariableDeclaration_return validationRuleVariableDeclaration() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.validationRuleVariableDeclaration_return retval = new NRLActionParser_NRLConstraintRules.validationRuleVariableDeclaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token COMMA8=null;
        NRLActionParser_NRLConstraintRules.simpleVariableDeclaration_return simpleVariableDeclaration7 = null;


        CommonTree COMMA8_tree=null;
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_simpleVariableDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule simpleVariableDeclaration");
        try {
            // NRLConstraintRules.g:110:3: ( simpleVariableDeclaration ( COMMA )? -> ^( VT_VARIABLE_DECLARATION simpleVariableDeclaration ) )
            // NRLConstraintRules.g:110:5: simpleVariableDeclaration ( COMMA )?
            {
            pushFollow(FOLLOW_simpleVariableDeclaration_in_validationRuleVariableDeclaration202);
            simpleVariableDeclaration7=simpleVariableDeclaration();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_simpleVariableDeclaration.add(simpleVariableDeclaration7.getTree());
            // NRLConstraintRules.g:110:31: ( COMMA )?
            int alt4=2;
            switch ( input.LA(1) ) {
                case COMMA:
                    {
                    alt4=1;
                    }
                    break;
            }

            switch (alt4) {
                case 1 :
                    // NRLConstraintRules.g:110:31: COMMA
                    {
                    COMMA8=(Token)match(input,COMMA,FOLLOW_COMMA_in_validationRuleVariableDeclaration204); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_COMMA.add(COMMA8);


                    }
                    break;

            }



            // AST REWRITE
            // elements: simpleVariableDeclaration
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 111:4: -> ^( VT_VARIABLE_DECLARATION simpleVariableDeclaration )
            {
                // NRLConstraintRules.g:111:7: ^( VT_VARIABLE_DECLARATION simpleVariableDeclaration )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_VARIABLE_DECLARATION, "VT_VARIABLE_DECLARATION"), root_1);

                adaptor.addChild(root_1, stream_simpleVariableDeclaration.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "validationRuleVariableDeclaration"

    public static class validationFragmentDeclaration_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "validationFragmentDeclaration"
    // NRLConstraintRules.g:114:1: validationFragmentDeclaration : multipleContext VALIDATION_FRAGMENT DOUBLE_QUOTED_STRING constraint ;
    public final NRLActionParser_NRLConstraintRules.validationFragmentDeclaration_return validationFragmentDeclaration() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.validationFragmentDeclaration_return retval = new NRLActionParser_NRLConstraintRules.validationFragmentDeclaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token VALIDATION_FRAGMENT10=null;
        Token DOUBLE_QUOTED_STRING11=null;
        NRLActionParser_NRLConstraintRules.multipleContext_return multipleContext9 = null;

        NRLActionParser_NRLConstraintRules.constraint_return constraint12 = null;


        CommonTree VALIDATION_FRAGMENT10_tree=null;
        CommonTree DOUBLE_QUOTED_STRING11_tree=null;

        try {
            // NRLConstraintRules.g:115:3: ( multipleContext VALIDATION_FRAGMENT DOUBLE_QUOTED_STRING constraint )
            // NRLConstraintRules.g:115:5: multipleContext VALIDATION_FRAGMENT DOUBLE_QUOTED_STRING constraint
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_multipleContext_in_validationFragmentDeclaration233);
            multipleContext9=multipleContext();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, multipleContext9.getTree());
            VALIDATION_FRAGMENT10=(Token)match(input,VALIDATION_FRAGMENT,FOLLOW_VALIDATION_FRAGMENT_in_validationFragmentDeclaration235); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            VALIDATION_FRAGMENT10_tree = (CommonTree)adaptor.create(VALIDATION_FRAGMENT10);
            root_0 = (CommonTree)adaptor.becomeRoot(VALIDATION_FRAGMENT10_tree, root_0);
            }
            DOUBLE_QUOTED_STRING11=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_validationFragmentDeclaration238); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOUBLE_QUOTED_STRING11_tree = (CommonTree)adaptor.create(DOUBLE_QUOTED_STRING11);
            adaptor.addChild(root_0, DOUBLE_QUOTED_STRING11_tree);
            }
            pushFollow(FOLLOW_constraint_in_validationFragmentDeclaration240);
            constraint12=constraint();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, constraint12.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "validationFragmentDeclaration"

    public static class ruleSetDeclaration_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "ruleSetDeclaration"
    // NRLConstraintRules.g:118:1: ruleSetDeclaration : RULESET DOUBLE_QUOTED_STRING ( APPLIES_TO modelReference WHERE constraint )? ;
    public final NRLActionParser_NRLConstraintRules.ruleSetDeclaration_return ruleSetDeclaration() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.ruleSetDeclaration_return retval = new NRLActionParser_NRLConstraintRules.ruleSetDeclaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token RULESET13=null;
        Token DOUBLE_QUOTED_STRING14=null;
        Token APPLIES_TO15=null;
        Token WHERE17=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference16 = null;

        NRLActionParser_NRLConstraintRules.constraint_return constraint18 = null;


        CommonTree RULESET13_tree=null;
        CommonTree DOUBLE_QUOTED_STRING14_tree=null;
        CommonTree APPLIES_TO15_tree=null;
        CommonTree WHERE17_tree=null;

        try {
            // NRLConstraintRules.g:119:3: ( RULESET DOUBLE_QUOTED_STRING ( APPLIES_TO modelReference WHERE constraint )? )
            // NRLConstraintRules.g:119:5: RULESET DOUBLE_QUOTED_STRING ( APPLIES_TO modelReference WHERE constraint )?
            {
            root_0 = (CommonTree)adaptor.nil();

            RULESET13=(Token)match(input,RULESET,FOLLOW_RULESET_in_ruleSetDeclaration255); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RULESET13_tree = (CommonTree)adaptor.create(RULESET13);
            root_0 = (CommonTree)adaptor.becomeRoot(RULESET13_tree, root_0);
            }
            DOUBLE_QUOTED_STRING14=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_ruleSetDeclaration258); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOUBLE_QUOTED_STRING14_tree = (CommonTree)adaptor.create(DOUBLE_QUOTED_STRING14);
            adaptor.addChild(root_0, DOUBLE_QUOTED_STRING14_tree);
            }
            // NRLConstraintRules.g:120:4: ( APPLIES_TO modelReference WHERE constraint )?
            int alt5=2;
            switch ( input.LA(1) ) {
                case APPLIES_TO:
                    {
                    alt5=1;
                    }
                    break;
            }

            switch (alt5) {
                case 1 :
                    // NRLConstraintRules.g:121:5: APPLIES_TO modelReference WHERE constraint
                    {
                    APPLIES_TO15=(Token)match(input,APPLIES_TO,FOLLOW_APPLIES_TO_in_ruleSetDeclaration270); if (state.failed) return retval;
                    pushFollow(FOLLOW_modelReference_in_ruleSetDeclaration273);
                    modelReference16=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference16.getTree());
                    WHERE17=(Token)match(input,WHERE,FOLLOW_WHERE_in_ruleSetDeclaration275); if (state.failed) return retval;
                    pushFollow(FOLLOW_constraint_in_ruleSetDeclaration278);
                    constraint18=constraint();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, constraint18.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "ruleSetDeclaration"

    public static class globalVariableDeclaration_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "globalVariableDeclaration"
    // NRLConstraintRules.g:125:1: globalVariableDeclaration : simpleVariableDeclaration -> ^( VT_VARIABLE_DECLARATION simpleVariableDeclaration ) ;
    public final NRLActionParser_NRLConstraintRules.globalVariableDeclaration_return globalVariableDeclaration() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.globalVariableDeclaration_return retval = new NRLActionParser_NRLConstraintRules.globalVariableDeclaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser_NRLConstraintRules.simpleVariableDeclaration_return simpleVariableDeclaration19 = null;


        RewriteRuleSubtreeStream stream_simpleVariableDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule simpleVariableDeclaration");
        try {
            // NRLConstraintRules.g:127:3: ( simpleVariableDeclaration -> ^( VT_VARIABLE_DECLARATION simpleVariableDeclaration ) )
            // NRLConstraintRules.g:127:5: simpleVariableDeclaration
            {
            pushFollow(FOLLOW_simpleVariableDeclaration_in_globalVariableDeclaration304);
            simpleVariableDeclaration19=simpleVariableDeclaration();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_simpleVariableDeclaration.add(simpleVariableDeclaration19.getTree());


            // AST REWRITE
            // elements: simpleVariableDeclaration
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 128:4: -> ^( VT_VARIABLE_DECLARATION simpleVariableDeclaration )
            {
                // NRLConstraintRules.g:128:7: ^( VT_VARIABLE_DECLARATION simpleVariableDeclaration )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_VARIABLE_DECLARATION, "VT_VARIABLE_DECLARATION"), root_1);

                adaptor.addChild(root_1, stream_simpleVariableDeclaration.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "globalVariableDeclaration"

    public static class simpleVariableDeclaration_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "simpleVariableDeclaration"
    // NRLConstraintRules.g:131:1: simpleVariableDeclaration : DOUBLE_QUOTED_STRING ( REPRESENT | HASHAVE ) expression ;
    public final NRLActionParser_NRLConstraintRules.simpleVariableDeclaration_return simpleVariableDeclaration() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.simpleVariableDeclaration_return retval = new NRLActionParser_NRLConstraintRules.simpleVariableDeclaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token DOUBLE_QUOTED_STRING20=null;
        Token REPRESENT21=null;
        Token HASHAVE22=null;
        NRLActionParser_NRLConstraintRules.expression_return expression23 = null;


        CommonTree DOUBLE_QUOTED_STRING20_tree=null;
        CommonTree REPRESENT21_tree=null;
        CommonTree HASHAVE22_tree=null;

        try {
            // NRLConstraintRules.g:132:3: ( DOUBLE_QUOTED_STRING ( REPRESENT | HASHAVE ) expression )
            // NRLConstraintRules.g:132:5: DOUBLE_QUOTED_STRING ( REPRESENT | HASHAVE ) expression
            {
            root_0 = (CommonTree)adaptor.nil();

            DOUBLE_QUOTED_STRING20=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_simpleVariableDeclaration328); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOUBLE_QUOTED_STRING20_tree = (CommonTree)adaptor.create(DOUBLE_QUOTED_STRING20);
            adaptor.addChild(root_0, DOUBLE_QUOTED_STRING20_tree);
            }
            // NRLConstraintRules.g:132:26: ( REPRESENT | HASHAVE )
            int alt6=2;
            switch ( input.LA(1) ) {
            case REPRESENT:
                {
                alt6=1;
                }
                break;
            case HASHAVE:
                {
                alt6=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;
            }

            switch (alt6) {
                case 1 :
                    // NRLConstraintRules.g:132:27: REPRESENT
                    {
                    REPRESENT21=(Token)match(input,REPRESENT,FOLLOW_REPRESENT_in_simpleVariableDeclaration331); if (state.failed) return retval;

                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:132:38: HASHAVE
                    {
                    HASHAVE22=(Token)match(input,HASHAVE,FOLLOW_HASHAVE_in_simpleVariableDeclaration334); if (state.failed) return retval;

                    }
                    break;

            }

            pushFollow(FOLLOW_expression_in_simpleVariableDeclaration338);
            expression23=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, expression23.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "simpleVariableDeclaration"

    public static class context_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "context"
    // NRLConstraintRules.g:135:1: context : CONTEXT modelReference ;
    public final NRLActionParser_NRLConstraintRules.context_return context() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.context_return retval = new NRLActionParser_NRLConstraintRules.context_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token CONTEXT24=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference25 = null;


        CommonTree CONTEXT24_tree=null;

        try {
            // NRLConstraintRules.g:136:3: ( CONTEXT modelReference )
            // NRLConstraintRules.g:136:5: CONTEXT modelReference
            {
            root_0 = (CommonTree)adaptor.nil();

            CONTEXT24=(Token)match(input,CONTEXT,FOLLOW_CONTEXT_in_context353); if (state.failed) return retval;
            pushFollow(FOLLOW_modelReference_in_context356);
            modelReference25=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference25.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "context"

    public static class multipleContext_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "multipleContext"
    // NRLConstraintRules.g:139:1: multipleContext : CONTEXT multipleContextEntry ( COMMA multipleContextEntry )* ;
    public final NRLActionParser_NRLConstraintRules.multipleContext_return multipleContext() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.multipleContext_return retval = new NRLActionParser_NRLConstraintRules.multipleContext_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token CONTEXT26=null;
        Token COMMA28=null;
        NRLActionParser_NRLConstraintRules.multipleContextEntry_return multipleContextEntry27 = null;

        NRLActionParser_NRLConstraintRules.multipleContextEntry_return multipleContextEntry29 = null;


        CommonTree CONTEXT26_tree=null;
        CommonTree COMMA28_tree=null;

        try {
            // NRLConstraintRules.g:140:3: ( CONTEXT multipleContextEntry ( COMMA multipleContextEntry )* )
            // NRLConstraintRules.g:140:5: CONTEXT multipleContextEntry ( COMMA multipleContextEntry )*
            {
            root_0 = (CommonTree)adaptor.nil();

            CONTEXT26=(Token)match(input,CONTEXT,FOLLOW_CONTEXT_in_multipleContext371); if (state.failed) return retval;
            pushFollow(FOLLOW_multipleContextEntry_in_multipleContext374);
            multipleContextEntry27=multipleContextEntry();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, multipleContextEntry27.getTree());
            // NRLConstraintRules.g:140:35: ( COMMA multipleContextEntry )*
            loop7:
            do {
                int alt7=2;
                switch ( input.LA(1) ) {
                case COMMA:
                    {
                    alt7=1;
                    }
                    break;

                }

                switch (alt7) {
            	case 1 :
            	    // NRLConstraintRules.g:140:37: COMMA multipleContextEntry
            	    {
            	    COMMA28=(Token)match(input,COMMA,FOLLOW_COMMA_in_multipleContext378); if (state.failed) return retval;
            	    pushFollow(FOLLOW_multipleContextEntry_in_multipleContext381);
            	    multipleContextEntry29=multipleContextEntry();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, multipleContextEntry29.getTree());

            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "multipleContext"

    public static class multipleContextEntry_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "multipleContextEntry"
    // NRLConstraintRules.g:143:1: multipleContextEntry : modelReference LPAREN DOUBLE_QUOTED_STRING RPAREN -> ^( VT_MULTIPLE_CONTEXTENTRY modelReference DOUBLE_QUOTED_STRING ) ;
    public final NRLActionParser_NRLConstraintRules.multipleContextEntry_return multipleContextEntry() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.multipleContextEntry_return retval = new NRLActionParser_NRLConstraintRules.multipleContextEntry_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token LPAREN31=null;
        Token DOUBLE_QUOTED_STRING32=null;
        Token RPAREN33=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference30 = null;


        CommonTree LPAREN31_tree=null;
        CommonTree DOUBLE_QUOTED_STRING32_tree=null;
        CommonTree RPAREN33_tree=null;
        RewriteRuleTokenStream stream_DOUBLE_QUOTED_STRING=new RewriteRuleTokenStream(adaptor,"token DOUBLE_QUOTED_STRING");
        RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
        RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
        RewriteRuleSubtreeStream stream_modelReference=new RewriteRuleSubtreeStream(adaptor,"rule modelReference");
        try {
            // NRLConstraintRules.g:145:3: ( modelReference LPAREN DOUBLE_QUOTED_STRING RPAREN -> ^( VT_MULTIPLE_CONTEXTENTRY modelReference DOUBLE_QUOTED_STRING ) )
            // NRLConstraintRules.g:145:5: modelReference LPAREN DOUBLE_QUOTED_STRING RPAREN
            {
            pushFollow(FOLLOW_modelReference_in_multipleContextEntry404);
            modelReference30=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_modelReference.add(modelReference30.getTree());
            LPAREN31=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_multipleContextEntry406); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_LPAREN.add(LPAREN31);

            DOUBLE_QUOTED_STRING32=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_multipleContextEntry408); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_DOUBLE_QUOTED_STRING.add(DOUBLE_QUOTED_STRING32);

            RPAREN33=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_multipleContextEntry410); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_RPAREN.add(RPAREN33);



            // AST REWRITE
            // elements: modelReference, DOUBLE_QUOTED_STRING
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 146:4: -> ^( VT_MULTIPLE_CONTEXTENTRY modelReference DOUBLE_QUOTED_STRING )
            {
                // NRLConstraintRules.g:146:7: ^( VT_MULTIPLE_CONTEXTENTRY modelReference DOUBLE_QUOTED_STRING )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_MULTIPLE_CONTEXTENTRY, "VT_MULTIPLE_CONTEXTENTRY"), root_1);

                adaptor.addChild(root_1, stream_modelReference.nextTree());
                adaptor.addChild(root_1, stream_DOUBLE_QUOTED_STRING.nextNode());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "multipleContextEntry"

    public static class constraint_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constraint"
    // NRLConstraintRules.g:149:1: constraint : statement ;
    public final NRLActionParser_NRLConstraintRules.constraint_return constraint() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.constraint_return retval = new NRLActionParser_NRLConstraintRules.constraint_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser_NRLConstraintRules.statement_return statement34 = null;



        try {
            // NRLConstraintRules.g:150:3: ( statement )
            // NRLConstraintRules.g:150:5: statement
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_statement_in_constraint438);
            statement34=statement();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, statement34.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "constraint"

    public static class statement_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "statement"
    // NRLConstraintRules.g:153:1: statement : ( IF iffStatement THEN statement ( options {greedy=true; } : ELSE statement )? | iffStatement );
    public final NRLActionParser_NRLConstraintRules.statement_return statement() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.statement_return retval = new NRLActionParser_NRLConstraintRules.statement_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token IF35=null;
        Token THEN37=null;
        Token ELSE39=null;
        NRLActionParser_NRLConstraintRules.iffStatement_return iffStatement36 = null;

        NRLActionParser_NRLConstraintRules.statement_return statement38 = null;

        NRLActionParser_NRLConstraintRules.statement_return statement40 = null;

        NRLActionParser_NRLConstraintRules.iffStatement_return iffStatement41 = null;


        CommonTree IF35_tree=null;
        CommonTree THEN37_tree=null;
        CommonTree ELSE39_tree=null;

        try {
            // NRLConstraintRules.g:154:3: ( IF iffStatement THEN statement ( options {greedy=true; } : ELSE statement )? | iffStatement )
            int alt9=2;
            switch ( input.LA(1) ) {
            case IF:
                {
                alt9=1;
                }
                break;
            case LPAREN:
            case IN:
            case EXACTLY:
            case AT_LEAST:
            case AT_MOST:
            case ONE:
            case TWO:
            case THREE:
            case FOUR:
            case INTEGER_NUMBER:
            case NO:
            case THERE_IS:
            case EACH:
            case FOLLOWING:
            case MINUS:
            case OPERATOR:
            case PROPERTYNAME:
            case SUM_OF:
            case NUMBER_OF:
            case FIRST:
            case SINGLE_QUOTED_STRING:
            case BOOLEAN:
            case DECIMAL_NUMBER:
            case ORDINAL_NUMBER:
            case IDENTIFIER:
                {
                alt9=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 9, 0, input);

                throw nvae;
            }

            switch (alt9) {
                case 1 :
                    // NRLConstraintRules.g:154:5: IF iffStatement THEN statement ( options {greedy=true; } : ELSE statement )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    IF35=(Token)match(input,IF,FOLLOW_IF_in_statement453); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    IF35_tree = (CommonTree)adaptor.create(IF35);
                    root_0 = (CommonTree)adaptor.becomeRoot(IF35_tree, root_0);
                    }
                    pushFollow(FOLLOW_iffStatement_in_statement456);
                    iffStatement36=iffStatement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, iffStatement36.getTree());
                    THEN37=(Token)match(input,THEN,FOLLOW_THEN_in_statement458); if (state.failed) return retval;
                    pushFollow(FOLLOW_statement_in_statement461);
                    statement38=statement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, statement38.getTree());
                    // NRLConstraintRules.g:155:4: ( options {greedy=true; } : ELSE statement )?
                    int alt8=2;
                    switch ( input.LA(1) ) {
                        case ELSE:
                            {
                            alt8=1;
                            }
                            break;
                    }

                    switch (alt8) {
                        case 1 :
                            // NRLConstraintRules.g:159:5: ELSE statement
                            {
                            ELSE39=(Token)match(input,ELSE,FOLLOW_ELSE_in_statement498); if (state.failed) return retval;
                            pushFollow(FOLLOW_statement_in_statement501);
                            statement40=statement();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) adaptor.addChild(root_0, statement40.getTree());

                            }
                            break;

                    }


                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:161:5: iffStatement
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_iffStatement_in_statement513);
                    iffStatement41=iffStatement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, iffStatement41.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "statement"

    public static class iffStatement_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "iffStatement"
    // NRLConstraintRules.g:164:1: iffStatement : impliesStatement ( IFF iffStatement )? ;
    public final NRLActionParser_NRLConstraintRules.iffStatement_return iffStatement() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.iffStatement_return retval = new NRLActionParser_NRLConstraintRules.iffStatement_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token IFF43=null;
        NRLActionParser_NRLConstraintRules.impliesStatement_return impliesStatement42 = null;

        NRLActionParser_NRLConstraintRules.iffStatement_return iffStatement44 = null;


        CommonTree IFF43_tree=null;

        try {
            // NRLConstraintRules.g:165:3: ( impliesStatement ( IFF iffStatement )? )
            // NRLConstraintRules.g:165:5: impliesStatement ( IFF iffStatement )?
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_impliesStatement_in_iffStatement528);
            impliesStatement42=impliesStatement();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, impliesStatement42.getTree());
            // NRLConstraintRules.g:165:22: ( IFF iffStatement )?
            int alt10=2;
            switch ( input.LA(1) ) {
                case IFF:
                    {
                    alt10=1;
                    }
                    break;
            }

            switch (alt10) {
                case 1 :
                    // NRLConstraintRules.g:165:23: IFF iffStatement
                    {
                    IFF43=(Token)match(input,IFF,FOLLOW_IFF_in_iffStatement531); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    IFF43_tree = (CommonTree)adaptor.create(IFF43);
                    root_0 = (CommonTree)adaptor.becomeRoot(IFF43_tree, root_0);
                    }
                    pushFollow(FOLLOW_iffStatement_in_iffStatement534);
                    iffStatement44=iffStatement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, iffStatement44.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "iffStatement"

    public static class impliesStatement_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "impliesStatement"
    // NRLConstraintRules.g:168:1: impliesStatement : orStatement ( IMPLIES impliesStatement )? ;
    public final NRLActionParser_NRLConstraintRules.impliesStatement_return impliesStatement() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.impliesStatement_return retval = new NRLActionParser_NRLConstraintRules.impliesStatement_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token IMPLIES46=null;
        NRLActionParser_NRLConstraintRules.orStatement_return orStatement45 = null;

        NRLActionParser_NRLConstraintRules.impliesStatement_return impliesStatement47 = null;


        CommonTree IMPLIES46_tree=null;

        try {
            // NRLConstraintRules.g:169:3: ( orStatement ( IMPLIES impliesStatement )? )
            // NRLConstraintRules.g:169:5: orStatement ( IMPLIES impliesStatement )?
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_orStatement_in_impliesStatement549);
            orStatement45=orStatement();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, orStatement45.getTree());
            // NRLConstraintRules.g:169:17: ( IMPLIES impliesStatement )?
            int alt11=2;
            switch ( input.LA(1) ) {
                case IMPLIES:
                    {
                    alt11=1;
                    }
                    break;
            }

            switch (alt11) {
                case 1 :
                    // NRLConstraintRules.g:169:18: IMPLIES impliesStatement
                    {
                    IMPLIES46=(Token)match(input,IMPLIES,FOLLOW_IMPLIES_in_impliesStatement552); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    IMPLIES46_tree = (CommonTree)adaptor.create(IMPLIES46);
                    root_0 = (CommonTree)adaptor.becomeRoot(IMPLIES46_tree, root_0);
                    }
                    pushFollow(FOLLOW_impliesStatement_in_impliesStatement555);
                    impliesStatement47=impliesStatement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, impliesStatement47.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "impliesStatement"

    public static class orStatement_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orStatement"
    // NRLConstraintRules.g:172:1: orStatement : andStatement ( OR orStatement )? ;
    public final NRLActionParser_NRLConstraintRules.orStatement_return orStatement() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.orStatement_return retval = new NRLActionParser_NRLConstraintRules.orStatement_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token OR49=null;
        NRLActionParser_NRLConstraintRules.andStatement_return andStatement48 = null;

        NRLActionParser_NRLConstraintRules.orStatement_return orStatement50 = null;


        CommonTree OR49_tree=null;

        try {
            // NRLConstraintRules.g:173:3: ( andStatement ( OR orStatement )? )
            // NRLConstraintRules.g:173:5: andStatement ( OR orStatement )?
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_andStatement_in_orStatement572);
            andStatement48=andStatement();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, andStatement48.getTree());
            // NRLConstraintRules.g:173:18: ( OR orStatement )?
            int alt12=2;
            switch ( input.LA(1) ) {
                case OR:
                    {
                    alt12=1;
                    }
                    break;
            }

            switch (alt12) {
                case 1 :
                    // NRLConstraintRules.g:173:19: OR orStatement
                    {
                    OR49=(Token)match(input,OR,FOLLOW_OR_in_orStatement575); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    OR49_tree = (CommonTree)adaptor.create(OR49);
                    root_0 = (CommonTree)adaptor.becomeRoot(OR49_tree, root_0);
                    }
                    pushFollow(FOLLOW_orStatement_in_orStatement578);
                    orStatement50=orStatement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, orStatement50.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orStatement"

    public static class andStatement_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "andStatement"
    // NRLConstraintRules.g:176:1: andStatement : logicalStatement ( AND andStatement )? ;
    public final NRLActionParser_NRLConstraintRules.andStatement_return andStatement() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.andStatement_return retval = new NRLActionParser_NRLConstraintRules.andStatement_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token AND52=null;
        NRLActionParser_NRLConstraintRules.logicalStatement_return logicalStatement51 = null;

        NRLActionParser_NRLConstraintRules.andStatement_return andStatement53 = null;


        CommonTree AND52_tree=null;

        try {
            // NRLConstraintRules.g:177:3: ( logicalStatement ( AND andStatement )? )
            // NRLConstraintRules.g:177:5: logicalStatement ( AND andStatement )?
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_logicalStatement_in_andStatement595);
            logicalStatement51=logicalStatement();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, logicalStatement51.getTree());
            // NRLConstraintRules.g:177:22: ( AND andStatement )?
            int alt13=2;
            switch ( input.LA(1) ) {
                case AND:
                    {
                    alt13=1;
                    }
                    break;
            }

            switch (alt13) {
                case 1 :
                    // NRLConstraintRules.g:177:23: AND andStatement
                    {
                    AND52=(Token)match(input,AND,FOLLOW_AND_in_andStatement598); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    AND52_tree = (CommonTree)adaptor.create(AND52);
                    root_0 = (CommonTree)adaptor.becomeRoot(AND52_tree, root_0);
                    }
                    pushFollow(FOLLOW_andStatement_in_andStatement601);
                    andStatement53=andStatement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, andStatement53.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "andStatement"

    public static class logicalStatement_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "logicalStatement"
    // NRLConstraintRules.g:180:1: logicalStatement : ( ( modelReference ( PRESENT | HASHAVE ) )=> existsStatement | ( modelReference THAT )=> existsStatement | ( modelReference NOT_PRESENT )=> notExistsStatement | ( enumeratorDisambiguation )=> existsStatement | ( forallStart )=> forallStatement | globalExistsStatement | predicateStatement );
    public final NRLActionParser_NRLConstraintRules.logicalStatement_return logicalStatement() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.logicalStatement_return retval = new NRLActionParser_NRLConstraintRules.logicalStatement_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser_NRLConstraintRules.existsStatement_return existsStatement54 = null;

        NRLActionParser_NRLConstraintRules.existsStatement_return existsStatement55 = null;

        NRLActionParser_NRLConstraintRules.notExistsStatement_return notExistsStatement56 = null;

        NRLActionParser_NRLConstraintRules.existsStatement_return existsStatement57 = null;

        NRLActionParser_NRLConstraintRules.forallStatement_return forallStatement58 = null;

        NRLActionParser_NRLConstraintRules.globalExistsStatement_return globalExistsStatement59 = null;

        NRLActionParser_NRLConstraintRules.predicateStatement_return predicateStatement60 = null;



        try {
            // NRLConstraintRules.g:181:3: ( ( modelReference ( PRESENT | HASHAVE ) )=> existsStatement | ( modelReference THAT )=> existsStatement | ( modelReference NOT_PRESENT )=> notExistsStatement | ( enumeratorDisambiguation )=> existsStatement | ( forallStart )=> forallStatement | globalExistsStatement | predicateStatement )
            int alt14=7;
            alt14 = dfa14.predict(input);
            switch (alt14) {
                case 1 :
                    // NRLConstraintRules.g:181:5: ( modelReference ( PRESENT | HASHAVE ) )=> existsStatement
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_existsStatement_in_logicalStatement630);
                    existsStatement54=existsStatement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, existsStatement54.getTree());

                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:182:5: ( modelReference THAT )=> existsStatement
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_existsStatement_in_logicalStatement644);
                    existsStatement55=existsStatement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, existsStatement55.getTree());

                    }
                    break;
                case 3 :
                    // NRLConstraintRules.g:183:5: ( modelReference NOT_PRESENT )=> notExistsStatement
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_notExistsStatement_in_logicalStatement658);
                    notExistsStatement56=notExistsStatement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, notExistsStatement56.getTree());

                    }
                    break;
                case 4 :
                    // NRLConstraintRules.g:184:5: ( enumeratorDisambiguation )=> existsStatement
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_existsStatement_in_logicalStatement671);
                    existsStatement57=existsStatement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, existsStatement57.getTree());

                    }
                    break;
                case 5 :
                    // NRLConstraintRules.g:185:5: ( forallStart )=> forallStatement
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_forallStatement_in_logicalStatement683);
                    forallStatement58=forallStatement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, forallStatement58.getTree());

                    }
                    break;
                case 6 :
                    // NRLConstraintRules.g:186:5: globalExistsStatement
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_globalExistsStatement_in_logicalStatement689);
                    globalExistsStatement59=globalExistsStatement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, globalExistsStatement59.getTree());

                    }
                    break;
                case 7 :
                    // NRLConstraintRules.g:187:5: predicateStatement
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_predicateStatement_in_logicalStatement695);
                    predicateStatement60=predicateStatement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, predicateStatement60.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "logicalStatement"

    public static class enumeratorDisambiguation_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "enumeratorDisambiguation"
    // NRLConstraintRules.g:190:1: enumeratorDisambiguation : enumeratorStart ( OF )? ( THAT | HASHAVE | modelReference ) ;
    public final NRLActionParser_NRLConstraintRules.enumeratorDisambiguation_return enumeratorDisambiguation() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.enumeratorDisambiguation_return retval = new NRLActionParser_NRLConstraintRules.enumeratorDisambiguation_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token OF62=null;
        Token THAT63=null;
        Token HASHAVE64=null;
        NRLActionParser_NRLConstraintRules.enumeratorStart_return enumeratorStart61 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference65 = null;


        CommonTree OF62_tree=null;
        CommonTree THAT63_tree=null;
        CommonTree HASHAVE64_tree=null;

        try {
            // NRLConstraintRules.g:191:3: ( enumeratorStart ( OF )? ( THAT | HASHAVE | modelReference ) )
            // NRLConstraintRules.g:191:5: enumeratorStart ( OF )? ( THAT | HASHAVE | modelReference )
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_enumeratorStart_in_enumeratorDisambiguation708);
            enumeratorStart61=enumeratorStart();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, enumeratorStart61.getTree());
            // NRLConstraintRules.g:191:21: ( OF )?
            int alt15=2;
            switch ( input.LA(1) ) {
                case OF:
                    {
                    alt15=1;
                    }
                    break;
            }

            switch (alt15) {
                case 1 :
                    // NRLConstraintRules.g:191:21: OF
                    {
                    OF62=(Token)match(input,OF,FOLLOW_OF_in_enumeratorDisambiguation710); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    OF62_tree = (CommonTree)adaptor.create(OF62);
                    adaptor.addChild(root_0, OF62_tree);
                    }

                    }
                    break;

            }

            // NRLConstraintRules.g:191:25: ( THAT | HASHAVE | modelReference )
            int alt16=3;
            switch ( input.LA(1) ) {
            case THAT:
                {
                alt16=1;
                }
                break;
            case HASHAVE:
                {
                alt16=2;
                }
                break;
            case IDENTIFIER:
                {
                alt16=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 16, 0, input);

                throw nvae;
            }

            switch (alt16) {
                case 1 :
                    // NRLConstraintRules.g:191:26: THAT
                    {
                    THAT63=(Token)match(input,THAT,FOLLOW_THAT_in_enumeratorDisambiguation714); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    THAT63_tree = (CommonTree)adaptor.create(THAT63);
                    adaptor.addChild(root_0, THAT63_tree);
                    }

                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:191:33: HASHAVE
                    {
                    HASHAVE64=(Token)match(input,HASHAVE,FOLLOW_HASHAVE_in_enumeratorDisambiguation718); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    HASHAVE64_tree = (CommonTree)adaptor.create(HASHAVE64);
                    adaptor.addChild(root_0, HASHAVE64_tree);
                    }

                    }
                    break;
                case 3 :
                    // NRLConstraintRules.g:191:43: modelReference
                    {
                    pushFollow(FOLLOW_modelReference_in_enumeratorDisambiguation722);
                    modelReference65=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference65.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "enumeratorDisambiguation"

    public static class enumeratorStart_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "enumeratorStart"
    // NRLConstraintRules.g:194:1: enumeratorStart : ( IN )? ( EXACTLY | AT_LEAST | AT_MOST )? ( ONE | TWO | THREE | FOUR | INTEGER_NUMBER | NO ) ;
    public final NRLActionParser_NRLConstraintRules.enumeratorStart_return enumeratorStart() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.enumeratorStart_return retval = new NRLActionParser_NRLConstraintRules.enumeratorStart_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token IN66=null;
        Token set67=null;
        Token set68=null;

        CommonTree IN66_tree=null;
        CommonTree set67_tree=null;
        CommonTree set68_tree=null;

        try {
            // NRLConstraintRules.g:195:3: ( ( IN )? ( EXACTLY | AT_LEAST | AT_MOST )? ( ONE | TWO | THREE | FOUR | INTEGER_NUMBER | NO ) )
            // NRLConstraintRules.g:195:5: ( IN )? ( EXACTLY | AT_LEAST | AT_MOST )? ( ONE | TWO | THREE | FOUR | INTEGER_NUMBER | NO )
            {
            root_0 = (CommonTree)adaptor.nil();

            // NRLConstraintRules.g:195:5: ( IN )?
            int alt17=2;
            switch ( input.LA(1) ) {
                case IN:
                    {
                    alt17=1;
                    }
                    break;
            }

            switch (alt17) {
                case 1 :
                    // NRLConstraintRules.g:195:6: IN
                    {
                    IN66=(Token)match(input,IN,FOLLOW_IN_in_enumeratorStart741); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    IN66_tree = (CommonTree)adaptor.create(IN66);
                    adaptor.addChild(root_0, IN66_tree);
                    }

                    }
                    break;

            }

            // NRLConstraintRules.g:195:11: ( EXACTLY | AT_LEAST | AT_MOST )?
            int alt18=2;
            switch ( input.LA(1) ) {
                case EXACTLY:
                case AT_LEAST:
                case AT_MOST:
                    {
                    alt18=1;
                    }
                    break;
            }

            switch (alt18) {
                case 1 :
                    // NRLConstraintRules.g:
                    {
                    set67=(Token)input.LT(1);
                    if ( (input.LA(1)>=EXACTLY && input.LA(1)<=AT_MOST) ) {
                        input.consume();
                        if ( state.backtracking==0 ) adaptor.addChild(root_0, (CommonTree)adaptor.create(set67));
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }


                    }
                    break;

            }

            set68=(Token)input.LT(1);
            if ( (input.LA(1)>=ONE && input.LA(1)<=NO) ) {
                input.consume();
                if ( state.backtracking==0 ) adaptor.addChild(root_0, (CommonTree)adaptor.create(set68));
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "enumeratorStart"

    public static class enumerator_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "enumerator"
    // NRLConstraintRules.g:198:1: enumerator : ( IN )? (qual= AT_MOST | qual= AT_LEAST | qual= EXACTLY )? (num= ONE | num= TWO | num= THREE | num= FOUR | num= INTEGER_NUMBER | num= NO ) -> ^( VT_ENUMERATOR ( $qual)? $num) ;
    public final NRLActionParser_NRLConstraintRules.enumerator_return enumerator() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.enumerator_return retval = new NRLActionParser_NRLConstraintRules.enumerator_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token qual=null;
        Token num=null;
        Token IN69=null;

        CommonTree qual_tree=null;
        CommonTree num_tree=null;
        CommonTree IN69_tree=null;
        RewriteRuleTokenStream stream_INTEGER_NUMBER=new RewriteRuleTokenStream(adaptor,"token INTEGER_NUMBER");
        RewriteRuleTokenStream stream_AT_LEAST=new RewriteRuleTokenStream(adaptor,"token AT_LEAST");
        RewriteRuleTokenStream stream_ONE=new RewriteRuleTokenStream(adaptor,"token ONE");
        RewriteRuleTokenStream stream_IN=new RewriteRuleTokenStream(adaptor,"token IN");
        RewriteRuleTokenStream stream_TWO=new RewriteRuleTokenStream(adaptor,"token TWO");
        RewriteRuleTokenStream stream_AT_MOST=new RewriteRuleTokenStream(adaptor,"token AT_MOST");
        RewriteRuleTokenStream stream_THREE=new RewriteRuleTokenStream(adaptor,"token THREE");
        RewriteRuleTokenStream stream_FOUR=new RewriteRuleTokenStream(adaptor,"token FOUR");
        RewriteRuleTokenStream stream_EXACTLY=new RewriteRuleTokenStream(adaptor,"token EXACTLY");
        RewriteRuleTokenStream stream_NO=new RewriteRuleTokenStream(adaptor,"token NO");

        try {
            // NRLConstraintRules.g:199:3: ( ( IN )? (qual= AT_MOST | qual= AT_LEAST | qual= EXACTLY )? (num= ONE | num= TWO | num= THREE | num= FOUR | num= INTEGER_NUMBER | num= NO ) -> ^( VT_ENUMERATOR ( $qual)? $num) )
            // NRLConstraintRules.g:199:5: ( IN )? (qual= AT_MOST | qual= AT_LEAST | qual= EXACTLY )? (num= ONE | num= TWO | num= THREE | num= FOUR | num= INTEGER_NUMBER | num= NO )
            {
            // NRLConstraintRules.g:199:5: ( IN )?
            int alt19=2;
            switch ( input.LA(1) ) {
                case IN:
                    {
                    alt19=1;
                    }
                    break;
            }

            switch (alt19) {
                case 1 :
                    // NRLConstraintRules.g:199:6: IN
                    {
                    IN69=(Token)match(input,IN,FOLLOW_IN_in_enumerator792); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_IN.add(IN69);


                    }
                    break;

            }

            // NRLConstraintRules.g:199:11: (qual= AT_MOST | qual= AT_LEAST | qual= EXACTLY )?
            int alt20=4;
            switch ( input.LA(1) ) {
                case AT_MOST:
                    {
                    alt20=1;
                    }
                    break;
                case AT_LEAST:
                    {
                    alt20=2;
                    }
                    break;
                case EXACTLY:
                    {
                    alt20=3;
                    }
                    break;
            }

            switch (alt20) {
                case 1 :
                    // NRLConstraintRules.g:199:12: qual= AT_MOST
                    {
                    qual=(Token)match(input,AT_MOST,FOLLOW_AT_MOST_in_enumerator799); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_AT_MOST.add(qual);


                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:199:27: qual= AT_LEAST
                    {
                    qual=(Token)match(input,AT_LEAST,FOLLOW_AT_LEAST_in_enumerator805); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_AT_LEAST.add(qual);


                    }
                    break;
                case 3 :
                    // NRLConstraintRules.g:199:43: qual= EXACTLY
                    {
                    qual=(Token)match(input,EXACTLY,FOLLOW_EXACTLY_in_enumerator811); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_EXACTLY.add(qual);


                    }
                    break;

            }

            // NRLConstraintRules.g:199:58: (num= ONE | num= TWO | num= THREE | num= FOUR | num= INTEGER_NUMBER | num= NO )
            int alt21=6;
            switch ( input.LA(1) ) {
            case ONE:
                {
                alt21=1;
                }
                break;
            case TWO:
                {
                alt21=2;
                }
                break;
            case THREE:
                {
                alt21=3;
                }
                break;
            case FOUR:
                {
                alt21=4;
                }
                break;
            case INTEGER_NUMBER:
                {
                alt21=5;
                }
                break;
            case NO:
                {
                alt21=6;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 21, 0, input);

                throw nvae;
            }

            switch (alt21) {
                case 1 :
                    // NRLConstraintRules.g:199:59: num= ONE
                    {
                    num=(Token)match(input,ONE,FOLLOW_ONE_in_enumerator818); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ONE.add(num);


                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:199:67: num= TWO
                    {
                    num=(Token)match(input,TWO,FOLLOW_TWO_in_enumerator822); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_TWO.add(num);


                    }
                    break;
                case 3 :
                    // NRLConstraintRules.g:199:75: num= THREE
                    {
                    num=(Token)match(input,THREE,FOLLOW_THREE_in_enumerator826); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_THREE.add(num);


                    }
                    break;
                case 4 :
                    // NRLConstraintRules.g:199:85: num= FOUR
                    {
                    num=(Token)match(input,FOUR,FOLLOW_FOUR_in_enumerator830); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_FOUR.add(num);


                    }
                    break;
                case 5 :
                    // NRLConstraintRules.g:199:94: num= INTEGER_NUMBER
                    {
                    num=(Token)match(input,INTEGER_NUMBER,FOLLOW_INTEGER_NUMBER_in_enumerator834); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_INTEGER_NUMBER.add(num);


                    }
                    break;
                case 6 :
                    // NRLConstraintRules.g:199:113: num= NO
                    {
                    num=(Token)match(input,NO,FOLLOW_NO_in_enumerator838); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_NO.add(num);


                    }
                    break;

            }



            // AST REWRITE
            // elements: num, qual
            // token labels: num, qual
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleTokenStream stream_num=new RewriteRuleTokenStream(adaptor,"token num",num);
            RewriteRuleTokenStream stream_qual=new RewriteRuleTokenStream(adaptor,"token qual",qual);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 200:4: -> ^( VT_ENUMERATOR ( $qual)? $num)
            {
                // NRLConstraintRules.g:200:7: ^( VT_ENUMERATOR ( $qual)? $num)
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_ENUMERATOR, "VT_ENUMERATOR"), root_1);

                // NRLConstraintRules.g:200:23: ( $qual)?
                if ( stream_qual.hasNext() ) {
                    adaptor.addChild(root_1, stream_qual.nextNode());

                }
                stream_qual.reset();
                adaptor.addChild(root_1, stream_num.nextNode());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "enumerator"

    public static class existsStatement_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "existsStatement"
    // NRLConstraintRules.g:203:1: existsStatement : ( ( enumeratorStart HASHAVE )=> enumerator HASHAVE simpleOrComplexConstraint -> ^( VT_EXISTS enumerator simpleOrComplexConstraint ) | ( enumerator ( OF )? )? modelReference ( PRESENT | ( ( ( ( THAT )? HASHAVE ) | WHERE )? simpleOrComplexConstraint ) ) -> ^( VT_EXISTS ( enumerator )? modelReference ( simpleOrComplexConstraint )? ) );
    public final NRLActionParser_NRLConstraintRules.existsStatement_return existsStatement() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.existsStatement_return retval = new NRLActionParser_NRLConstraintRules.existsStatement_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token HASHAVE71=null;
        Token OF74=null;
        Token PRESENT76=null;
        Token THAT77=null;
        Token HASHAVE78=null;
        Token WHERE79=null;
        NRLActionParser_NRLConstraintRules.enumerator_return enumerator70 = null;

        NRLActionParser_NRLConstraintRules.simpleOrComplexConstraint_return simpleOrComplexConstraint72 = null;

        NRLActionParser_NRLConstraintRules.enumerator_return enumerator73 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference75 = null;

        NRLActionParser_NRLConstraintRules.simpleOrComplexConstraint_return simpleOrComplexConstraint80 = null;


        CommonTree HASHAVE71_tree=null;
        CommonTree OF74_tree=null;
        CommonTree PRESENT76_tree=null;
        CommonTree THAT77_tree=null;
        CommonTree HASHAVE78_tree=null;
        CommonTree WHERE79_tree=null;
        RewriteRuleTokenStream stream_WHERE=new RewriteRuleTokenStream(adaptor,"token WHERE");
        RewriteRuleTokenStream stream_THAT=new RewriteRuleTokenStream(adaptor,"token THAT");
        RewriteRuleTokenStream stream_HASHAVE=new RewriteRuleTokenStream(adaptor,"token HASHAVE");
        RewriteRuleTokenStream stream_OF=new RewriteRuleTokenStream(adaptor,"token OF");
        RewriteRuleTokenStream stream_PRESENT=new RewriteRuleTokenStream(adaptor,"token PRESENT");
        RewriteRuleSubtreeStream stream_enumerator=new RewriteRuleSubtreeStream(adaptor,"rule enumerator");
        RewriteRuleSubtreeStream stream_simpleOrComplexConstraint=new RewriteRuleSubtreeStream(adaptor,"rule simpleOrComplexConstraint");
        RewriteRuleSubtreeStream stream_modelReference=new RewriteRuleSubtreeStream(adaptor,"rule modelReference");
        try {
            // NRLConstraintRules.g:205:3: ( ( enumeratorStart HASHAVE )=> enumerator HASHAVE simpleOrComplexConstraint -> ^( VT_EXISTS enumerator simpleOrComplexConstraint ) | ( enumerator ( OF )? )? modelReference ( PRESENT | ( ( ( ( THAT )? HASHAVE ) | WHERE )? simpleOrComplexConstraint ) ) -> ^( VT_EXISTS ( enumerator )? modelReference ( simpleOrComplexConstraint )? ) )
            int alt27=2;
            alt27 = dfa27.predict(input);
            switch (alt27) {
                case 1 :
                    // NRLConstraintRules.g:205:5: ( enumeratorStart HASHAVE )=> enumerator HASHAVE simpleOrComplexConstraint
                    {
                    pushFollow(FOLLOW_enumerator_in_existsStatement883);
                    enumerator70=enumerator();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enumerator.add(enumerator70.getTree());
                    HASHAVE71=(Token)match(input,HASHAVE,FOLLOW_HASHAVE_in_existsStatement885); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_HASHAVE.add(HASHAVE71);

                    pushFollow(FOLLOW_simpleOrComplexConstraint_in_existsStatement887);
                    simpleOrComplexConstraint72=simpleOrComplexConstraint();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_simpleOrComplexConstraint.add(simpleOrComplexConstraint72.getTree());


                    // AST REWRITE
                    // elements: enumerator, simpleOrComplexConstraint
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 206:4: -> ^( VT_EXISTS enumerator simpleOrComplexConstraint )
                    {
                        // NRLConstraintRules.g:206:7: ^( VT_EXISTS enumerator simpleOrComplexConstraint )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_EXISTS, "VT_EXISTS"), root_1);

                        adaptor.addChild(root_1, stream_enumerator.nextTree());
                        adaptor.addChild(root_1, stream_simpleOrComplexConstraint.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:207:5: ( enumerator ( OF )? )? modelReference ( PRESENT | ( ( ( ( THAT )? HASHAVE ) | WHERE )? simpleOrComplexConstraint ) )
                    {
                    // NRLConstraintRules.g:207:5: ( enumerator ( OF )? )?
                    int alt23=2;
                    switch ( input.LA(1) ) {
                        case IN:
                        case EXACTLY:
                        case AT_LEAST:
                        case AT_MOST:
                        case ONE:
                        case TWO:
                        case THREE:
                        case FOUR:
                        case INTEGER_NUMBER:
                        case NO:
                            {
                            alt23=1;
                            }
                            break;
                    }

                    switch (alt23) {
                        case 1 :
                            // NRLConstraintRules.g:207:6: enumerator ( OF )?
                            {
                            pushFollow(FOLLOW_enumerator_in_existsStatement907);
                            enumerator73=enumerator();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_enumerator.add(enumerator73.getTree());
                            // NRLConstraintRules.g:207:17: ( OF )?
                            int alt22=2;
                            switch ( input.LA(1) ) {
                                case OF:
                                    {
                                    alt22=1;
                                    }
                                    break;
                            }

                            switch (alt22) {
                                case 1 :
                                    // NRLConstraintRules.g:207:17: OF
                                    {
                                    OF74=(Token)match(input,OF,FOLLOW_OF_in_existsStatement909); if (state.failed) return retval; 
                                    if ( state.backtracking==0 ) stream_OF.add(OF74);


                                    }
                                    break;

                            }


                            }
                            break;

                    }

                    pushFollow(FOLLOW_modelReference_in_existsStatement914);
                    modelReference75=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_modelReference.add(modelReference75.getTree());
                    // NRLConstraintRules.g:207:38: ( PRESENT | ( ( ( ( THAT )? HASHAVE ) | WHERE )? simpleOrComplexConstraint ) )
                    int alt26=2;
                    switch ( input.LA(1) ) {
                    case PRESENT:
                        {
                        alt26=1;
                        }
                        break;
                    case WHERE:
                    case HASHAVE:
                    case LPAREN:
                    case THAT:
                    case INTEGER_NUMBER:
                    case FOLLOWING:
                    case MINUS:
                    case OPERATOR:
                    case PROPERTYNAME:
                    case SUM_OF:
                    case NUMBER_OF:
                    case FIRST:
                    case SINGLE_QUOTED_STRING:
                    case BOOLEAN:
                    case DECIMAL_NUMBER:
                    case ORDINAL_NUMBER:
                    case IDENTIFIER:
                        {
                        alt26=2;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 26, 0, input);

                        throw nvae;
                    }

                    switch (alt26) {
                        case 1 :
                            // NRLConstraintRules.g:207:39: PRESENT
                            {
                            PRESENT76=(Token)match(input,PRESENT,FOLLOW_PRESENT_in_existsStatement917); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_PRESENT.add(PRESENT76);


                            }
                            break;
                        case 2 :
                            // NRLConstraintRules.g:207:49: ( ( ( ( THAT )? HASHAVE ) | WHERE )? simpleOrComplexConstraint )
                            {
                            // NRLConstraintRules.g:207:49: ( ( ( ( THAT )? HASHAVE ) | WHERE )? simpleOrComplexConstraint )
                            // NRLConstraintRules.g:207:50: ( ( ( THAT )? HASHAVE ) | WHERE )? simpleOrComplexConstraint
                            {
                            // NRLConstraintRules.g:207:50: ( ( ( THAT )? HASHAVE ) | WHERE )?
                            int alt25=3;
                            switch ( input.LA(1) ) {
                                case HASHAVE:
                                case THAT:
                                    {
                                    alt25=1;
                                    }
                                    break;
                                case WHERE:
                                    {
                                    alt25=2;
                                    }
                                    break;
                            }

                            switch (alt25) {
                                case 1 :
                                    // NRLConstraintRules.g:207:52: ( ( THAT )? HASHAVE )
                                    {
                                    // NRLConstraintRules.g:207:52: ( ( THAT )? HASHAVE )
                                    // NRLConstraintRules.g:207:53: ( THAT )? HASHAVE
                                    {
                                    // NRLConstraintRules.g:207:53: ( THAT )?
                                    int alt24=2;
                                    switch ( input.LA(1) ) {
                                        case THAT:
                                            {
                                            alt24=1;
                                            }
                                            break;
                                    }

                                    switch (alt24) {
                                        case 1 :
                                            // NRLConstraintRules.g:207:54: THAT
                                            {
                                            THAT77=(Token)match(input,THAT,FOLLOW_THAT_in_existsStatement926); if (state.failed) return retval; 
                                            if ( state.backtracking==0 ) stream_THAT.add(THAT77);


                                            }
                                            break;

                                    }

                                    HASHAVE78=(Token)match(input,HASHAVE,FOLLOW_HASHAVE_in_existsStatement930); if (state.failed) return retval; 
                                    if ( state.backtracking==0 ) stream_HASHAVE.add(HASHAVE78);


                                    }


                                    }
                                    break;
                                case 2 :
                                    // NRLConstraintRules.g:207:72: WHERE
                                    {
                                    WHERE79=(Token)match(input,WHERE,FOLLOW_WHERE_in_existsStatement935); if (state.failed) return retval; 
                                    if ( state.backtracking==0 ) stream_WHERE.add(WHERE79);


                                    }
                                    break;

                            }

                            pushFollow(FOLLOW_simpleOrComplexConstraint_in_existsStatement939);
                            simpleOrComplexConstraint80=simpleOrComplexConstraint();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_simpleOrComplexConstraint.add(simpleOrComplexConstraint80.getTree());

                            }


                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: modelReference, enumerator, simpleOrComplexConstraint
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 208:4: -> ^( VT_EXISTS ( enumerator )? modelReference ( simpleOrComplexConstraint )? )
                    {
                        // NRLConstraintRules.g:208:7: ^( VT_EXISTS ( enumerator )? modelReference ( simpleOrComplexConstraint )? )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_EXISTS, "VT_EXISTS"), root_1);

                        // NRLConstraintRules.g:208:19: ( enumerator )?
                        if ( stream_enumerator.hasNext() ) {
                            adaptor.addChild(root_1, stream_enumerator.nextTree());

                        }
                        stream_enumerator.reset();
                        adaptor.addChild(root_1, stream_modelReference.nextTree());
                        // NRLConstraintRules.g:208:46: ( simpleOrComplexConstraint )?
                        if ( stream_simpleOrComplexConstraint.hasNext() ) {
                            adaptor.addChild(root_1, stream_simpleOrComplexConstraint.nextTree());

                        }
                        stream_simpleOrComplexConstraint.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "existsStatement"

    public static class globalExistsStatement_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "globalExistsStatement"
    // NRLConstraintRules.g:211:1: globalExistsStatement : THERE_IS ( NO )? modelReference ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN )? ( WHERE simpleOrComplexConstraint )? ;
    public final NRLActionParser_NRLConstraintRules.globalExistsStatement_return globalExistsStatement() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.globalExistsStatement_return retval = new NRLActionParser_NRLConstraintRules.globalExistsStatement_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token var=null;
        Token THERE_IS81=null;
        Token NO82=null;
        Token LPAREN84=null;
        Token RPAREN85=null;
        Token WHERE86=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference83 = null;

        NRLActionParser_NRLConstraintRules.simpleOrComplexConstraint_return simpleOrComplexConstraint87 = null;


        CommonTree var_tree=null;
        CommonTree THERE_IS81_tree=null;
        CommonTree NO82_tree=null;
        CommonTree LPAREN84_tree=null;
        CommonTree RPAREN85_tree=null;
        CommonTree WHERE86_tree=null;

        try {
            // NRLConstraintRules.g:212:3: ( THERE_IS ( NO )? modelReference ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN )? ( WHERE simpleOrComplexConstraint )? )
            // NRLConstraintRules.g:212:5: THERE_IS ( NO )? modelReference ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN )? ( WHERE simpleOrComplexConstraint )?
            {
            root_0 = (CommonTree)adaptor.nil();

            THERE_IS81=(Token)match(input,THERE_IS,FOLLOW_THERE_IS_in_globalExistsStatement975); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            THERE_IS81_tree = (CommonTree)adaptor.create(THERE_IS81);
            root_0 = (CommonTree)adaptor.becomeRoot(THERE_IS81_tree, root_0);
            }
            // NRLConstraintRules.g:212:15: ( NO )?
            int alt28=2;
            switch ( input.LA(1) ) {
                case NO:
                    {
                    alt28=1;
                    }
                    break;
            }

            switch (alt28) {
                case 1 :
                    // NRLConstraintRules.g:212:16: NO
                    {
                    NO82=(Token)match(input,NO,FOLLOW_NO_in_globalExistsStatement979); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NO82_tree = (CommonTree)adaptor.create(NO82);
                    adaptor.addChild(root_0, NO82_tree);
                    }

                    }
                    break;

            }

            pushFollow(FOLLOW_modelReference_in_globalExistsStatement983);
            modelReference83=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference83.getTree());
            // NRLConstraintRules.g:213:4: ( LPAREN var= DOUBLE_QUOTED_STRING RPAREN )?
            int alt29=2;
            switch ( input.LA(1) ) {
                case LPAREN:
                    {
                    alt29=1;
                    }
                    break;
            }

            switch (alt29) {
                case 1 :
                    // NRLConstraintRules.g:214:5: LPAREN var= DOUBLE_QUOTED_STRING RPAREN
                    {
                    LPAREN84=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_globalExistsStatement995); if (state.failed) return retval;
                    var=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_globalExistsStatement1000); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    var_tree = (CommonTree)adaptor.create(var);
                    adaptor.addChild(root_0, var_tree);
                    }
                    RPAREN85=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_globalExistsStatement1002); if (state.failed) return retval;

                    }
                    break;

            }

            // NRLConstraintRules.g:216:4: ( WHERE simpleOrComplexConstraint )?
            int alt30=2;
            switch ( input.LA(1) ) {
                case WHERE:
                    {
                    alt30=1;
                    }
                    break;
            }

            switch (alt30) {
                case 1 :
                    // NRLConstraintRules.g:217:5: WHERE simpleOrComplexConstraint
                    {
                    WHERE86=(Token)match(input,WHERE,FOLLOW_WHERE_in_globalExistsStatement1021); if (state.failed) return retval;
                    pushFollow(FOLLOW_simpleOrComplexConstraint_in_globalExistsStatement1024);
                    simpleOrComplexConstraint87=simpleOrComplexConstraint();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, simpleOrComplexConstraint87.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "globalExistsStatement"

    public static class simpleOrComplexConstraint_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "simpleOrComplexConstraint"
    // NRLConstraintRules.g:221:1: simpleOrComplexConstraint : ( ( LPAREN )=> LPAREN constraint RPAREN | predicateStatement );
    public final NRLActionParser_NRLConstraintRules.simpleOrComplexConstraint_return simpleOrComplexConstraint() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.simpleOrComplexConstraint_return retval = new NRLActionParser_NRLConstraintRules.simpleOrComplexConstraint_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token LPAREN88=null;
        Token RPAREN90=null;
        NRLActionParser_NRLConstraintRules.constraint_return constraint89 = null;

        NRLActionParser_NRLConstraintRules.predicateStatement_return predicateStatement91 = null;


        CommonTree LPAREN88_tree=null;
        CommonTree RPAREN90_tree=null;

        try {
            // NRLConstraintRules.g:222:3: ( ( LPAREN )=> LPAREN constraint RPAREN | predicateStatement )
            int alt31=2;
            alt31 = dfa31.predict(input);
            switch (alt31) {
                case 1 :
                    // NRLConstraintRules.g:222:5: ( LPAREN )=> LPAREN constraint RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    LPAREN88=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_simpleOrComplexConstraint1052); if (state.failed) return retval;
                    pushFollow(FOLLOW_constraint_in_simpleOrComplexConstraint1055);
                    constraint89=constraint();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, constraint89.getTree());
                    RPAREN90=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_simpleOrComplexConstraint1057); if (state.failed) return retval;

                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:223:5: predicateStatement
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_predicateStatement_in_simpleOrComplexConstraint1064);
                    predicateStatement91=predicateStatement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, predicateStatement91.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "simpleOrComplexConstraint"

    public static class notExistsStatement_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "notExistsStatement"
    // NRLConstraintRules.g:226:1: notExistsStatement : modelReference NOT_PRESENT ;
    public final NRLActionParser_NRLConstraintRules.notExistsStatement_return notExistsStatement() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.notExistsStatement_return retval = new NRLActionParser_NRLConstraintRules.notExistsStatement_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token NOT_PRESENT93=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference92 = null;


        CommonTree NOT_PRESENT93_tree=null;

        try {
            // NRLConstraintRules.g:227:3: ( modelReference NOT_PRESENT )
            // NRLConstraintRules.g:227:5: modelReference NOT_PRESENT
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_modelReference_in_notExistsStatement1077);
            modelReference92=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference92.getTree());
            NOT_PRESENT93=(Token)match(input,NOT_PRESENT,FOLLOW_NOT_PRESENT_in_notExistsStatement1079); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            NOT_PRESENT93_tree = (CommonTree)adaptor.create(NOT_PRESENT93);
            root_0 = (CommonTree)adaptor.becomeRoot(NOT_PRESENT93_tree, root_0);
            }

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "notExistsStatement"

    public static class forallStatement_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "forallStatement"
    // NRLConstraintRules.g:230:1: forallStatement : ( ( forallStart OF modelReference HASHAVE )=> ( IN )? EACH ( OF )? modelReference HASHAVE simpleOrComplexConstraint | ( forallStart modelReference HASHAVE )=> ( IN )? EACH ( OF )? modelReference HASHAVE simpleOrComplexConstraint | ( forallStart DOUBLE_QUOTED_STRING )=> ( IN )? EACH DOUBLE_QUOTED_STRING ( IN_COLLECTION )? ( OF )? modelReference ( HASHAVE | COMMA )? simpleOrComplexConstraint | ( IN )? EACH ( OF )? modelReference simpleOrComplexConstraint );
    public final NRLActionParser_NRLConstraintRules.forallStatement_return forallStatement() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.forallStatement_return retval = new NRLActionParser_NRLConstraintRules.forallStatement_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token IN94=null;
        Token EACH95=null;
        Token OF96=null;
        Token HASHAVE98=null;
        Token IN100=null;
        Token EACH101=null;
        Token OF102=null;
        Token HASHAVE104=null;
        Token IN106=null;
        Token EACH107=null;
        Token DOUBLE_QUOTED_STRING108=null;
        Token IN_COLLECTION109=null;
        Token OF110=null;
        Token HASHAVE112=null;
        Token COMMA113=null;
        Token IN115=null;
        Token EACH116=null;
        Token OF117=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference97 = null;

        NRLActionParser_NRLConstraintRules.simpleOrComplexConstraint_return simpleOrComplexConstraint99 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference103 = null;

        NRLActionParser_NRLConstraintRules.simpleOrComplexConstraint_return simpleOrComplexConstraint105 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference111 = null;

        NRLActionParser_NRLConstraintRules.simpleOrComplexConstraint_return simpleOrComplexConstraint114 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference118 = null;

        NRLActionParser_NRLConstraintRules.simpleOrComplexConstraint_return simpleOrComplexConstraint119 = null;


        CommonTree IN94_tree=null;
        CommonTree EACH95_tree=null;
        CommonTree OF96_tree=null;
        CommonTree HASHAVE98_tree=null;
        CommonTree IN100_tree=null;
        CommonTree EACH101_tree=null;
        CommonTree OF102_tree=null;
        CommonTree HASHAVE104_tree=null;
        CommonTree IN106_tree=null;
        CommonTree EACH107_tree=null;
        CommonTree DOUBLE_QUOTED_STRING108_tree=null;
        CommonTree IN_COLLECTION109_tree=null;
        CommonTree OF110_tree=null;
        CommonTree HASHAVE112_tree=null;
        CommonTree COMMA113_tree=null;
        CommonTree IN115_tree=null;
        CommonTree EACH116_tree=null;
        CommonTree OF117_tree=null;

        try {
            // NRLConstraintRules.g:231:3: ( ( forallStart OF modelReference HASHAVE )=> ( IN )? EACH ( OF )? modelReference HASHAVE simpleOrComplexConstraint | ( forallStart modelReference HASHAVE )=> ( IN )? EACH ( OF )? modelReference HASHAVE simpleOrComplexConstraint | ( forallStart DOUBLE_QUOTED_STRING )=> ( IN )? EACH DOUBLE_QUOTED_STRING ( IN_COLLECTION )? ( OF )? modelReference ( HASHAVE | COMMA )? simpleOrComplexConstraint | ( IN )? EACH ( OF )? modelReference simpleOrComplexConstraint )
            int alt42=4;
            switch ( input.LA(1) ) {
            case IN:
                {
                int LA42_1 = input.LA(2);

                if ( (synpred9_NRLConstraintRules()) ) {
                    alt42=1;
                }
                else if ( (synpred10_NRLConstraintRules()) ) {
                    alt42=2;
                }
                else if ( (synpred11_NRLConstraintRules()) ) {
                    alt42=3;
                }
                else if ( (true) ) {
                    alt42=4;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 42, 1, input);

                    throw nvae;
                }
                }
                break;
            case EACH:
                {
                int LA42_2 = input.LA(2);

                if ( (synpred9_NRLConstraintRules()) ) {
                    alt42=1;
                }
                else if ( (synpred10_NRLConstraintRules()) ) {
                    alt42=2;
                }
                else if ( (synpred11_NRLConstraintRules()) ) {
                    alt42=3;
                }
                else if ( (true) ) {
                    alt42=4;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 42, 2, input);

                    throw nvae;
                }
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 42, 0, input);

                throw nvae;
            }

            switch (alt42) {
                case 1 :
                    // NRLConstraintRules.g:231:5: ( forallStart OF modelReference HASHAVE )=> ( IN )? EACH ( OF )? modelReference HASHAVE simpleOrComplexConstraint
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    // NRLConstraintRules.g:231:48: ( IN )?
                    int alt32=2;
                    switch ( input.LA(1) ) {
                        case IN:
                            {
                            alt32=1;
                            }
                            break;
                    }

                    switch (alt32) {
                        case 1 :
                            // NRLConstraintRules.g:231:49: IN
                            {
                            IN94=(Token)match(input,IN,FOLLOW_IN_in_forallStatement1108); if (state.failed) return retval;

                            }
                            break;

                    }

                    EACH95=(Token)match(input,EACH,FOLLOW_EACH_in_forallStatement1113); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    EACH95_tree = (CommonTree)adaptor.create(EACH95);
                    root_0 = (CommonTree)adaptor.becomeRoot(EACH95_tree, root_0);
                    }
                    // NRLConstraintRules.g:231:61: ( OF )?
                    int alt33=2;
                    switch ( input.LA(1) ) {
                        case OF:
                            {
                            alt33=1;
                            }
                            break;
                    }

                    switch (alt33) {
                        case 1 :
                            // NRLConstraintRules.g:231:62: OF
                            {
                            OF96=(Token)match(input,OF,FOLLOW_OF_in_forallStatement1117); if (state.failed) return retval;

                            }
                            break;

                    }

                    pushFollow(FOLLOW_modelReference_in_forallStatement1122);
                    modelReference97=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference97.getTree());
                    HASHAVE98=(Token)match(input,HASHAVE,FOLLOW_HASHAVE_in_forallStatement1124); if (state.failed) return retval;
                    pushFollow(FOLLOW_simpleOrComplexConstraint_in_forallStatement1127);
                    simpleOrComplexConstraint99=simpleOrComplexConstraint();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, simpleOrComplexConstraint99.getTree());

                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:232:5: ( forallStart modelReference HASHAVE )=> ( IN )? EACH ( OF )? modelReference HASHAVE simpleOrComplexConstraint
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    // NRLConstraintRules.g:232:45: ( IN )?
                    int alt34=2;
                    switch ( input.LA(1) ) {
                        case IN:
                            {
                            alt34=1;
                            }
                            break;
                    }

                    switch (alt34) {
                        case 1 :
                            // NRLConstraintRules.g:232:46: IN
                            {
                            IN100=(Token)match(input,IN,FOLLOW_IN_in_forallStatement1144); if (state.failed) return retval;

                            }
                            break;

                    }

                    EACH101=(Token)match(input,EACH,FOLLOW_EACH_in_forallStatement1149); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    EACH101_tree = (CommonTree)adaptor.create(EACH101);
                    root_0 = (CommonTree)adaptor.becomeRoot(EACH101_tree, root_0);
                    }
                    // NRLConstraintRules.g:232:58: ( OF )?
                    int alt35=2;
                    switch ( input.LA(1) ) {
                        case OF:
                            {
                            alt35=1;
                            }
                            break;
                    }

                    switch (alt35) {
                        case 1 :
                            // NRLConstraintRules.g:232:59: OF
                            {
                            OF102=(Token)match(input,OF,FOLLOW_OF_in_forallStatement1153); if (state.failed) return retval;

                            }
                            break;

                    }

                    pushFollow(FOLLOW_modelReference_in_forallStatement1158);
                    modelReference103=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference103.getTree());
                    HASHAVE104=(Token)match(input,HASHAVE,FOLLOW_HASHAVE_in_forallStatement1160); if (state.failed) return retval;
                    pushFollow(FOLLOW_simpleOrComplexConstraint_in_forallStatement1163);
                    simpleOrComplexConstraint105=simpleOrComplexConstraint();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, simpleOrComplexConstraint105.getTree());

                    }
                    break;
                case 3 :
                    // NRLConstraintRules.g:233:5: ( forallStart DOUBLE_QUOTED_STRING )=> ( IN )? EACH DOUBLE_QUOTED_STRING ( IN_COLLECTION )? ( OF )? modelReference ( HASHAVE | COMMA )? simpleOrComplexConstraint
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    // NRLConstraintRules.g:233:43: ( IN )?
                    int alt36=2;
                    switch ( input.LA(1) ) {
                        case IN:
                            {
                            alt36=1;
                            }
                            break;
                    }

                    switch (alt36) {
                        case 1 :
                            // NRLConstraintRules.g:233:44: IN
                            {
                            IN106=(Token)match(input,IN,FOLLOW_IN_in_forallStatement1178); if (state.failed) return retval;

                            }
                            break;

                    }

                    EACH107=(Token)match(input,EACH,FOLLOW_EACH_in_forallStatement1183); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    EACH107_tree = (CommonTree)adaptor.create(EACH107);
                    root_0 = (CommonTree)adaptor.becomeRoot(EACH107_tree, root_0);
                    }
                    DOUBLE_QUOTED_STRING108=(Token)match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_forallStatement1186); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    DOUBLE_QUOTED_STRING108_tree = (CommonTree)adaptor.create(DOUBLE_QUOTED_STRING108);
                    adaptor.addChild(root_0, DOUBLE_QUOTED_STRING108_tree);
                    }
                    // NRLConstraintRules.g:233:77: ( IN_COLLECTION )?
                    int alt37=2;
                    switch ( input.LA(1) ) {
                        case IN_COLLECTION:
                            {
                            alt37=1;
                            }
                            break;
                    }

                    switch (alt37) {
                        case 1 :
                            // NRLConstraintRules.g:233:78: IN_COLLECTION
                            {
                            IN_COLLECTION109=(Token)match(input,IN_COLLECTION,FOLLOW_IN_COLLECTION_in_forallStatement1189); if (state.failed) return retval;

                            }
                            break;

                    }

                    // NRLConstraintRules.g:233:95: ( OF )?
                    int alt38=2;
                    switch ( input.LA(1) ) {
                        case OF:
                            {
                            alt38=1;
                            }
                            break;
                    }

                    switch (alt38) {
                        case 1 :
                            // NRLConstraintRules.g:233:96: OF
                            {
                            OF110=(Token)match(input,OF,FOLLOW_OF_in_forallStatement1195); if (state.failed) return retval;

                            }
                            break;

                    }

                    pushFollow(FOLLOW_modelReference_in_forallStatement1200);
                    modelReference111=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference111.getTree());
                    // NRLConstraintRules.g:233:117: ( HASHAVE | COMMA )?
                    int alt39=3;
                    switch ( input.LA(1) ) {
                        case HASHAVE:
                            {
                            alt39=1;
                            }
                            break;
                        case COMMA:
                            {
                            alt39=2;
                            }
                            break;
                    }

                    switch (alt39) {
                        case 1 :
                            // NRLConstraintRules.g:233:118: HASHAVE
                            {
                            HASHAVE112=(Token)match(input,HASHAVE,FOLLOW_HASHAVE_in_forallStatement1203); if (state.failed) return retval;

                            }
                            break;
                        case 2 :
                            // NRLConstraintRules.g:233:129: COMMA
                            {
                            COMMA113=(Token)match(input,COMMA,FOLLOW_COMMA_in_forallStatement1208); if (state.failed) return retval;

                            }
                            break;

                    }

                    pushFollow(FOLLOW_simpleOrComplexConstraint_in_forallStatement1213);
                    simpleOrComplexConstraint114=simpleOrComplexConstraint();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, simpleOrComplexConstraint114.getTree());

                    }
                    break;
                case 4 :
                    // NRLConstraintRules.g:234:5: ( IN )? EACH ( OF )? modelReference simpleOrComplexConstraint
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    // NRLConstraintRules.g:234:5: ( IN )?
                    int alt40=2;
                    switch ( input.LA(1) ) {
                        case IN:
                            {
                            alt40=1;
                            }
                            break;
                    }

                    switch (alt40) {
                        case 1 :
                            // NRLConstraintRules.g:234:6: IN
                            {
                            IN115=(Token)match(input,IN,FOLLOW_IN_in_forallStatement1220); if (state.failed) return retval;

                            }
                            break;

                    }

                    EACH116=(Token)match(input,EACH,FOLLOW_EACH_in_forallStatement1225); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    EACH116_tree = (CommonTree)adaptor.create(EACH116);
                    root_0 = (CommonTree)adaptor.becomeRoot(EACH116_tree, root_0);
                    }
                    // NRLConstraintRules.g:234:18: ( OF )?
                    int alt41=2;
                    switch ( input.LA(1) ) {
                        case OF:
                            {
                            alt41=1;
                            }
                            break;
                    }

                    switch (alt41) {
                        case 1 :
                            // NRLConstraintRules.g:234:19: OF
                            {
                            OF117=(Token)match(input,OF,FOLLOW_OF_in_forallStatement1229); if (state.failed) return retval;

                            }
                            break;

                    }

                    pushFollow(FOLLOW_modelReference_in_forallStatement1234);
                    modelReference118=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference118.getTree());
                    pushFollow(FOLLOW_simpleOrComplexConstraint_in_forallStatement1236);
                    simpleOrComplexConstraint119=simpleOrComplexConstraint();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, simpleOrComplexConstraint119.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "forallStatement"

    public static class forallStart_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "forallStart"
    // NRLConstraintRules.g:237:1: forallStart : ( IN )? EACH ;
    public final NRLActionParser_NRLConstraintRules.forallStart_return forallStart() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.forallStart_return retval = new NRLActionParser_NRLConstraintRules.forallStart_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token IN120=null;
        Token EACH121=null;

        CommonTree IN120_tree=null;
        CommonTree EACH121_tree=null;

        try {
            // NRLConstraintRules.g:238:3: ( ( IN )? EACH )
            // NRLConstraintRules.g:238:5: ( IN )? EACH
            {
            root_0 = (CommonTree)adaptor.nil();

            // NRLConstraintRules.g:238:5: ( IN )?
            int alt43=2;
            switch ( input.LA(1) ) {
                case IN:
                    {
                    alt43=1;
                    }
                    break;
            }

            switch (alt43) {
                case 1 :
                    // NRLConstraintRules.g:238:6: IN
                    {
                    IN120=(Token)match(input,IN,FOLLOW_IN_in_forallStart1252); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    IN120_tree = (CommonTree)adaptor.create(IN120);
                    adaptor.addChild(root_0, IN120_tree);
                    }

                    }
                    break;

            }

            EACH121=(Token)match(input,EACH,FOLLOW_EACH_in_forallStart1256); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            EACH121_tree = (CommonTree)adaptor.create(EACH121);
            adaptor.addChild(root_0, EACH121_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "forallStart"

    public static class predicateStatement_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "predicateStatement"
    // NRLConstraintRules.g:241:1: predicateStatement : ( ( expression IS_IN )=> expression IS_IN listDefinition | ( expression IS_NOT_IN )=> expression IS_NOT_IN listDefinition | ( modelReference KIND_OF )=> isSubtypePredicate | ( FOLLOWING PRESENT )=> multipleExistsStatement | ( FOLLOWING NOT_PRESENT )=> multipleNotExistsStatement | expression ( ( EQUALS | NOT_EQUALS | LESS | LESS_EQ | GREATER | GREATER_EQ ) expression )? );
    public final NRLActionParser_NRLConstraintRules.predicateStatement_return predicateStatement() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.predicateStatement_return retval = new NRLActionParser_NRLConstraintRules.predicateStatement_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token IS_IN123=null;
        Token IS_NOT_IN126=null;
        Token EQUALS132=null;
        Token NOT_EQUALS133=null;
        Token LESS134=null;
        Token LESS_EQ135=null;
        Token GREATER136=null;
        Token GREATER_EQ137=null;
        NRLActionParser_NRLConstraintRules.expression_return expression122 = null;

        NRLActionParser_NRLConstraintRules.listDefinition_return listDefinition124 = null;

        NRLActionParser_NRLConstraintRules.expression_return expression125 = null;

        NRLActionParser_NRLConstraintRules.listDefinition_return listDefinition127 = null;

        NRLActionParser_NRLConstraintRules.isSubtypePredicate_return isSubtypePredicate128 = null;

        NRLActionParser_NRLConstraintRules.multipleExistsStatement_return multipleExistsStatement129 = null;

        NRLActionParser_NRLConstraintRules.multipleNotExistsStatement_return multipleNotExistsStatement130 = null;

        NRLActionParser_NRLConstraintRules.expression_return expression131 = null;

        NRLActionParser_NRLConstraintRules.expression_return expression138 = null;


        CommonTree IS_IN123_tree=null;
        CommonTree IS_NOT_IN126_tree=null;
        CommonTree EQUALS132_tree=null;
        CommonTree NOT_EQUALS133_tree=null;
        CommonTree LESS134_tree=null;
        CommonTree LESS_EQ135_tree=null;
        CommonTree GREATER136_tree=null;
        CommonTree GREATER_EQ137_tree=null;

        try {
            // NRLConstraintRules.g:242:3: ( ( expression IS_IN )=> expression IS_IN listDefinition | ( expression IS_NOT_IN )=> expression IS_NOT_IN listDefinition | ( modelReference KIND_OF )=> isSubtypePredicate | ( FOLLOWING PRESENT )=> multipleExistsStatement | ( FOLLOWING NOT_PRESENT )=> multipleNotExistsStatement | expression ( ( EQUALS | NOT_EQUALS | LESS | LESS_EQ | GREATER | GREATER_EQ ) expression )? )
            int alt46=6;
            alt46 = dfa46.predict(input);
            switch (alt46) {
                case 1 :
                    // NRLConstraintRules.g:242:5: ( expression IS_IN )=> expression IS_IN listDefinition
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_expression_in_predicateStatement1284);
                    expression122=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, expression122.getTree());
                    IS_IN123=(Token)match(input,IS_IN,FOLLOW_IS_IN_in_predicateStatement1286); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    IS_IN123_tree = (CommonTree)adaptor.create(IS_IN123);
                    root_0 = (CommonTree)adaptor.becomeRoot(IS_IN123_tree, root_0);
                    }
                    pushFollow(FOLLOW_listDefinition_in_predicateStatement1289);
                    listDefinition124=listDefinition();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, listDefinition124.getTree());

                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:243:5: ( expression IS_NOT_IN )=> expression IS_NOT_IN listDefinition
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_expression_in_predicateStatement1303);
                    expression125=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, expression125.getTree());
                    IS_NOT_IN126=(Token)match(input,IS_NOT_IN,FOLLOW_IS_NOT_IN_in_predicateStatement1305); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    IS_NOT_IN126_tree = (CommonTree)adaptor.create(IS_NOT_IN126);
                    root_0 = (CommonTree)adaptor.becomeRoot(IS_NOT_IN126_tree, root_0);
                    }
                    pushFollow(FOLLOW_listDefinition_in_predicateStatement1308);
                    listDefinition127=listDefinition();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, listDefinition127.getTree());

                    }
                    break;
                case 3 :
                    // NRLConstraintRules.g:244:5: ( modelReference KIND_OF )=> isSubtypePredicate
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_isSubtypePredicate_in_predicateStatement1322);
                    isSubtypePredicate128=isSubtypePredicate();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, isSubtypePredicate128.getTree());

                    }
                    break;
                case 4 :
                    // NRLConstraintRules.g:245:5: ( FOLLOWING PRESENT )=> multipleExistsStatement
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_multipleExistsStatement_in_predicateStatement1336);
                    multipleExistsStatement129=multipleExistsStatement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, multipleExistsStatement129.getTree());

                    }
                    break;
                case 5 :
                    // NRLConstraintRules.g:246:5: ( FOLLOWING NOT_PRESENT )=> multipleNotExistsStatement
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_multipleNotExistsStatement_in_predicateStatement1350);
                    multipleNotExistsStatement130=multipleNotExistsStatement();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, multipleNotExistsStatement130.getTree());

                    }
                    break;
                case 6 :
                    // NRLConstraintRules.g:247:5: expression ( ( EQUALS | NOT_EQUALS | LESS | LESS_EQ | GREATER | GREATER_EQ ) expression )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_expression_in_predicateStatement1356);
                    expression131=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, expression131.getTree());
                    // NRLConstraintRules.g:247:16: ( ( EQUALS | NOT_EQUALS | LESS | LESS_EQ | GREATER | GREATER_EQ ) expression )?
                    int alt45=2;
                    switch ( input.LA(1) ) {
                        case EQUALS:
                            {
                            alt45=1;
                            }
                            break;
                        case NOT_EQUALS:
                            {
                            alt45=1;
                            }
                            break;
                        case LESS:
                            {
                            alt45=1;
                            }
                            break;
                        case LESS_EQ:
                            {
                            alt45=1;
                            }
                            break;
                        case GREATER:
                            {
                            alt45=1;
                            }
                            break;
                        case GREATER_EQ:
                            {
                            alt45=1;
                            }
                            break;
                    }

                    switch (alt45) {
                        case 1 :
                            // NRLConstraintRules.g:247:17: ( EQUALS | NOT_EQUALS | LESS | LESS_EQ | GREATER | GREATER_EQ ) expression
                            {
                            // NRLConstraintRules.g:247:17: ( EQUALS | NOT_EQUALS | LESS | LESS_EQ | GREATER | GREATER_EQ )
                            int alt44=6;
                            switch ( input.LA(1) ) {
                            case EQUALS:
                                {
                                alt44=1;
                                }
                                break;
                            case NOT_EQUALS:
                                {
                                alt44=2;
                                }
                                break;
                            case LESS:
                                {
                                alt44=3;
                                }
                                break;
                            case LESS_EQ:
                                {
                                alt44=4;
                                }
                                break;
                            case GREATER:
                                {
                                alt44=5;
                                }
                                break;
                            case GREATER_EQ:
                                {
                                alt44=6;
                                }
                                break;
                            default:
                                if (state.backtracking>0) {state.failed=true; return retval;}
                                NoViableAltException nvae =
                                    new NoViableAltException("", 44, 0, input);

                                throw nvae;
                            }

                            switch (alt44) {
                                case 1 :
                                    // NRLConstraintRules.g:248:9: EQUALS
                                    {
                                    EQUALS132=(Token)match(input,EQUALS,FOLLOW_EQUALS_in_predicateStatement1369); if (state.failed) return retval;
                                    if ( state.backtracking==0 ) {
                                    EQUALS132_tree = (CommonTree)adaptor.create(EQUALS132);
                                    root_0 = (CommonTree)adaptor.becomeRoot(EQUALS132_tree, root_0);
                                    }

                                    }
                                    break;
                                case 2 :
                                    // NRLConstraintRules.g:249:9: NOT_EQUALS
                                    {
                                    NOT_EQUALS133=(Token)match(input,NOT_EQUALS,FOLLOW_NOT_EQUALS_in_predicateStatement1380); if (state.failed) return retval;
                                    if ( state.backtracking==0 ) {
                                    NOT_EQUALS133_tree = (CommonTree)adaptor.create(NOT_EQUALS133);
                                    root_0 = (CommonTree)adaptor.becomeRoot(NOT_EQUALS133_tree, root_0);
                                    }

                                    }
                                    break;
                                case 3 :
                                    // NRLConstraintRules.g:250:9: LESS
                                    {
                                    LESS134=(Token)match(input,LESS,FOLLOW_LESS_in_predicateStatement1391); if (state.failed) return retval;
                                    if ( state.backtracking==0 ) {
                                    LESS134_tree = (CommonTree)adaptor.create(LESS134);
                                    root_0 = (CommonTree)adaptor.becomeRoot(LESS134_tree, root_0);
                                    }

                                    }
                                    break;
                                case 4 :
                                    // NRLConstraintRules.g:251:9: LESS_EQ
                                    {
                                    LESS_EQ135=(Token)match(input,LESS_EQ,FOLLOW_LESS_EQ_in_predicateStatement1402); if (state.failed) return retval;
                                    if ( state.backtracking==0 ) {
                                    LESS_EQ135_tree = (CommonTree)adaptor.create(LESS_EQ135);
                                    root_0 = (CommonTree)adaptor.becomeRoot(LESS_EQ135_tree, root_0);
                                    }

                                    }
                                    break;
                                case 5 :
                                    // NRLConstraintRules.g:252:9: GREATER
                                    {
                                    GREATER136=(Token)match(input,GREATER,FOLLOW_GREATER_in_predicateStatement1413); if (state.failed) return retval;
                                    if ( state.backtracking==0 ) {
                                    GREATER136_tree = (CommonTree)adaptor.create(GREATER136);
                                    root_0 = (CommonTree)adaptor.becomeRoot(GREATER136_tree, root_0);
                                    }

                                    }
                                    break;
                                case 6 :
                                    // NRLConstraintRules.g:253:9: GREATER_EQ
                                    {
                                    GREATER_EQ137=(Token)match(input,GREATER_EQ,FOLLOW_GREATER_EQ_in_predicateStatement1424); if (state.failed) return retval;
                                    if ( state.backtracking==0 ) {
                                    GREATER_EQ137_tree = (CommonTree)adaptor.create(GREATER_EQ137);
                                    root_0 = (CommonTree)adaptor.becomeRoot(GREATER_EQ137_tree, root_0);
                                    }

                                    }
                                    break;

                            }

                            pushFollow(FOLLOW_expression_in_predicateStatement1438);
                            expression138=expression();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) adaptor.addChild(root_0, expression138.getTree());

                            }
                            break;

                    }


                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "predicateStatement"

    public static class listDefinition_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "listDefinition"
    // NRLConstraintRules.g:262:1: listDefinition : identifier ( COMMA identifier )* ;
    public final NRLActionParser_NRLConstraintRules.listDefinition_return listDefinition() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.listDefinition_return retval = new NRLActionParser_NRLConstraintRules.listDefinition_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token COMMA140=null;
        NRLActionParser_NRLConstraintRules.identifier_return identifier139 = null;

        NRLActionParser_NRLConstraintRules.identifier_return identifier141 = null;


        CommonTree COMMA140_tree=null;

        try {
            // NRLConstraintRules.g:263:3: ( identifier ( COMMA identifier )* )
            // NRLConstraintRules.g:263:5: identifier ( COMMA identifier )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_identifier_in_listDefinition1459);
            identifier139=identifier();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, identifier139.getTree());
            // NRLConstraintRules.g:263:16: ( COMMA identifier )*
            loop47:
            do {
                int alt47=2;
                alt47 = dfa47.predict(input);
                switch (alt47) {
            	case 1 :
            	    // NRLConstraintRules.g:264:5: COMMA identifier
            	    {
            	    COMMA140=(Token)match(input,COMMA,FOLLOW_COMMA_in_listDefinition1467); if (state.failed) return retval;
            	    pushFollow(FOLLOW_identifier_in_listDefinition1475);
            	    identifier141=identifier();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, identifier141.getTree());

            	    }
            	    break;

            	default :
            	    break loop47;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "listDefinition"

    public static class isSubtypePredicate_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "isSubtypePredicate"
    // NRLConstraintRules.g:269:1: isSubtypePredicate : modelReference KIND_OF modelReference ;
    public final NRLActionParser_NRLConstraintRules.isSubtypePredicate_return isSubtypePredicate() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.isSubtypePredicate_return retval = new NRLActionParser_NRLConstraintRules.isSubtypePredicate_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token KIND_OF143=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference142 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference144 = null;


        CommonTree KIND_OF143_tree=null;

        try {
            // NRLConstraintRules.g:270:3: ( modelReference KIND_OF modelReference )
            // NRLConstraintRules.g:270:5: modelReference KIND_OF modelReference
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_modelReference_in_isSubtypePredicate1494);
            modelReference142=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference142.getTree());
            KIND_OF143=(Token)match(input,KIND_OF,FOLLOW_KIND_OF_in_isSubtypePredicate1496); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            KIND_OF143_tree = (CommonTree)adaptor.create(KIND_OF143);
            root_0 = (CommonTree)adaptor.becomeRoot(KIND_OF143_tree, root_0);
            }
            pushFollow(FOLLOW_modelReference_in_isSubtypePredicate1499);
            modelReference144=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference144.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "isSubtypePredicate"

    public static class multipleExistsStatement_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "multipleExistsStatement"
    // NRLConstraintRules.g:273:1: multipleExistsStatement : FOLLOWING PRESENT COLON modelReferenceList -> ^( VT_MULTIPLE_EXISTS modelReferenceList ) ;
    public final NRLActionParser_NRLConstraintRules.multipleExistsStatement_return multipleExistsStatement() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.multipleExistsStatement_return retval = new NRLActionParser_NRLConstraintRules.multipleExistsStatement_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token FOLLOWING145=null;
        Token PRESENT146=null;
        Token COLON147=null;
        NRLActionParser_NRLConstraintRules.modelReferenceList_return modelReferenceList148 = null;


        CommonTree FOLLOWING145_tree=null;
        CommonTree PRESENT146_tree=null;
        CommonTree COLON147_tree=null;
        RewriteRuleTokenStream stream_COLON=new RewriteRuleTokenStream(adaptor,"token COLON");
        RewriteRuleTokenStream stream_FOLLOWING=new RewriteRuleTokenStream(adaptor,"token FOLLOWING");
        RewriteRuleTokenStream stream_PRESENT=new RewriteRuleTokenStream(adaptor,"token PRESENT");
        RewriteRuleSubtreeStream stream_modelReferenceList=new RewriteRuleSubtreeStream(adaptor,"rule modelReferenceList");
        try {
            // NRLConstraintRules.g:275:3: ( FOLLOWING PRESENT COLON modelReferenceList -> ^( VT_MULTIPLE_EXISTS modelReferenceList ) )
            // NRLConstraintRules.g:275:5: FOLLOWING PRESENT COLON modelReferenceList
            {
            FOLLOWING145=(Token)match(input,FOLLOWING,FOLLOW_FOLLOWING_in_multipleExistsStatement1519); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_FOLLOWING.add(FOLLOWING145);

            PRESENT146=(Token)match(input,PRESENT,FOLLOW_PRESENT_in_multipleExistsStatement1521); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_PRESENT.add(PRESENT146);

            COLON147=(Token)match(input,COLON,FOLLOW_COLON_in_multipleExistsStatement1523); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_COLON.add(COLON147);

            pushFollow(FOLLOW_modelReferenceList_in_multipleExistsStatement1525);
            modelReferenceList148=modelReferenceList();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_modelReferenceList.add(modelReferenceList148.getTree());


            // AST REWRITE
            // elements: modelReferenceList
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 276:4: -> ^( VT_MULTIPLE_EXISTS modelReferenceList )
            {
                // NRLConstraintRules.g:276:7: ^( VT_MULTIPLE_EXISTS modelReferenceList )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_MULTIPLE_EXISTS, "VT_MULTIPLE_EXISTS"), root_1);

                adaptor.addChild(root_1, stream_modelReferenceList.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "multipleExistsStatement"

    public static class multipleNotExistsStatement_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "multipleNotExistsStatement"
    // NRLConstraintRules.g:279:1: multipleNotExistsStatement : FOLLOWING NOT_PRESENT COLON modelReferenceList -> ^( VT_MULTIPLE_NOTEXISTS modelReferenceList ) ;
    public final NRLActionParser_NRLConstraintRules.multipleNotExistsStatement_return multipleNotExistsStatement() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.multipleNotExistsStatement_return retval = new NRLActionParser_NRLConstraintRules.multipleNotExistsStatement_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token FOLLOWING149=null;
        Token NOT_PRESENT150=null;
        Token COLON151=null;
        NRLActionParser_NRLConstraintRules.modelReferenceList_return modelReferenceList152 = null;


        CommonTree FOLLOWING149_tree=null;
        CommonTree NOT_PRESENT150_tree=null;
        CommonTree COLON151_tree=null;
        RewriteRuleTokenStream stream_COLON=new RewriteRuleTokenStream(adaptor,"token COLON");
        RewriteRuleTokenStream stream_NOT_PRESENT=new RewriteRuleTokenStream(adaptor,"token NOT_PRESENT");
        RewriteRuleTokenStream stream_FOLLOWING=new RewriteRuleTokenStream(adaptor,"token FOLLOWING");
        RewriteRuleSubtreeStream stream_modelReferenceList=new RewriteRuleSubtreeStream(adaptor,"rule modelReferenceList");
        try {
            // NRLConstraintRules.g:281:3: ( FOLLOWING NOT_PRESENT COLON modelReferenceList -> ^( VT_MULTIPLE_NOTEXISTS modelReferenceList ) )
            // NRLConstraintRules.g:281:5: FOLLOWING NOT_PRESENT COLON modelReferenceList
            {
            FOLLOWING149=(Token)match(input,FOLLOWING,FOLLOW_FOLLOWING_in_multipleNotExistsStatement1554); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_FOLLOWING.add(FOLLOWING149);

            NOT_PRESENT150=(Token)match(input,NOT_PRESENT,FOLLOW_NOT_PRESENT_in_multipleNotExistsStatement1556); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_NOT_PRESENT.add(NOT_PRESENT150);

            COLON151=(Token)match(input,COLON,FOLLOW_COLON_in_multipleNotExistsStatement1558); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_COLON.add(COLON151);

            pushFollow(FOLLOW_modelReferenceList_in_multipleNotExistsStatement1560);
            modelReferenceList152=modelReferenceList();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_modelReferenceList.add(modelReferenceList152.getTree());


            // AST REWRITE
            // elements: modelReferenceList
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 282:4: -> ^( VT_MULTIPLE_NOTEXISTS modelReferenceList )
            {
                // NRLConstraintRules.g:282:7: ^( VT_MULTIPLE_NOTEXISTS modelReferenceList )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_MULTIPLE_NOTEXISTS, "VT_MULTIPLE_NOTEXISTS"), root_1);

                adaptor.addChild(root_1, stream_modelReferenceList.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               initialisePositionFromChild(retval.tree, 0); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "multipleNotExistsStatement"

    public static class expression_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "expression"
    // NRLConstraintRules.g:285:1: expression : addExpression ;
    public final NRLActionParser_NRLConstraintRules.expression_return expression() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.expression_return retval = new NRLActionParser_NRLConstraintRules.expression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser_NRLConstraintRules.addExpression_return addExpression153 = null;



        try {
            // NRLConstraintRules.g:286:3: ( addExpression )
            // NRLConstraintRules.g:286:5: addExpression
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_addExpression_in_expression1584);
            addExpression153=addExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, addExpression153.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "expression"

    public static class addExpression_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "addExpression"
    // NRLConstraintRules.g:296:1: addExpression : multiplyExpression ( options {greedy=true; } : ( ADD | MINUS ) multiplyExpression )* ;
    public final NRLActionParser_NRLConstraintRules.addExpression_return addExpression() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.addExpression_return retval = new NRLActionParser_NRLConstraintRules.addExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token ADD155=null;
        Token MINUS156=null;
        NRLActionParser_NRLConstraintRules.multiplyExpression_return multiplyExpression154 = null;

        NRLActionParser_NRLConstraintRules.multiplyExpression_return multiplyExpression157 = null;


        CommonTree ADD155_tree=null;
        CommonTree MINUS156_tree=null;

        try {
            // NRLConstraintRules.g:302:3: ( multiplyExpression ( options {greedy=true; } : ( ADD | MINUS ) multiplyExpression )* )
            // NRLConstraintRules.g:302:5: multiplyExpression ( options {greedy=true; } : ( ADD | MINUS ) multiplyExpression )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_multiplyExpression_in_addExpression1604);
            multiplyExpression154=multiplyExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, multiplyExpression154.getTree());
            // NRLConstraintRules.g:303:4: ( options {greedy=true; } : ( ADD | MINUS ) multiplyExpression )*
            loop49:
            do {
                int alt49=2;
                switch ( input.LA(1) ) {
                case MINUS:
                    {
                    alt49=1;
                    }
                    break;
                case ADD:
                    {
                    alt49=1;
                    }
                    break;

                }

                switch (alt49) {
            	case 1 :
            	    // NRLConstraintRules.g:307:5: ( ADD | MINUS ) multiplyExpression
            	    {
            	    // NRLConstraintRules.g:307:5: ( ADD | MINUS )
            	    int alt48=2;
            	    switch ( input.LA(1) ) {
            	    case ADD:
            	        {
            	        alt48=1;
            	        }
            	        break;
            	    case MINUS:
            	        {
            	        alt48=2;
            	        }
            	        break;
            	    default:
            	        if (state.backtracking>0) {state.failed=true; return retval;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 48, 0, input);

            	        throw nvae;
            	    }

            	    switch (alt48) {
            	        case 1 :
            	            // NRLConstraintRules.g:307:6: ADD
            	            {
            	            ADD155=(Token)match(input,ADD,FOLLOW_ADD_in_addExpression1646); if (state.failed) return retval;
            	            if ( state.backtracking==0 ) {
            	            ADD155_tree = (CommonTree)adaptor.create(ADD155);
            	            root_0 = (CommonTree)adaptor.becomeRoot(ADD155_tree, root_0);
            	            }

            	            }
            	            break;
            	        case 2 :
            	            // NRLConstraintRules.g:307:13: MINUS
            	            {
            	            MINUS156=(Token)match(input,MINUS,FOLLOW_MINUS_in_addExpression1651); if (state.failed) return retval;
            	            if ( state.backtracking==0 ) {
            	            MINUS156_tree = (CommonTree)adaptor.create(MINUS156);
            	            root_0 = (CommonTree)adaptor.becomeRoot(MINUS156_tree, root_0);
            	            }

            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_multiplyExpression_in_addExpression1660);
            	    multiplyExpression157=multiplyExpression();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, multiplyExpression157.getTree());

            	    }
            	    break;

            	default :
            	    break loop49;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               
              	if (retval.tree instanceof IArithmeticExpression && retval.tree.getChildCount() == 2) {
              		validateChildType(retval.tree, IExpression.class);
              	}

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "addExpression"

    public static class multiplyExpression_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "multiplyExpression"
    // NRLConstraintRules.g:312:1: multiplyExpression : infixOperatorExpression ( options {greedy=true; } : ( TIMES | DIV | MOD ) infixOperatorExpression )* ;
    public final NRLActionParser_NRLConstraintRules.multiplyExpression_return multiplyExpression() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.multiplyExpression_return retval = new NRLActionParser_NRLConstraintRules.multiplyExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token TIMES159=null;
        Token DIV160=null;
        Token MOD161=null;
        NRLActionParser_NRLConstraintRules.infixOperatorExpression_return infixOperatorExpression158 = null;

        NRLActionParser_NRLConstraintRules.infixOperatorExpression_return infixOperatorExpression162 = null;


        CommonTree TIMES159_tree=null;
        CommonTree DIV160_tree=null;
        CommonTree MOD161_tree=null;

        try {
            // NRLConstraintRules.g:313:3: ( infixOperatorExpression ( options {greedy=true; } : ( TIMES | DIV | MOD ) infixOperatorExpression )* )
            // NRLConstraintRules.g:313:5: infixOperatorExpression ( options {greedy=true; } : ( TIMES | DIV | MOD ) infixOperatorExpression )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_infixOperatorExpression_in_multiplyExpression1681);
            infixOperatorExpression158=infixOperatorExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, infixOperatorExpression158.getTree());
            // NRLConstraintRules.g:314:4: ( options {greedy=true; } : ( TIMES | DIV | MOD ) infixOperatorExpression )*
            loop51:
            do {
                int alt51=2;
                switch ( input.LA(1) ) {
                case TIMES:
                    {
                    alt51=1;
                    }
                    break;
                case DIV:
                    {
                    alt51=1;
                    }
                    break;
                case MOD:
                    {
                    alt51=1;
                    }
                    break;

                }

                switch (alt51) {
            	case 1 :
            	    // NRLConstraintRules.g:318:5: ( TIMES | DIV | MOD ) infixOperatorExpression
            	    {
            	    // NRLConstraintRules.g:318:5: ( TIMES | DIV | MOD )
            	    int alt50=3;
            	    switch ( input.LA(1) ) {
            	    case TIMES:
            	        {
            	        alt50=1;
            	        }
            	        break;
            	    case DIV:
            	        {
            	        alt50=2;
            	        }
            	        break;
            	    case MOD:
            	        {
            	        alt50=3;
            	        }
            	        break;
            	    default:
            	        if (state.backtracking>0) {state.failed=true; return retval;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 50, 0, input);

            	        throw nvae;
            	    }

            	    switch (alt50) {
            	        case 1 :
            	            // NRLConstraintRules.g:318:6: TIMES
            	            {
            	            TIMES159=(Token)match(input,TIMES,FOLLOW_TIMES_in_multiplyExpression1723); if (state.failed) return retval;
            	            if ( state.backtracking==0 ) {
            	            TIMES159_tree = (CommonTree)adaptor.create(TIMES159);
            	            root_0 = (CommonTree)adaptor.becomeRoot(TIMES159_tree, root_0);
            	            }

            	            }
            	            break;
            	        case 2 :
            	            // NRLConstraintRules.g:318:13: DIV
            	            {
            	            DIV160=(Token)match(input,DIV,FOLLOW_DIV_in_multiplyExpression1726); if (state.failed) return retval;
            	            if ( state.backtracking==0 ) {
            	            DIV160_tree = (CommonTree)adaptor.create(DIV160);
            	            root_0 = (CommonTree)adaptor.becomeRoot(DIV160_tree, root_0);
            	            }

            	            }
            	            break;
            	        case 3 :
            	            // NRLConstraintRules.g:318:18: MOD
            	            {
            	            MOD161=(Token)match(input,MOD,FOLLOW_MOD_in_multiplyExpression1729); if (state.failed) return retval;
            	            if ( state.backtracking==0 ) {
            	            MOD161_tree = (CommonTree)adaptor.create(MOD161);
            	            root_0 = (CommonTree)adaptor.becomeRoot(MOD161_tree, root_0);
            	            }

            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_infixOperatorExpression_in_multiplyExpression1738);
            	    infixOperatorExpression162=infixOperatorExpression();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, infixOperatorExpression162.getTree());

            	    }
            	    break;

            	default :
            	    break loop51;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "multiplyExpression"

    public static class infixOperatorExpression_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "infixOperatorExpression"
    // NRLConstraintRules.g:323:1: infixOperatorExpression : infixPropertyApplication ( options {greedy=true; } : OPERATOR infixPropertyApplication )* ;
    public final NRLActionParser_NRLConstraintRules.infixOperatorExpression_return infixOperatorExpression() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.infixOperatorExpression_return retval = new NRLActionParser_NRLConstraintRules.infixOperatorExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token OPERATOR164=null;
        NRLActionParser_NRLConstraintRules.infixPropertyApplication_return infixPropertyApplication163 = null;

        NRLActionParser_NRLConstraintRules.infixPropertyApplication_return infixPropertyApplication165 = null;


        CommonTree OPERATOR164_tree=null;

        try {
            // NRLConstraintRules.g:324:3: ( infixPropertyApplication ( options {greedy=true; } : OPERATOR infixPropertyApplication )* )
            // NRLConstraintRules.g:324:5: infixPropertyApplication ( options {greedy=true; } : OPERATOR infixPropertyApplication )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_infixPropertyApplication_in_infixOperatorExpression1764);
            infixPropertyApplication163=infixPropertyApplication();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, infixPropertyApplication163.getTree());
            // NRLConstraintRules.g:324:30: ( options {greedy=true; } : OPERATOR infixPropertyApplication )*
            loop52:
            do {
                int alt52=2;
                switch ( input.LA(1) ) {
                case OPERATOR:
                    {
                    alt52=1;
                    }
                    break;

                }

                switch (alt52) {
            	case 1 :
            	    // NRLConstraintRules.g:328:5: OPERATOR infixPropertyApplication
            	    {
            	    OPERATOR164=(Token)match(input,OPERATOR,FOLLOW_OPERATOR_in_infixOperatorExpression1798); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    OPERATOR164_tree = (CommonTree)adaptor.create(OPERATOR164);
            	    root_0 = (CommonTree)adaptor.becomeRoot(OPERATOR164_tree, root_0);
            	    }
            	    pushFollow(FOLLOW_infixPropertyApplication_in_infixOperatorExpression1801);
            	    infixPropertyApplication165=infixPropertyApplication();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, infixPropertyApplication165.getTree());

            	    }
            	    break;

            	default :
            	    break loop52;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "infixOperatorExpression"

    public static class infixPropertyApplication_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "infixPropertyApplication"
    // NRLConstraintRules.g:332:1: infixPropertyApplication : term ( options {greedy=true; } : PROPERTYNAME term )* ;
    public final NRLActionParser_NRLConstraintRules.infixPropertyApplication_return infixPropertyApplication() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.infixPropertyApplication_return retval = new NRLActionParser_NRLConstraintRules.infixPropertyApplication_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token PROPERTYNAME167=null;
        NRLActionParser_NRLConstraintRules.term_return term166 = null;

        NRLActionParser_NRLConstraintRules.term_return term168 = null;


        CommonTree PROPERTYNAME167_tree=null;

        try {
            // NRLConstraintRules.g:333:3: ( term ( options {greedy=true; } : PROPERTYNAME term )* )
            // NRLConstraintRules.g:333:5: term ( options {greedy=true; } : PROPERTYNAME term )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_term_in_infixPropertyApplication1820);
            term166=term();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, term166.getTree());
            // NRLConstraintRules.g:333:10: ( options {greedy=true; } : PROPERTYNAME term )*
            loop53:
            do {
                int alt53=2;
                switch ( input.LA(1) ) {
                case PROPERTYNAME:
                    {
                    alt53=1;
                    }
                    break;

                }

                switch (alt53) {
            	case 1 :
            	    // NRLConstraintRules.g:337:5: PROPERTYNAME term
            	    {
            	    PROPERTYNAME167=(Token)match(input,PROPERTYNAME,FOLLOW_PROPERTYNAME_in_infixPropertyApplication1854); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    PROPERTYNAME167_tree = (CommonTree)adaptor.create(PROPERTYNAME167);
            	    root_0 = (CommonTree)adaptor.becomeRoot(PROPERTYNAME167_tree, root_0);
            	    }
            	    pushFollow(FOLLOW_term_in_infixPropertyApplication1857);
            	    term168=term();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, term168.getTree());

            	    }
            	    break;

            	default :
            	    break loop53;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "infixPropertyApplication"

    public static class term_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "term"
    // NRLConstraintRules.g:341:1: term : ( ( OPERATOR )=> operatorInvocation | ( PROPERTYNAME )=> propertyApplication | ( modelReference AS_A )=> castExpression | ( modelReference WHERE )=> selectionExpression | ( FIRST modelReference WHERE )=> selectionExpression | ( FIRST OF modelReference WHERE )=> selectionExpression | LPAREN constraint RPAREN | functionalExpression | identifier );
    public final NRLActionParser_NRLConstraintRules.term_return term() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.term_return retval = new NRLActionParser_NRLConstraintRules.term_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token LPAREN175=null;
        Token RPAREN177=null;
        NRLActionParser_NRLConstraintRules.operatorInvocation_return operatorInvocation169 = null;

        NRLActionParser_NRLConstraintRules.propertyApplication_return propertyApplication170 = null;

        NRLActionParser_NRLConstraintRules.castExpression_return castExpression171 = null;

        NRLActionParser_NRLConstraintRules.selectionExpression_return selectionExpression172 = null;

        NRLActionParser_NRLConstraintRules.selectionExpression_return selectionExpression173 = null;

        NRLActionParser_NRLConstraintRules.selectionExpression_return selectionExpression174 = null;

        NRLActionParser_NRLConstraintRules.constraint_return constraint176 = null;

        NRLActionParser_NRLConstraintRules.functionalExpression_return functionalExpression178 = null;

        NRLActionParser_NRLConstraintRules.identifier_return identifier179 = null;


        CommonTree LPAREN175_tree=null;
        CommonTree RPAREN177_tree=null;

        try {
            // NRLConstraintRules.g:342:3: ( ( OPERATOR )=> operatorInvocation | ( PROPERTYNAME )=> propertyApplication | ( modelReference AS_A )=> castExpression | ( modelReference WHERE )=> selectionExpression | ( FIRST modelReference WHERE )=> selectionExpression | ( FIRST OF modelReference WHERE )=> selectionExpression | LPAREN constraint RPAREN | functionalExpression | identifier )
            int alt54=9;
            alt54 = dfa54.predict(input);
            switch (alt54) {
                case 1 :
                    // NRLConstraintRules.g:342:5: ( OPERATOR )=> operatorInvocation
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_operatorInvocation_in_term1884);
                    operatorInvocation169=operatorInvocation();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, operatorInvocation169.getTree());

                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:343:5: ( PROPERTYNAME )=> propertyApplication
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_propertyApplication_in_term1896);
                    propertyApplication170=propertyApplication();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, propertyApplication170.getTree());

                    }
                    break;
                case 3 :
                    // NRLConstraintRules.g:344:5: ( modelReference AS_A )=> castExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_castExpression_in_term1910);
                    castExpression171=castExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, castExpression171.getTree());

                    }
                    break;
                case 4 :
                    // NRLConstraintRules.g:345:5: ( modelReference WHERE )=> selectionExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_selectionExpression_in_term1924);
                    selectionExpression172=selectionExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, selectionExpression172.getTree());

                    }
                    break;
                case 5 :
                    // NRLConstraintRules.g:346:5: ( FIRST modelReference WHERE )=> selectionExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_selectionExpression_in_term1940);
                    selectionExpression173=selectionExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, selectionExpression173.getTree());

                    }
                    break;
                case 6 :
                    // NRLConstraintRules.g:347:5: ( FIRST OF modelReference WHERE )=> selectionExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_selectionExpression_in_term1958);
                    selectionExpression174=selectionExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, selectionExpression174.getTree());

                    }
                    break;
                case 7 :
                    // NRLConstraintRules.g:348:5: LPAREN constraint RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    LPAREN175=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_term1966); if (state.failed) return retval;
                    pushFollow(FOLLOW_constraint_in_term1969);
                    constraint176=constraint();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, constraint176.getTree());
                    RPAREN177=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_term1971); if (state.failed) return retval;

                    }
                    break;
                case 8 :
                    // NRLConstraintRules.g:349:5: functionalExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_functionalExpression_in_term1978);
                    functionalExpression178=functionalExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, functionalExpression178.getTree());

                    }
                    break;
                case 9 :
                    // NRLConstraintRules.g:350:5: identifier
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_identifier_in_term1984);
                    identifier179=identifier();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, identifier179.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "term"

    public static class simpleTerm_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "simpleTerm"
    // NRLConstraintRules.g:354:1: simpleTerm : ( ( OPERATOR )=> operatorInvocation | functionalExpression | identifier );
    public final NRLActionParser_NRLConstraintRules.simpleTerm_return simpleTerm() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.simpleTerm_return retval = new NRLActionParser_NRLConstraintRules.simpleTerm_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser_NRLConstraintRules.operatorInvocation_return operatorInvocation180 = null;

        NRLActionParser_NRLConstraintRules.functionalExpression_return functionalExpression181 = null;

        NRLActionParser_NRLConstraintRules.identifier_return identifier182 = null;



        try {
            // NRLConstraintRules.g:355:3: ( ( OPERATOR )=> operatorInvocation | functionalExpression | identifier )
            int alt55=3;
            int LA55_0 = input.LA(1);

            if ( (LA55_0==OPERATOR) && (synpred23_NRLConstraintRules())) {
                alt55=1;
            }
            else if ( ((LA55_0>=SUM_OF && LA55_0<=NUMBER_OF)) ) {
                alt55=2;
            }
            else if ( (LA55_0==INTEGER_NUMBER||LA55_0==MINUS||(LA55_0>=FIRST && LA55_0<=IDENTIFIER)) ) {
                alt55=3;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 55, 0, input);

                throw nvae;
            }
            switch (alt55) {
                case 1 :
                    // NRLConstraintRules.g:355:5: ( OPERATOR )=> operatorInvocation
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_operatorInvocation_in_simpleTerm2005);
                    operatorInvocation180=operatorInvocation();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, operatorInvocation180.getTree());

                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:356:5: functionalExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_functionalExpression_in_simpleTerm2011);
                    functionalExpression181=functionalExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, functionalExpression181.getTree());

                    }
                    break;
                case 3 :
                    // NRLConstraintRules.g:357:5: identifier
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_identifier_in_simpleTerm2017);
                    identifier182=identifier();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, identifier182.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "simpleTerm"

    public static class operatorInvocation_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "operatorInvocation"
    // NRLConstraintRules.g:365:1: operatorInvocation : OPERATOR ( operatorParameterList )? ;
    public final NRLActionParser_NRLConstraintRules.operatorInvocation_return operatorInvocation() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.operatorInvocation_return retval = new NRLActionParser_NRLConstraintRules.operatorInvocation_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token OPERATOR183=null;
        NRLActionParser_NRLConstraintRules.operatorParameterList_return operatorParameterList184 = null;


        CommonTree OPERATOR183_tree=null;

        try {
            // NRLConstraintRules.g:366:3: ( OPERATOR ( operatorParameterList )? )
            // NRLConstraintRules.g:366:5: OPERATOR ( operatorParameterList )?
            {
            root_0 = (CommonTree)adaptor.nil();

            OPERATOR183=(Token)match(input,OPERATOR,FOLLOW_OPERATOR_in_operatorInvocation2034); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            OPERATOR183_tree = (CommonTree)adaptor.create(OPERATOR183);
            root_0 = (CommonTree)adaptor.becomeRoot(OPERATOR183_tree, root_0);
            }
            // NRLConstraintRules.g:367:4: ( operatorParameterList )?
            int alt56=2;
            alt56 = dfa56.predict(input);
            switch (alt56) {
                case 1 :
                    // NRLConstraintRules.g:368:5: operatorParameterList
                    {
                    pushFollow(FOLLOW_operatorParameterList_in_operatorInvocation2047);
                    operatorParameterList184=operatorParameterList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, operatorParameterList184.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "operatorInvocation"

    public static class operatorParameterList_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "operatorParameterList"
    // NRLConstraintRules.g:377:1: operatorParameterList : expression ( ( AND | FROM | TO | WITH | USING ) expression )* ;
    public final NRLActionParser_NRLConstraintRules.operatorParameterList_return operatorParameterList() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.operatorParameterList_return retval = new NRLActionParser_NRLConstraintRules.operatorParameterList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token AND186=null;
        Token FROM187=null;
        Token TO188=null;
        Token WITH189=null;
        Token USING190=null;
        NRLActionParser_NRLConstraintRules.expression_return expression185 = null;

        NRLActionParser_NRLConstraintRules.expression_return expression191 = null;


        CommonTree AND186_tree=null;
        CommonTree FROM187_tree=null;
        CommonTree TO188_tree=null;
        CommonTree WITH189_tree=null;
        CommonTree USING190_tree=null;

        try {
            // NRLConstraintRules.g:378:3: ( expression ( ( AND | FROM | TO | WITH | USING ) expression )* )
            // NRLConstraintRules.g:378:5: expression ( ( AND | FROM | TO | WITH | USING ) expression )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_expression_in_operatorParameterList2079);
            expression185=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, expression185.getTree());
            // NRLConstraintRules.g:378:16: ( ( AND | FROM | TO | WITH | USING ) expression )*
            loop58:
            do {
                int alt58=2;
                switch ( input.LA(1) ) {
                case AND:
                    {
                    alt58=1;
                    }
                    break;
                case FROM:
                    {
                    alt58=1;
                    }
                    break;
                case TO:
                    {
                    alt58=1;
                    }
                    break;
                case WITH:
                    {
                    alt58=1;
                    }
                    break;
                case USING:
                    {
                    alt58=1;
                    }
                    break;

                }

                switch (alt58) {
            	case 1 :
            	    // NRLConstraintRules.g:378:18: ( AND | FROM | TO | WITH | USING ) expression
            	    {
            	    // NRLConstraintRules.g:378:18: ( AND | FROM | TO | WITH | USING )
            	    int alt57=5;
            	    switch ( input.LA(1) ) {
            	    case AND:
            	        {
            	        alt57=1;
            	        }
            	        break;
            	    case FROM:
            	        {
            	        alt57=2;
            	        }
            	        break;
            	    case TO:
            	        {
            	        alt57=3;
            	        }
            	        break;
            	    case WITH:
            	        {
            	        alt57=4;
            	        }
            	        break;
            	    case USING:
            	        {
            	        alt57=5;
            	        }
            	        break;
            	    default:
            	        if (state.backtracking>0) {state.failed=true; return retval;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 57, 0, input);

            	        throw nvae;
            	    }

            	    switch (alt57) {
            	        case 1 :
            	            // NRLConstraintRules.g:378:19: AND
            	            {
            	            AND186=(Token)match(input,AND,FOLLOW_AND_in_operatorParameterList2084); if (state.failed) return retval;

            	            }
            	            break;
            	        case 2 :
            	            // NRLConstraintRules.g:378:24: FROM
            	            {
            	            FROM187=(Token)match(input,FROM,FOLLOW_FROM_in_operatorParameterList2087); if (state.failed) return retval;

            	            }
            	            break;
            	        case 3 :
            	            // NRLConstraintRules.g:378:30: TO
            	            {
            	            TO188=(Token)match(input,TO,FOLLOW_TO_in_operatorParameterList2090); if (state.failed) return retval;

            	            }
            	            break;
            	        case 4 :
            	            // NRLConstraintRules.g:378:34: WITH
            	            {
            	            WITH189=(Token)match(input,WITH,FOLLOW_WITH_in_operatorParameterList2093); if (state.failed) return retval;

            	            }
            	            break;
            	        case 5 :
            	            // NRLConstraintRules.g:378:40: USING
            	            {
            	            USING190=(Token)match(input,USING,FOLLOW_USING_in_operatorParameterList2096); if (state.failed) return retval;

            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_expression_in_operatorParameterList2100);
            	    expression191=expression();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, expression191.getTree());

            	    }
            	    break;

            	default :
            	    break loop58;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "operatorParameterList"

    public static class propertyApplication_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "propertyApplication"
    // NRLConstraintRules.g:381:1: propertyApplication : PROPERTYNAME ( operatorParameterList )? ;
    public final NRLActionParser_NRLConstraintRules.propertyApplication_return propertyApplication() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.propertyApplication_return retval = new NRLActionParser_NRLConstraintRules.propertyApplication_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token PROPERTYNAME192=null;
        NRLActionParser_NRLConstraintRules.operatorParameterList_return operatorParameterList193 = null;


        CommonTree PROPERTYNAME192_tree=null;

        try {
            // NRLConstraintRules.g:382:3: ( PROPERTYNAME ( operatorParameterList )? )
            // NRLConstraintRules.g:382:5: PROPERTYNAME ( operatorParameterList )?
            {
            root_0 = (CommonTree)adaptor.nil();

            PROPERTYNAME192=(Token)match(input,PROPERTYNAME,FOLLOW_PROPERTYNAME_in_propertyApplication2120); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            PROPERTYNAME192_tree = (CommonTree)adaptor.create(PROPERTYNAME192);
            root_0 = (CommonTree)adaptor.becomeRoot(PROPERTYNAME192_tree, root_0);
            }
            // NRLConstraintRules.g:382:19: ( operatorParameterList )?
            int alt59=2;
            alt59 = dfa59.predict(input);
            switch (alt59) {
                case 1 :
                    // NRLConstraintRules.g:382:19: operatorParameterList
                    {
                    pushFollow(FOLLOW_operatorParameterList_in_propertyApplication2123);
                    operatorParameterList193=operatorParameterList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, operatorParameterList193.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "propertyApplication"

    public static class functionalExpression_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "functionalExpression"
    // NRLConstraintRules.g:385:1: functionalExpression : ( SUM_OF modelReference | ( NUMBER_OF UNIQUE )=> NUMBER_OF UNIQUE modelReference ( LPAREN BY modelReference RPAREN )? | NUMBER_OF modelReference );
    public final NRLActionParser_NRLConstraintRules.functionalExpression_return functionalExpression() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.functionalExpression_return retval = new NRLActionParser_NRLConstraintRules.functionalExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token SUM_OF194=null;
        Token NUMBER_OF196=null;
        Token UNIQUE197=null;
        Token LPAREN199=null;
        Token BY200=null;
        Token RPAREN202=null;
        Token NUMBER_OF203=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference195 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference198 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference201 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference204 = null;


        CommonTree SUM_OF194_tree=null;
        CommonTree NUMBER_OF196_tree=null;
        CommonTree UNIQUE197_tree=null;
        CommonTree LPAREN199_tree=null;
        CommonTree BY200_tree=null;
        CommonTree RPAREN202_tree=null;
        CommonTree NUMBER_OF203_tree=null;

        try {
            // NRLConstraintRules.g:386:3: ( SUM_OF modelReference | ( NUMBER_OF UNIQUE )=> NUMBER_OF UNIQUE modelReference ( LPAREN BY modelReference RPAREN )? | NUMBER_OF modelReference )
            int alt61=3;
            switch ( input.LA(1) ) {
            case SUM_OF:
                {
                alt61=1;
                }
                break;
            case NUMBER_OF:
                {
                int LA61_2 = input.LA(2);

                if ( (LA61_2==UNIQUE) && (synpred24_NRLConstraintRules())) {
                    alt61=2;
                }
                else if ( (LA61_2==IDENTIFIER) ) {
                    alt61=3;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 61, 2, input);

                    throw nvae;
                }
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 61, 0, input);

                throw nvae;
            }

            switch (alt61) {
                case 1 :
                    // NRLConstraintRules.g:386:5: SUM_OF modelReference
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    SUM_OF194=(Token)match(input,SUM_OF,FOLLOW_SUM_OF_in_functionalExpression2141); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    SUM_OF194_tree = (CommonTree)adaptor.create(SUM_OF194);
                    root_0 = (CommonTree)adaptor.becomeRoot(SUM_OF194_tree, root_0);
                    }
                    pushFollow(FOLLOW_modelReference_in_functionalExpression2144);
                    modelReference195=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference195.getTree());

                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:387:5: ( NUMBER_OF UNIQUE )=> NUMBER_OF UNIQUE modelReference ( LPAREN BY modelReference RPAREN )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    NUMBER_OF196=(Token)match(input,NUMBER_OF,FOLLOW_NUMBER_OF_in_functionalExpression2158); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NUMBER_OF196_tree = (CommonTree)adaptor.create(NUMBER_OF196);
                    root_0 = (CommonTree)adaptor.becomeRoot(NUMBER_OF196_tree, root_0);
                    }
                    UNIQUE197=(Token)match(input,UNIQUE,FOLLOW_UNIQUE_in_functionalExpression2161); if (state.failed) return retval;
                    pushFollow(FOLLOW_modelReference_in_functionalExpression2164);
                    modelReference198=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference198.getTree());
                    // NRLConstraintRules.g:387:61: ( LPAREN BY modelReference RPAREN )?
                    int alt60=2;
                    switch ( input.LA(1) ) {
                        case LPAREN:
                            {
                            switch ( input.LA(2) ) {
                                case BY:
                                    {
                                    alt60=1;
                                    }
                                    break;
                            }

                            }
                            break;
                    }

                    switch (alt60) {
                        case 1 :
                            // NRLConstraintRules.g:387:63: LPAREN BY modelReference RPAREN
                            {
                            LPAREN199=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_functionalExpression2168); if (state.failed) return retval;
                            BY200=(Token)match(input,BY,FOLLOW_BY_in_functionalExpression2171); if (state.failed) return retval;
                            pushFollow(FOLLOW_modelReference_in_functionalExpression2174);
                            modelReference201=modelReference();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference201.getTree());
                            RPAREN202=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_functionalExpression2176); if (state.failed) return retval;

                            }
                            break;

                    }


                    }
                    break;
                case 3 :
                    // NRLConstraintRules.g:388:5: NUMBER_OF modelReference
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    NUMBER_OF203=(Token)match(input,NUMBER_OF,FOLLOW_NUMBER_OF_in_functionalExpression2186); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NUMBER_OF203_tree = (CommonTree)adaptor.create(NUMBER_OF203);
                    root_0 = (CommonTree)adaptor.becomeRoot(NUMBER_OF203_tree, root_0);
                    }
                    pushFollow(FOLLOW_modelReference_in_functionalExpression2189);
                    modelReference204=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference204.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "functionalExpression"

    public static class castExpression_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "castExpression"
    // NRLConstraintRules.g:391:1: castExpression : modelReference AS_A modelReference ;
    public final NRLActionParser_NRLConstraintRules.castExpression_return castExpression() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.castExpression_return retval = new NRLActionParser_NRLConstraintRules.castExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token AS_A206=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference205 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference207 = null;


        CommonTree AS_A206_tree=null;

        try {
            // NRLConstraintRules.g:392:3: ( modelReference AS_A modelReference )
            // NRLConstraintRules.g:392:5: modelReference AS_A modelReference
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_modelReference_in_castExpression2204);
            modelReference205=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference205.getTree());
            AS_A206=(Token)match(input,AS_A,FOLLOW_AS_A_in_castExpression2206); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            AS_A206_tree = (CommonTree)adaptor.create(AS_A206);
            root_0 = (CommonTree)adaptor.becomeRoot(AS_A206_tree, root_0);
            }
            pushFollow(FOLLOW_modelReference_in_castExpression2209);
            modelReference207=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference207.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "castExpression"

    public static class selectionExpression_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "selectionExpression"
    // NRLConstraintRules.g:395:1: selectionExpression : ( modelReference WHERE simpleOrComplexConstraint -> ^( VT_SELECTION_EXPR modelReference simpleOrComplexConstraint ) | FIRST ( OF )? modelReference WHERE simpleOrComplexConstraint -> ^( VT_SINGLE_SELECTION_EXPR modelReference simpleOrComplexConstraint ) );
    public final NRLActionParser_NRLConstraintRules.selectionExpression_return selectionExpression() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.selectionExpression_return retval = new NRLActionParser_NRLConstraintRules.selectionExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token WHERE209=null;
        Token FIRST211=null;
        Token OF212=null;
        Token WHERE214=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference208 = null;

        NRLActionParser_NRLConstraintRules.simpleOrComplexConstraint_return simpleOrComplexConstraint210 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference213 = null;

        NRLActionParser_NRLConstraintRules.simpleOrComplexConstraint_return simpleOrComplexConstraint215 = null;


        CommonTree WHERE209_tree=null;
        CommonTree FIRST211_tree=null;
        CommonTree OF212_tree=null;
        CommonTree WHERE214_tree=null;
        RewriteRuleTokenStream stream_WHERE=new RewriteRuleTokenStream(adaptor,"token WHERE");
        RewriteRuleTokenStream stream_OF=new RewriteRuleTokenStream(adaptor,"token OF");
        RewriteRuleTokenStream stream_FIRST=new RewriteRuleTokenStream(adaptor,"token FIRST");
        RewriteRuleSubtreeStream stream_simpleOrComplexConstraint=new RewriteRuleSubtreeStream(adaptor,"rule simpleOrComplexConstraint");
        RewriteRuleSubtreeStream stream_modelReference=new RewriteRuleSubtreeStream(adaptor,"rule modelReference");
        try {
            // NRLConstraintRules.g:396:3: ( modelReference WHERE simpleOrComplexConstraint -> ^( VT_SELECTION_EXPR modelReference simpleOrComplexConstraint ) | FIRST ( OF )? modelReference WHERE simpleOrComplexConstraint -> ^( VT_SINGLE_SELECTION_EXPR modelReference simpleOrComplexConstraint ) )
            int alt63=2;
            switch ( input.LA(1) ) {
            case IDENTIFIER:
                {
                alt63=1;
                }
                break;
            case FIRST:
                {
                alt63=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 63, 0, input);

                throw nvae;
            }

            switch (alt63) {
                case 1 :
                    // NRLConstraintRules.g:396:5: modelReference WHERE simpleOrComplexConstraint
                    {
                    pushFollow(FOLLOW_modelReference_in_selectionExpression2224);
                    modelReference208=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_modelReference.add(modelReference208.getTree());
                    WHERE209=(Token)match(input,WHERE,FOLLOW_WHERE_in_selectionExpression2226); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_WHERE.add(WHERE209);

                    pushFollow(FOLLOW_simpleOrComplexConstraint_in_selectionExpression2228);
                    simpleOrComplexConstraint210=simpleOrComplexConstraint();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_simpleOrComplexConstraint.add(simpleOrComplexConstraint210.getTree());


                    // AST REWRITE
                    // elements: modelReference, simpleOrComplexConstraint
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 397:4: -> ^( VT_SELECTION_EXPR modelReference simpleOrComplexConstraint )
                    {
                        // NRLConstraintRules.g:397:7: ^( VT_SELECTION_EXPR modelReference simpleOrComplexConstraint )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_SELECTION_EXPR, "VT_SELECTION_EXPR"), root_1);

                        adaptor.addChild(root_1, stream_modelReference.nextTree());
                        adaptor.addChild(root_1, stream_simpleOrComplexConstraint.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:398:5: FIRST ( OF )? modelReference WHERE simpleOrComplexConstraint
                    {
                    FIRST211=(Token)match(input,FIRST,FOLLOW_FIRST_in_selectionExpression2247); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_FIRST.add(FIRST211);

                    // NRLConstraintRules.g:398:11: ( OF )?
                    int alt62=2;
                    switch ( input.LA(1) ) {
                        case OF:
                            {
                            alt62=1;
                            }
                            break;
                    }

                    switch (alt62) {
                        case 1 :
                            // NRLConstraintRules.g:398:11: OF
                            {
                            OF212=(Token)match(input,OF,FOLLOW_OF_in_selectionExpression2249); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_OF.add(OF212);


                            }
                            break;

                    }

                    pushFollow(FOLLOW_modelReference_in_selectionExpression2252);
                    modelReference213=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_modelReference.add(modelReference213.getTree());
                    WHERE214=(Token)match(input,WHERE,FOLLOW_WHERE_in_selectionExpression2254); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_WHERE.add(WHERE214);

                    pushFollow(FOLLOW_simpleOrComplexConstraint_in_selectionExpression2256);
                    simpleOrComplexConstraint215=simpleOrComplexConstraint();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_simpleOrComplexConstraint.add(simpleOrComplexConstraint215.getTree());


                    // AST REWRITE
                    // elements: modelReference, simpleOrComplexConstraint
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 399:4: -> ^( VT_SINGLE_SELECTION_EXPR modelReference simpleOrComplexConstraint )
                    {
                        // NRLConstraintRules.g:399:7: ^( VT_SINGLE_SELECTION_EXPR modelReference simpleOrComplexConstraint )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_SINGLE_SELECTION_EXPR, "VT_SINGLE_SELECTION_EXPR"), root_1);

                        adaptor.addChild(root_1, stream_modelReference.nextTree());
                        adaptor.addChild(root_1, stream_simpleOrComplexConstraint.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "selectionExpression"

    public static class identifier_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "identifier"
    // NRLConstraintRules.g:402:1: identifier : ( modelReference | SINGLE_QUOTED_STRING | BOOLEAN | number | collectionIndex );
    public final NRLActionParser_NRLConstraintRules.identifier_return identifier() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.identifier_return retval = new NRLActionParser_NRLConstraintRules.identifier_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token SINGLE_QUOTED_STRING217=null;
        Token BOOLEAN218=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference216 = null;

        NRLActionParser_NRLConstraintRules.number_return number219 = null;

        NRLActionParser_NRLConstraintRules.collectionIndex_return collectionIndex220 = null;


        CommonTree SINGLE_QUOTED_STRING217_tree=null;
        CommonTree BOOLEAN218_tree=null;

        try {
            // NRLConstraintRules.g:403:3: ( modelReference | SINGLE_QUOTED_STRING | BOOLEAN | number | collectionIndex )
            int alt64=5;
            switch ( input.LA(1) ) {
            case IDENTIFIER:
                {
                alt64=1;
                }
                break;
            case SINGLE_QUOTED_STRING:
                {
                alt64=2;
                }
                break;
            case BOOLEAN:
                {
                alt64=3;
                }
                break;
            case INTEGER_NUMBER:
            case MINUS:
            case DECIMAL_NUMBER:
                {
                alt64=4;
                }
                break;
            case FIRST:
            case ORDINAL_NUMBER:
                {
                alt64=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 64, 0, input);

                throw nvae;
            }

            switch (alt64) {
                case 1 :
                    // NRLConstraintRules.g:403:5: modelReference
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_modelReference_in_identifier2282);
                    modelReference216=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference216.getTree());

                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:404:5: SINGLE_QUOTED_STRING
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    SINGLE_QUOTED_STRING217=(Token)match(input,SINGLE_QUOTED_STRING,FOLLOW_SINGLE_QUOTED_STRING_in_identifier2288); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    SINGLE_QUOTED_STRING217_tree = (CommonTree)adaptor.create(SINGLE_QUOTED_STRING217);
                    adaptor.addChild(root_0, SINGLE_QUOTED_STRING217_tree);
                    }

                    }
                    break;
                case 3 :
                    // NRLConstraintRules.g:405:5: BOOLEAN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    BOOLEAN218=(Token)match(input,BOOLEAN,FOLLOW_BOOLEAN_in_identifier2294); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    BOOLEAN218_tree = (CommonTree)adaptor.create(BOOLEAN218);
                    adaptor.addChild(root_0, BOOLEAN218_tree);
                    }

                    }
                    break;
                case 4 :
                    // NRLConstraintRules.g:406:5: number
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_number_in_identifier2300);
                    number219=number();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, number219.getTree());

                    }
                    break;
                case 5 :
                    // NRLConstraintRules.g:407:5: collectionIndex
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_collectionIndex_in_identifier2306);
                    collectionIndex220=collectionIndex();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, collectionIndex220.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "identifier"

    public static class number_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "number"
    // NRLConstraintRules.g:410:1: number : ( DECIMAL_NUMBER | INTEGER_NUMBER | MINUS DECIMAL_NUMBER -> ^( VT_NEGATE_DECIMAL DECIMAL_NUMBER ) | MINUS INTEGER_NUMBER -> ^( VT_NEGATE_INTEGER INTEGER_NUMBER ) );
    public final NRLActionParser_NRLConstraintRules.number_return number() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.number_return retval = new NRLActionParser_NRLConstraintRules.number_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token DECIMAL_NUMBER221=null;
        Token INTEGER_NUMBER222=null;
        Token MINUS223=null;
        Token DECIMAL_NUMBER224=null;
        Token MINUS225=null;
        Token INTEGER_NUMBER226=null;

        CommonTree DECIMAL_NUMBER221_tree=null;
        CommonTree INTEGER_NUMBER222_tree=null;
        CommonTree MINUS223_tree=null;
        CommonTree DECIMAL_NUMBER224_tree=null;
        CommonTree MINUS225_tree=null;
        CommonTree INTEGER_NUMBER226_tree=null;
        RewriteRuleTokenStream stream_INTEGER_NUMBER=new RewriteRuleTokenStream(adaptor,"token INTEGER_NUMBER");
        RewriteRuleTokenStream stream_MINUS=new RewriteRuleTokenStream(adaptor,"token MINUS");
        RewriteRuleTokenStream stream_DECIMAL_NUMBER=new RewriteRuleTokenStream(adaptor,"token DECIMAL_NUMBER");

        try {
            // NRLConstraintRules.g:411:3: ( DECIMAL_NUMBER | INTEGER_NUMBER | MINUS DECIMAL_NUMBER -> ^( VT_NEGATE_DECIMAL DECIMAL_NUMBER ) | MINUS INTEGER_NUMBER -> ^( VT_NEGATE_INTEGER INTEGER_NUMBER ) )
            int alt65=4;
            switch ( input.LA(1) ) {
            case DECIMAL_NUMBER:
                {
                alt65=1;
                }
                break;
            case INTEGER_NUMBER:
                {
                alt65=2;
                }
                break;
            case MINUS:
                {
                switch ( input.LA(2) ) {
                case DECIMAL_NUMBER:
                    {
                    alt65=3;
                    }
                    break;
                case INTEGER_NUMBER:
                    {
                    alt65=4;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 65, 3, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 65, 0, input);

                throw nvae;
            }

            switch (alt65) {
                case 1 :
                    // NRLConstraintRules.g:411:5: DECIMAL_NUMBER
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    DECIMAL_NUMBER221=(Token)match(input,DECIMAL_NUMBER,FOLLOW_DECIMAL_NUMBER_in_number2319); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    DECIMAL_NUMBER221_tree = (CommonTree)adaptor.create(DECIMAL_NUMBER221);
                    adaptor.addChild(root_0, DECIMAL_NUMBER221_tree);
                    }

                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:412:5: INTEGER_NUMBER
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    INTEGER_NUMBER222=(Token)match(input,INTEGER_NUMBER,FOLLOW_INTEGER_NUMBER_in_number2325); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    INTEGER_NUMBER222_tree = (CommonTree)adaptor.create(INTEGER_NUMBER222);
                    adaptor.addChild(root_0, INTEGER_NUMBER222_tree);
                    }

                    }
                    break;
                case 3 :
                    // NRLConstraintRules.g:413:5: MINUS DECIMAL_NUMBER
                    {
                    MINUS223=(Token)match(input,MINUS,FOLLOW_MINUS_in_number2331); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_MINUS.add(MINUS223);

                    DECIMAL_NUMBER224=(Token)match(input,DECIMAL_NUMBER,FOLLOW_DECIMAL_NUMBER_in_number2333); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_DECIMAL_NUMBER.add(DECIMAL_NUMBER224);



                    // AST REWRITE
                    // elements: DECIMAL_NUMBER
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 413:26: -> ^( VT_NEGATE_DECIMAL DECIMAL_NUMBER )
                    {
                        // NRLConstraintRules.g:413:29: ^( VT_NEGATE_DECIMAL DECIMAL_NUMBER )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_NEGATE_DECIMAL, "VT_NEGATE_DECIMAL"), root_1);

                        adaptor.addChild(root_1, stream_DECIMAL_NUMBER.nextNode());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // NRLConstraintRules.g:414:5: MINUS INTEGER_NUMBER
                    {
                    MINUS225=(Token)match(input,MINUS,FOLLOW_MINUS_in_number2347); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_MINUS.add(MINUS225);

                    INTEGER_NUMBER226=(Token)match(input,INTEGER_NUMBER,FOLLOW_INTEGER_NUMBER_in_number2349); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_INTEGER_NUMBER.add(INTEGER_NUMBER226);



                    // AST REWRITE
                    // elements: INTEGER_NUMBER
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 414:26: -> ^( VT_NEGATE_INTEGER INTEGER_NUMBER )
                    {
                        // NRLConstraintRules.g:414:29: ^( VT_NEGATE_INTEGER INTEGER_NUMBER )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_NEGATE_INTEGER, "VT_NEGATE_INTEGER"), root_1);

                        adaptor.addChild(root_1, stream_INTEGER_NUMBER.nextNode());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "number"

    public static class collectionIndex_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "collectionIndex"
    // NRLConstraintRules.g:417:1: collectionIndex : ( ORDINAL_NUMBER ( OF )? modelReference | FIRST ( OF )? modelReference -> ^( VT_FIRST_ORDINAL_NUMBER modelReference ) );
    public final NRLActionParser_NRLConstraintRules.collectionIndex_return collectionIndex() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.collectionIndex_return retval = new NRLActionParser_NRLConstraintRules.collectionIndex_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token ORDINAL_NUMBER227=null;
        Token OF228=null;
        Token FIRST230=null;
        Token OF231=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference229 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference232 = null;


        CommonTree ORDINAL_NUMBER227_tree=null;
        CommonTree OF228_tree=null;
        CommonTree FIRST230_tree=null;
        CommonTree OF231_tree=null;
        RewriteRuleTokenStream stream_OF=new RewriteRuleTokenStream(adaptor,"token OF");
        RewriteRuleTokenStream stream_FIRST=new RewriteRuleTokenStream(adaptor,"token FIRST");
        RewriteRuleSubtreeStream stream_modelReference=new RewriteRuleSubtreeStream(adaptor,"rule modelReference");
        try {
            // NRLConstraintRules.g:418:3: ( ORDINAL_NUMBER ( OF )? modelReference | FIRST ( OF )? modelReference -> ^( VT_FIRST_ORDINAL_NUMBER modelReference ) )
            int alt68=2;
            switch ( input.LA(1) ) {
            case ORDINAL_NUMBER:
                {
                alt68=1;
                }
                break;
            case FIRST:
                {
                alt68=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 68, 0, input);

                throw nvae;
            }

            switch (alt68) {
                case 1 :
                    // NRLConstraintRules.g:418:5: ORDINAL_NUMBER ( OF )? modelReference
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    ORDINAL_NUMBER227=(Token)match(input,ORDINAL_NUMBER,FOLLOW_ORDINAL_NUMBER_in_collectionIndex2372); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    ORDINAL_NUMBER227_tree = (CommonTree)adaptor.create(ORDINAL_NUMBER227);
                    root_0 = (CommonTree)adaptor.becomeRoot(ORDINAL_NUMBER227_tree, root_0);
                    }
                    // NRLConstraintRules.g:418:21: ( OF )?
                    int alt66=2;
                    switch ( input.LA(1) ) {
                        case OF:
                            {
                            alt66=1;
                            }
                            break;
                    }

                    switch (alt66) {
                        case 1 :
                            // NRLConstraintRules.g:418:22: OF
                            {
                            OF228=(Token)match(input,OF,FOLLOW_OF_in_collectionIndex2376); if (state.failed) return retval;

                            }
                            break;

                    }

                    pushFollow(FOLLOW_modelReference_in_collectionIndex2381);
                    modelReference229=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference229.getTree());

                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:419:5: FIRST ( OF )? modelReference
                    {
                    FIRST230=(Token)match(input,FIRST,FOLLOW_FIRST_in_collectionIndex2387); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_FIRST.add(FIRST230);

                    // NRLConstraintRules.g:419:11: ( OF )?
                    int alt67=2;
                    switch ( input.LA(1) ) {
                        case OF:
                            {
                            alt67=1;
                            }
                            break;
                    }

                    switch (alt67) {
                        case 1 :
                            // NRLConstraintRules.g:419:11: OF
                            {
                            OF231=(Token)match(input,OF,FOLLOW_OF_in_collectionIndex2389); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_OF.add(OF231);


                            }
                            break;

                    }

                    pushFollow(FOLLOW_modelReference_in_collectionIndex2392);
                    modelReference232=modelReference();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_modelReference.add(modelReference232.getTree());


                    // AST REWRITE
                    // elements: modelReference
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 420:4: -> ^( VT_FIRST_ORDINAL_NUMBER modelReference )
                    {
                        // NRLConstraintRules.g:420:7: ^( VT_FIRST_ORDINAL_NUMBER modelReference )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_FIRST_ORDINAL_NUMBER, "VT_FIRST_ORDINAL_NUMBER"), root_1);

                        adaptor.addChild(root_1, stream_modelReference.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "collectionIndex"

    public static class modelReference_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "modelReference"
    // NRLConstraintRules.g:423:1: modelReference : identifierSequence -> ^( VT_MODELREFERENCE identifierSequence ) ;
    public final NRLActionParser_NRLConstraintRules.modelReference_return modelReference() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.modelReference_return retval = new NRLActionParser_NRLConstraintRules.modelReference_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser_NRLConstraintRules.identifierSequence_return identifierSequence233 = null;


        RewriteRuleSubtreeStream stream_identifierSequence=new RewriteRuleSubtreeStream(adaptor,"rule identifierSequence");
        try {
            // NRLConstraintRules.g:425:3: ( identifierSequence -> ^( VT_MODELREFERENCE identifierSequence ) )
            // NRLConstraintRules.g:425:5: identifierSequence
            {
            pushFollow(FOLLOW_identifierSequence_in_modelReference2423);
            identifierSequence233=identifierSequence();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_identifierSequence.add(identifierSequence233.getTree());


            // AST REWRITE
            // elements: identifierSequence
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 426:4: -> ^( VT_MODELREFERENCE identifierSequence )
            {
                // NRLConstraintRules.g:426:7: ^( VT_MODELREFERENCE identifierSequence )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_MODELREFERENCE, "VT_MODELREFERENCE"), root_1);

                adaptor.addChild(root_1, stream_identifierSequence.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
            if ( state.backtracking==0 ) {
               ((ModelReferenceImpl) retval.tree).initializeSteps(); 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "modelReference"

    public static class modelReferenceList_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "modelReferenceList"
    // NRLConstraintRules.g:429:1: modelReferenceList : modelReference ( options {greedy=true; } : COMMA modelReference )* ;
    public final NRLActionParser_NRLConstraintRules.modelReferenceList_return modelReferenceList() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.modelReferenceList_return retval = new NRLActionParser_NRLConstraintRules.modelReferenceList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token COMMA235=null;
        NRLActionParser_NRLConstraintRules.modelReference_return modelReference234 = null;

        NRLActionParser_NRLConstraintRules.modelReference_return modelReference236 = null;


        CommonTree COMMA235_tree=null;

        try {
            // NRLConstraintRules.g:430:3: ( modelReference ( options {greedy=true; } : COMMA modelReference )* )
            // NRLConstraintRules.g:430:5: modelReference ( options {greedy=true; } : COMMA modelReference )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_modelReference_in_modelReferenceList2448);
            modelReference234=modelReference();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference234.getTree());
            // NRLConstraintRules.g:430:20: ( options {greedy=true; } : COMMA modelReference )*
            loop69:
            do {
                int alt69=2;
                switch ( input.LA(1) ) {
                case COMMA:
                    {
                    switch ( input.LA(2) ) {
                    case IDENTIFIER:
                        {
                        alt69=1;
                        }
                        break;

                    }

                    }
                    break;

                }

                switch (alt69) {
            	case 1 :
            	    // NRLConstraintRules.g:434:5: COMMA modelReference
            	    {
            	    COMMA235=(Token)match(input,COMMA,FOLLOW_COMMA_in_modelReferenceList2482); if (state.failed) return retval;
            	    pushFollow(FOLLOW_modelReference_in_modelReferenceList2485);
            	    modelReference236=modelReference();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, modelReference236.getTree());

            	    }
            	    break;

            	default :
            	    break loop69;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "modelReferenceList"

    public static class identifierSequence_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "identifierSequence"
    // NRLConstraintRules.g:438:1: identifierSequence : IDENTIFIER ( OF identifierSequence )? ;
    public final NRLActionParser_NRLConstraintRules.identifierSequence_return identifierSequence() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.identifierSequence_return retval = new NRLActionParser_NRLConstraintRules.identifierSequence_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token IDENTIFIER237=null;
        Token OF238=null;
        NRLActionParser_NRLConstraintRules.identifierSequence_return identifierSequence239 = null;


        CommonTree IDENTIFIER237_tree=null;
        CommonTree OF238_tree=null;

        try {
            // NRLConstraintRules.g:439:3: ( IDENTIFIER ( OF identifierSequence )? )
            // NRLConstraintRules.g:439:5: IDENTIFIER ( OF identifierSequence )?
            {
            root_0 = (CommonTree)adaptor.nil();

            IDENTIFIER237=(Token)match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_identifierSequence2506); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            IDENTIFIER237_tree = (CommonTree)adaptor.create(IDENTIFIER237);
            adaptor.addChild(root_0, IDENTIFIER237_tree);
            }
            // NRLConstraintRules.g:439:16: ( OF identifierSequence )?
            int alt70=2;
            switch ( input.LA(1) ) {
                case OF:
                    {
                    alt70=1;
                    }
                    break;
            }

            switch (alt70) {
                case 1 :
                    // NRLConstraintRules.g:439:17: OF identifierSequence
                    {
                    OF238=(Token)match(input,OF,FOLLOW_OF_in_identifierSequence2509); if (state.failed) return retval;
                    pushFollow(FOLLOW_identifierSequence_in_identifierSequence2512);
                    identifierSequence239=identifierSequence();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, identifierSequence239.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "identifierSequence"

    public static class constraintRuleReport_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constraintRuleReport"
    // NRLConstraintRules.g:444:1: constraintRuleReport : REPORT ( COLON )? compoundReport ;
    public final NRLActionParser_NRLConstraintRules.constraintRuleReport_return constraintRuleReport() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.constraintRuleReport_return retval = new NRLActionParser_NRLConstraintRules.constraintRuleReport_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token REPORT240=null;
        Token COLON241=null;
        NRLActionParser_NRLConstraintRules.compoundReport_return compoundReport242 = null;


        CommonTree REPORT240_tree=null;
        CommonTree COLON241_tree=null;

        try {
            // NRLConstraintRules.g:445:3: ( REPORT ( COLON )? compoundReport )
            // NRLConstraintRules.g:445:5: REPORT ( COLON )? compoundReport
            {
            root_0 = (CommonTree)adaptor.nil();

            REPORT240=(Token)match(input,REPORT,FOLLOW_REPORT_in_constraintRuleReport2532); if (state.failed) return retval;
            // NRLConstraintRules.g:445:13: ( COLON )?
            int alt71=2;
            switch ( input.LA(1) ) {
                case COLON:
                    {
                    alt71=1;
                    }
                    break;
            }

            switch (alt71) {
                case 1 :
                    // NRLConstraintRules.g:445:15: COLON
                    {
                    COLON241=(Token)match(input,COLON,FOLLOW_COLON_in_constraintRuleReport2537); if (state.failed) return retval;

                    }
                    break;

            }

            pushFollow(FOLLOW_compoundReport_in_constraintRuleReport2543);
            compoundReport242=compoundReport();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, compoundReport242.getTree());

            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "constraintRuleReport"

    public static class compoundReport_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "compoundReport"
    // NRLConstraintRules.g:448:1: compoundReport : simpleReports -> ^( VT_COMPOUND_REPORT simpleReports ) ;
    public final NRLActionParser_NRLConstraintRules.compoundReport_return compoundReport() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.compoundReport_return retval = new NRLActionParser_NRLConstraintRules.compoundReport_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser_NRLConstraintRules.simpleReports_return simpleReports243 = null;


        RewriteRuleSubtreeStream stream_simpleReports=new RewriteRuleSubtreeStream(adaptor,"rule simpleReports");
        try {
            // NRLConstraintRules.g:449:3: ( simpleReports -> ^( VT_COMPOUND_REPORT simpleReports ) )
            // NRLConstraintRules.g:449:5: simpleReports
            {
            pushFollow(FOLLOW_simpleReports_in_compoundReport2558);
            simpleReports243=simpleReports();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_simpleReports.add(simpleReports243.getTree());


            // AST REWRITE
            // elements: simpleReports
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 450:4: -> ^( VT_COMPOUND_REPORT simpleReports )
            {
                // NRLConstraintRules.g:450:7: ^( VT_COMPOUND_REPORT simpleReports )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_COMPOUND_REPORT, "VT_COMPOUND_REPORT"), root_1);

                adaptor.addChild(root_1, stream_simpleReports.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "compoundReport"

    public static class simpleReports_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "simpleReports"
    // NRLConstraintRules.g:453:1: simpleReports : simpleReport ( ( COMMA )? simpleReport )* ;
    public final NRLActionParser_NRLConstraintRules.simpleReports_return simpleReports() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.simpleReports_return retval = new NRLActionParser_NRLConstraintRules.simpleReports_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token COMMA245=null;
        NRLActionParser_NRLConstraintRules.simpleReport_return simpleReport244 = null;

        NRLActionParser_NRLConstraintRules.simpleReport_return simpleReport246 = null;


        CommonTree COMMA245_tree=null;

        try {
            // NRLConstraintRules.g:454:3: ( simpleReport ( ( COMMA )? simpleReport )* )
            // NRLConstraintRules.g:454:5: simpleReport ( ( COMMA )? simpleReport )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_simpleReport_in_simpleReports2583);
            simpleReport244=simpleReport();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, simpleReport244.getTree());
            // NRLConstraintRules.g:454:18: ( ( COMMA )? simpleReport )*
            loop73:
            do {
                int alt73=2;
                switch ( input.LA(1) ) {
                case COMMA:
                case IF:
                case INTEGER_NUMBER:
                case MINUS:
                case OPERATOR:
                case SUM_OF:
                case NUMBER_OF:
                case FIRST:
                case SINGLE_QUOTED_STRING:
                case BOOLEAN:
                case DECIMAL_NUMBER:
                case ORDINAL_NUMBER:
                case IDENTIFIER:
                case REPORT:
                    {
                    alt73=1;
                    }
                    break;

                }

                switch (alt73) {
            	case 1 :
            	    // NRLConstraintRules.g:454:20: ( COMMA )? simpleReport
            	    {
            	    // NRLConstraintRules.g:454:20: ( COMMA )?
            	    int alt72=2;
            	    switch ( input.LA(1) ) {
            	        case COMMA:
            	            {
            	            alt72=1;
            	            }
            	            break;
            	    }

            	    switch (alt72) {
            	        case 1 :
            	            // NRLConstraintRules.g:454:22: COMMA
            	            {
            	            COMMA245=(Token)match(input,COMMA,FOLLOW_COMMA_in_simpleReports2589); if (state.failed) return retval;

            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_simpleReport_in_simpleReports2595);
            	    simpleReport246=simpleReport();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, simpleReport246.getTree());

            	    }
            	    break;

            	default :
            	    break loop73;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "simpleReports"

    public static class simpleReport_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "simpleReport"
    // NRLConstraintRules.g:457:1: simpleReport : ( concatenatedReport | conditionalReport );
    public final NRLActionParser_NRLConstraintRules.simpleReport_return simpleReport() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.simpleReport_return retval = new NRLActionParser_NRLConstraintRules.simpleReport_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NRLActionParser_NRLConstraintRules.concatenatedReport_return concatenatedReport247 = null;

        NRLActionParser_NRLConstraintRules.conditionalReport_return conditionalReport248 = null;



        try {
            // NRLConstraintRules.g:458:3: ( concatenatedReport | conditionalReport )
            int alt74=2;
            switch ( input.LA(1) ) {
            case INTEGER_NUMBER:
            case MINUS:
            case OPERATOR:
            case SUM_OF:
            case NUMBER_OF:
            case FIRST:
            case SINGLE_QUOTED_STRING:
            case BOOLEAN:
            case DECIMAL_NUMBER:
            case ORDINAL_NUMBER:
            case IDENTIFIER:
            case REPORT:
                {
                alt74=1;
                }
                break;
            case IF:
                {
                alt74=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 74, 0, input);

                throw nvae;
            }

            switch (alt74) {
                case 1 :
                    // NRLConstraintRules.g:458:5: concatenatedReport
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_concatenatedReport_in_simpleReport2611);
                    concatenatedReport247=concatenatedReport();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, concatenatedReport247.getTree());

                    }
                    break;
                case 2 :
                    // NRLConstraintRules.g:459:5: conditionalReport
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_conditionalReport_in_simpleReport2617);
                    conditionalReport248=conditionalReport();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) adaptor.addChild(root_0, conditionalReport248.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "simpleReport"

    public static class concatenatedReport_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "concatenatedReport"
    // NRLConstraintRules.g:462:1: concatenatedReport : ( REPORT )? concatenatedReportTerms -> ^( VT_CONCATENATED_REPORT concatenatedReportTerms ) ;
    public final NRLActionParser_NRLConstraintRules.concatenatedReport_return concatenatedReport() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.concatenatedReport_return retval = new NRLActionParser_NRLConstraintRules.concatenatedReport_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token REPORT249=null;
        NRLActionParser_NRLConstraintRules.concatenatedReportTerms_return concatenatedReportTerms250 = null;


        CommonTree REPORT249_tree=null;
        RewriteRuleTokenStream stream_REPORT=new RewriteRuleTokenStream(adaptor,"token REPORT");
        RewriteRuleSubtreeStream stream_concatenatedReportTerms=new RewriteRuleSubtreeStream(adaptor,"rule concatenatedReportTerms");
        try {
            // NRLConstraintRules.g:463:3: ( ( REPORT )? concatenatedReportTerms -> ^( VT_CONCATENATED_REPORT concatenatedReportTerms ) )
            // NRLConstraintRules.g:463:5: ( REPORT )? concatenatedReportTerms
            {
            // NRLConstraintRules.g:463:5: ( REPORT )?
            int alt75=2;
            switch ( input.LA(1) ) {
                case REPORT:
                    {
                    alt75=1;
                    }
                    break;
            }

            switch (alt75) {
                case 1 :
                    // NRLConstraintRules.g:463:5: REPORT
                    {
                    REPORT249=(Token)match(input,REPORT,FOLLOW_REPORT_in_concatenatedReport2632); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_REPORT.add(REPORT249);


                    }
                    break;

            }

            pushFollow(FOLLOW_concatenatedReportTerms_in_concatenatedReport2635);
            concatenatedReportTerms250=concatenatedReportTerms();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_concatenatedReportTerms.add(concatenatedReportTerms250.getTree());


            // AST REWRITE
            // elements: concatenatedReportTerms
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 464:4: -> ^( VT_CONCATENATED_REPORT concatenatedReportTerms )
            {
                // NRLConstraintRules.g:464:7: ^( VT_CONCATENATED_REPORT concatenatedReportTerms )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_CONCATENATED_REPORT, "VT_CONCATENATED_REPORT"), root_1);

                adaptor.addChild(root_1, stream_concatenatedReportTerms.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "concatenatedReport"

    public static class concatenatedReportTerms_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "concatenatedReportTerms"
    // NRLConstraintRules.g:467:1: concatenatedReportTerms : simpleTerm ( ADD simpleTerm )* ;
    public final NRLActionParser_NRLConstraintRules.concatenatedReportTerms_return concatenatedReportTerms() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.concatenatedReportTerms_return retval = new NRLActionParser_NRLConstraintRules.concatenatedReportTerms_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token ADD252=null;
        NRLActionParser_NRLConstraintRules.simpleTerm_return simpleTerm251 = null;

        NRLActionParser_NRLConstraintRules.simpleTerm_return simpleTerm253 = null;


        CommonTree ADD252_tree=null;

        try {
            // NRLConstraintRules.g:468:3: ( simpleTerm ( ADD simpleTerm )* )
            // NRLConstraintRules.g:468:5: simpleTerm ( ADD simpleTerm )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_simpleTerm_in_concatenatedReportTerms2659);
            simpleTerm251=simpleTerm();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) adaptor.addChild(root_0, simpleTerm251.getTree());
            // NRLConstraintRules.g:468:16: ( ADD simpleTerm )*
            loop76:
            do {
                int alt76=2;
                switch ( input.LA(1) ) {
                case ADD:
                    {
                    alt76=1;
                    }
                    break;

                }

                switch (alt76) {
            	case 1 :
            	    // NRLConstraintRules.g:468:18: ADD simpleTerm
            	    {
            	    ADD252=(Token)match(input,ADD,FOLLOW_ADD_in_concatenatedReportTerms2663); if (state.failed) return retval;
            	    pushFollow(FOLLOW_simpleTerm_in_concatenatedReportTerms2666);
            	    simpleTerm253=simpleTerm();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) adaptor.addChild(root_0, simpleTerm253.getTree());

            	    }
            	    break;

            	default :
            	    break loop76;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "concatenatedReportTerms"

    public static class conditionalReport_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "conditionalReport"
    // NRLConstraintRules.g:471:1: conditionalReport : IF constraint THEN c1= compoundReport ( ELSE c2= compoundReport )? SEMI -> ^( VT_CONDITIONAL_REPORT constraint $c1 ( $c2)? ) ;
    public final NRLActionParser_NRLConstraintRules.conditionalReport_return conditionalReport() throws RecognitionException {
        NRLActionParser_NRLConstraintRules.conditionalReport_return retval = new NRLActionParser_NRLConstraintRules.conditionalReport_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token IF254=null;
        Token THEN256=null;
        Token ELSE257=null;
        Token SEMI258=null;
        NRLActionParser_NRLConstraintRules.compoundReport_return c1 = null;

        NRLActionParser_NRLConstraintRules.compoundReport_return c2 = null;

        NRLActionParser_NRLConstraintRules.constraint_return constraint255 = null;


        CommonTree IF254_tree=null;
        CommonTree THEN256_tree=null;
        CommonTree ELSE257_tree=null;
        CommonTree SEMI258_tree=null;
        RewriteRuleTokenStream stream_THEN=new RewriteRuleTokenStream(adaptor,"token THEN");
        RewriteRuleTokenStream stream_SEMI=new RewriteRuleTokenStream(adaptor,"token SEMI");
        RewriteRuleTokenStream stream_IF=new RewriteRuleTokenStream(adaptor,"token IF");
        RewriteRuleTokenStream stream_ELSE=new RewriteRuleTokenStream(adaptor,"token ELSE");
        RewriteRuleSubtreeStream stream_constraint=new RewriteRuleSubtreeStream(adaptor,"rule constraint");
        RewriteRuleSubtreeStream stream_compoundReport=new RewriteRuleSubtreeStream(adaptor,"rule compoundReport");
        try {
            // NRLConstraintRules.g:472:3: ( IF constraint THEN c1= compoundReport ( ELSE c2= compoundReport )? SEMI -> ^( VT_CONDITIONAL_REPORT constraint $c1 ( $c2)? ) )
            // NRLConstraintRules.g:472:5: IF constraint THEN c1= compoundReport ( ELSE c2= compoundReport )? SEMI
            {
            IF254=(Token)match(input,IF,FOLLOW_IF_in_conditionalReport2686); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_IF.add(IF254);

            pushFollow(FOLLOW_constraint_in_conditionalReport2688);
            constraint255=constraint();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_constraint.add(constraint255.getTree());
            THEN256=(Token)match(input,THEN,FOLLOW_THEN_in_conditionalReport2690); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_THEN.add(THEN256);

            pushFollow(FOLLOW_compoundReport_in_conditionalReport2694);
            c1=compoundReport();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_compoundReport.add(c1.getTree());
            // NRLConstraintRules.g:472:42: ( ELSE c2= compoundReport )?
            int alt77=2;
            switch ( input.LA(1) ) {
                case ELSE:
                    {
                    alt77=1;
                    }
                    break;
            }

            switch (alt77) {
                case 1 :
                    // NRLConstraintRules.g:472:44: ELSE c2= compoundReport
                    {
                    ELSE257=(Token)match(input,ELSE,FOLLOW_ELSE_in_conditionalReport2698); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ELSE.add(ELSE257);

                    pushFollow(FOLLOW_compoundReport_in_conditionalReport2702);
                    c2=compoundReport();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_compoundReport.add(c2.getTree());

                    }
                    break;

            }

            SEMI258=(Token)match(input,SEMI,FOLLOW_SEMI_in_conditionalReport2707); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_SEMI.add(SEMI258);



            // AST REWRITE
            // elements: c2, constraint, c1
            // token labels: 
            // rule labels: retval, c1, c2
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_c1=new RewriteRuleSubtreeStream(adaptor,"rule c1",c1!=null?c1.tree:null);
            RewriteRuleSubtreeStream stream_c2=new RewriteRuleSubtreeStream(adaptor,"rule c2",c2!=null?c2.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 473:4: -> ^( VT_CONDITIONAL_REPORT constraint $c1 ( $c2)? )
            {
                // NRLConstraintRules.g:473:7: ^( VT_CONDITIONAL_REPORT constraint $c1 ( $c2)? )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(VT_CONDITIONAL_REPORT, "VT_CONDITIONAL_REPORT"), root_1);

                adaptor.addChild(root_1, stream_constraint.nextTree());
                adaptor.addChild(root_1, stream_c1.nextTree());
                // NRLConstraintRules.g:473:46: ( $c2)?
                if ( stream_c2.hasNext() ) {
                    adaptor.addChild(root_1, stream_c2.nextTree());

                }
                stream_c2.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            retval.stop = input.LT(-1);

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "conditionalReport"

    // $ANTLR start synpred1_NRLConstraintRules
    public final void synpred1_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:98:5: ( context VALIDATION_RULE )
        // NRLConstraintRules.g:98:6: context VALIDATION_RULE
        {
        pushFollow(FOLLOW_context_in_synpred1_NRLConstraintRules125);
        context();

        state._fsp--;
        if (state.failed) return ;
        match(input,VALIDATION_RULE,FOLLOW_VALIDATION_RULE_in_synpred1_NRLConstraintRules127); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred1_NRLConstraintRules

    // $ANTLR start synpred2_NRLConstraintRules
    public final void synpred2_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:181:5: ( modelReference ( PRESENT | HASHAVE ) )
        // NRLConstraintRules.g:181:6: modelReference ( PRESENT | HASHAVE )
        {
        pushFollow(FOLLOW_modelReference_in_synpred2_NRLConstraintRules619);
        modelReference();

        state._fsp--;
        if (state.failed) return ;
        if ( input.LA(1)==HASHAVE||input.LA(1)==PRESENT ) {
            input.consume();
            state.errorRecovery=false;state.failed=false;
        }
        else {
            if (state.backtracking>0) {state.failed=true; return ;}
            MismatchedSetException mse = new MismatchedSetException(null,input);
            throw mse;
        }


        }
    }
    // $ANTLR end synpred2_NRLConstraintRules

    // $ANTLR start synpred3_NRLConstraintRules
    public final void synpred3_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:182:5: ( modelReference THAT )
        // NRLConstraintRules.g:182:6: modelReference THAT
        {
        pushFollow(FOLLOW_modelReference_in_synpred3_NRLConstraintRules637);
        modelReference();

        state._fsp--;
        if (state.failed) return ;
        match(input,THAT,FOLLOW_THAT_in_synpred3_NRLConstraintRules639); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred3_NRLConstraintRules

    // $ANTLR start synpred4_NRLConstraintRules
    public final void synpred4_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:183:5: ( modelReference NOT_PRESENT )
        // NRLConstraintRules.g:183:6: modelReference NOT_PRESENT
        {
        pushFollow(FOLLOW_modelReference_in_synpred4_NRLConstraintRules651);
        modelReference();

        state._fsp--;
        if (state.failed) return ;
        match(input,NOT_PRESENT,FOLLOW_NOT_PRESENT_in_synpred4_NRLConstraintRules653); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred4_NRLConstraintRules

    // $ANTLR start synpred5_NRLConstraintRules
    public final void synpred5_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:184:5: ( enumeratorDisambiguation )
        // NRLConstraintRules.g:184:6: enumeratorDisambiguation
        {
        pushFollow(FOLLOW_enumeratorDisambiguation_in_synpred5_NRLConstraintRules666);
        enumeratorDisambiguation();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred5_NRLConstraintRules

    // $ANTLR start synpred6_NRLConstraintRules
    public final void synpred6_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:185:5: ( forallStart )
        // NRLConstraintRules.g:185:6: forallStart
        {
        pushFollow(FOLLOW_forallStart_in_synpred6_NRLConstraintRules678);
        forallStart();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred6_NRLConstraintRules

    // $ANTLR start synpred7_NRLConstraintRules
    public final void synpred7_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:205:5: ( enumeratorStart HASHAVE )
        // NRLConstraintRules.g:205:6: enumeratorStart HASHAVE
        {
        pushFollow(FOLLOW_enumeratorStart_in_synpred7_NRLConstraintRules876);
        enumeratorStart();

        state._fsp--;
        if (state.failed) return ;
        match(input,HASHAVE,FOLLOW_HASHAVE_in_synpred7_NRLConstraintRules878); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred7_NRLConstraintRules

    // $ANTLR start synpred8_NRLConstraintRules
    public final void synpred8_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:222:5: ( LPAREN )
        // NRLConstraintRules.g:222:6: LPAREN
        {
        match(input,LPAREN,FOLLOW_LPAREN_in_synpred8_NRLConstraintRules1047); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred8_NRLConstraintRules

    // $ANTLR start synpred9_NRLConstraintRules
    public final void synpred9_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:231:5: ( forallStart OF modelReference HASHAVE )
        // NRLConstraintRules.g:231:6: forallStart OF modelReference HASHAVE
        {
        pushFollow(FOLLOW_forallStart_in_synpred9_NRLConstraintRules1096);
        forallStart();

        state._fsp--;
        if (state.failed) return ;
        match(input,OF,FOLLOW_OF_in_synpred9_NRLConstraintRules1098); if (state.failed) return ;
        pushFollow(FOLLOW_modelReference_in_synpred9_NRLConstraintRules1100);
        modelReference();

        state._fsp--;
        if (state.failed) return ;
        match(input,HASHAVE,FOLLOW_HASHAVE_in_synpred9_NRLConstraintRules1102); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred9_NRLConstraintRules

    // $ANTLR start synpred10_NRLConstraintRules
    public final void synpred10_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:232:5: ( forallStart modelReference HASHAVE )
        // NRLConstraintRules.g:232:6: forallStart modelReference HASHAVE
        {
        pushFollow(FOLLOW_forallStart_in_synpred10_NRLConstraintRules1134);
        forallStart();

        state._fsp--;
        if (state.failed) return ;
        pushFollow(FOLLOW_modelReference_in_synpred10_NRLConstraintRules1136);
        modelReference();

        state._fsp--;
        if (state.failed) return ;
        match(input,HASHAVE,FOLLOW_HASHAVE_in_synpred10_NRLConstraintRules1138); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred10_NRLConstraintRules

    // $ANTLR start synpred11_NRLConstraintRules
    public final void synpred11_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:233:5: ( forallStart DOUBLE_QUOTED_STRING )
        // NRLConstraintRules.g:233:6: forallStart DOUBLE_QUOTED_STRING
        {
        pushFollow(FOLLOW_forallStart_in_synpred11_NRLConstraintRules1170);
        forallStart();

        state._fsp--;
        if (state.failed) return ;
        match(input,DOUBLE_QUOTED_STRING,FOLLOW_DOUBLE_QUOTED_STRING_in_synpred11_NRLConstraintRules1172); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred11_NRLConstraintRules

    // $ANTLR start synpred12_NRLConstraintRules
    public final void synpred12_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:242:5: ( expression IS_IN )
        // NRLConstraintRules.g:242:6: expression IS_IN
        {
        pushFollow(FOLLOW_expression_in_synpred12_NRLConstraintRules1277);
        expression();

        state._fsp--;
        if (state.failed) return ;
        match(input,IS_IN,FOLLOW_IS_IN_in_synpred12_NRLConstraintRules1279); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred12_NRLConstraintRules

    // $ANTLR start synpred13_NRLConstraintRules
    public final void synpred13_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:243:5: ( expression IS_NOT_IN )
        // NRLConstraintRules.g:243:6: expression IS_NOT_IN
        {
        pushFollow(FOLLOW_expression_in_synpred13_NRLConstraintRules1296);
        expression();

        state._fsp--;
        if (state.failed) return ;
        match(input,IS_NOT_IN,FOLLOW_IS_NOT_IN_in_synpred13_NRLConstraintRules1298); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred13_NRLConstraintRules

    // $ANTLR start synpred14_NRLConstraintRules
    public final void synpred14_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:244:5: ( modelReference KIND_OF )
        // NRLConstraintRules.g:244:6: modelReference KIND_OF
        {
        pushFollow(FOLLOW_modelReference_in_synpred14_NRLConstraintRules1315);
        modelReference();

        state._fsp--;
        if (state.failed) return ;
        match(input,KIND_OF,FOLLOW_KIND_OF_in_synpred14_NRLConstraintRules1317); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred14_NRLConstraintRules

    // $ANTLR start synpred15_NRLConstraintRules
    public final void synpred15_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:245:5: ( FOLLOWING PRESENT )
        // NRLConstraintRules.g:245:6: FOLLOWING PRESENT
        {
        match(input,FOLLOWING,FOLLOW_FOLLOWING_in_synpred15_NRLConstraintRules1329); if (state.failed) return ;
        match(input,PRESENT,FOLLOW_PRESENT_in_synpred15_NRLConstraintRules1331); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred15_NRLConstraintRules

    // $ANTLR start synpred16_NRLConstraintRules
    public final void synpred16_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:246:5: ( FOLLOWING NOT_PRESENT )
        // NRLConstraintRules.g:246:6: FOLLOWING NOT_PRESENT
        {
        match(input,FOLLOWING,FOLLOW_FOLLOWING_in_synpred16_NRLConstraintRules1343); if (state.failed) return ;
        match(input,NOT_PRESENT,FOLLOW_NOT_PRESENT_in_synpred16_NRLConstraintRules1345); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred16_NRLConstraintRules

    // $ANTLR start synpred17_NRLConstraintRules
    public final void synpred17_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:342:5: ( OPERATOR )
        // NRLConstraintRules.g:342:6: OPERATOR
        {
        match(input,OPERATOR,FOLLOW_OPERATOR_in_synpred17_NRLConstraintRules1879); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred17_NRLConstraintRules

    // $ANTLR start synpred18_NRLConstraintRules
    public final void synpred18_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:343:5: ( PROPERTYNAME )
        // NRLConstraintRules.g:343:6: PROPERTYNAME
        {
        match(input,PROPERTYNAME,FOLLOW_PROPERTYNAME_in_synpred18_NRLConstraintRules1891); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred18_NRLConstraintRules

    // $ANTLR start synpred19_NRLConstraintRules
    public final void synpred19_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:344:5: ( modelReference AS_A )
        // NRLConstraintRules.g:344:6: modelReference AS_A
        {
        pushFollow(FOLLOW_modelReference_in_synpred19_NRLConstraintRules1903);
        modelReference();

        state._fsp--;
        if (state.failed) return ;
        match(input,AS_A,FOLLOW_AS_A_in_synpred19_NRLConstraintRules1905); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred19_NRLConstraintRules

    // $ANTLR start synpred20_NRLConstraintRules
    public final void synpred20_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:345:5: ( modelReference WHERE )
        // NRLConstraintRules.g:345:6: modelReference WHERE
        {
        pushFollow(FOLLOW_modelReference_in_synpred20_NRLConstraintRules1917);
        modelReference();

        state._fsp--;
        if (state.failed) return ;
        match(input,WHERE,FOLLOW_WHERE_in_synpred20_NRLConstraintRules1919); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred20_NRLConstraintRules

    // $ANTLR start synpred21_NRLConstraintRules
    public final void synpred21_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:346:5: ( FIRST modelReference WHERE )
        // NRLConstraintRules.g:346:6: FIRST modelReference WHERE
        {
        match(input,FIRST,FOLLOW_FIRST_in_synpred21_NRLConstraintRules1931); if (state.failed) return ;
        pushFollow(FOLLOW_modelReference_in_synpred21_NRLConstraintRules1933);
        modelReference();

        state._fsp--;
        if (state.failed) return ;
        match(input,WHERE,FOLLOW_WHERE_in_synpred21_NRLConstraintRules1935); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred21_NRLConstraintRules

    // $ANTLR start synpred22_NRLConstraintRules
    public final void synpred22_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:347:5: ( FIRST OF modelReference WHERE )
        // NRLConstraintRules.g:347:6: FIRST OF modelReference WHERE
        {
        match(input,FIRST,FOLLOW_FIRST_in_synpred22_NRLConstraintRules1947); if (state.failed) return ;
        match(input,OF,FOLLOW_OF_in_synpred22_NRLConstraintRules1949); if (state.failed) return ;
        pushFollow(FOLLOW_modelReference_in_synpred22_NRLConstraintRules1951);
        modelReference();

        state._fsp--;
        if (state.failed) return ;
        match(input,WHERE,FOLLOW_WHERE_in_synpred22_NRLConstraintRules1953); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred22_NRLConstraintRules

    // $ANTLR start synpred23_NRLConstraintRules
    public final void synpred23_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:355:5: ( OPERATOR )
        // NRLConstraintRules.g:355:6: OPERATOR
        {
        match(input,OPERATOR,FOLLOW_OPERATOR_in_synpred23_NRLConstraintRules2000); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred23_NRLConstraintRules

    // $ANTLR start synpred24_NRLConstraintRules
    public final void synpred24_NRLConstraintRules_fragment() throws RecognitionException {   
        // NRLConstraintRules.g:387:5: ( NUMBER_OF UNIQUE )
        // NRLConstraintRules.g:387:6: NUMBER_OF UNIQUE
        {
        match(input,NUMBER_OF,FOLLOW_NUMBER_OF_in_synpred24_NRLConstraintRules2151); if (state.failed) return ;
        match(input,UNIQUE,FOLLOW_UNIQUE_in_synpred24_NRLConstraintRules2153); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred24_NRLConstraintRules

    // Delegated rules

    public final boolean synpred22_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred22_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred20_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred20_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred10_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred10_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred1_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred1_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred2_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred2_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred23_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred23_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred8_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred8_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred12_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred12_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred18_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred18_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred21_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred21_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred14_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred14_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred3_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred3_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred6_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred6_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred16_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred16_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred7_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred7_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred15_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred15_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred9_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred9_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred5_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred5_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred19_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred19_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred11_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred11_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred4_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred4_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred13_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred13_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred24_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred24_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred17_NRLConstraintRules() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred17_NRLConstraintRules_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }


    protected DFA14 dfa14 = new DFA14(this);
    protected DFA27 dfa27 = new DFA27(this);
    protected DFA31 dfa31 = new DFA31(this);
    protected DFA46 dfa46 = new DFA46(this);
    protected DFA47 dfa47 = new DFA47(this);
    protected DFA54 dfa54 = new DFA54(this);
    protected DFA56 dfa56 = new DFA56(this);
    protected DFA59 dfa59 = new DFA59(this);
    static final String DFA14_eotS =
        "\36\uffff";
    static final String DFA14_eofS =
        "\36\uffff";
    static final String DFA14_minS =
        "\1\36\13\0\22\uffff";
    static final String DFA14_maxS =
        "\1\130\13\0\22\uffff";
    static final String DFA14_acceptS =
        "\14\uffff\1\5\1\6\1\7\13\uffff\1\1\1\2\1\4\1\3";
    static final String DFA14_specialS =
        "\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13\22\uffff}>";
    static final String[] DFA14_transitionS = {
            "\1\16\12\uffff\1\1\1\4\1\3\1\2\1\5\1\6\1\7\1\10\1\11\1\12\1"+
            "\uffff\1\15\1\uffff\1\14\12\uffff\1\16\2\uffff\1\16\3\uffff"+
            "\2\16\4\uffff\2\16\3\uffff\5\16\1\13",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA14_eot = DFA.unpackEncodedString(DFA14_eotS);
    static final short[] DFA14_eof = DFA.unpackEncodedString(DFA14_eofS);
    static final char[] DFA14_min = DFA.unpackEncodedStringToUnsignedChars(DFA14_minS);
    static final char[] DFA14_max = DFA.unpackEncodedStringToUnsignedChars(DFA14_maxS);
    static final short[] DFA14_accept = DFA.unpackEncodedString(DFA14_acceptS);
    static final short[] DFA14_special = DFA.unpackEncodedString(DFA14_specialS);
    static final short[][] DFA14_transition;

    static {
        int numStates = DFA14_transitionS.length;
        DFA14_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA14_transition[i] = DFA.unpackEncodedString(DFA14_transitionS[i]);
        }
    }

    class DFA14 extends DFA {

        public DFA14(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 14;
            this.eot = DFA14_eot;
            this.eof = DFA14_eof;
            this.min = DFA14_min;
            this.max = DFA14_max;
            this.accept = DFA14_accept;
            this.special = DFA14_special;
            this.transition = DFA14_transition;
        }
        public String getDescription() {
            return "180:1: logicalStatement : ( ( modelReference ( PRESENT | HASHAVE ) )=> existsStatement | ( modelReference THAT )=> existsStatement | ( modelReference NOT_PRESENT )=> notExistsStatement | ( enumeratorDisambiguation )=> existsStatement | ( forallStart )=> forallStatement | globalExistsStatement | predicateStatement );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA14_0 = input.LA(1);

                         
                        int index14_0 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA14_0==IN) ) {s = 1;}

                        else if ( (LA14_0==AT_MOST) ) {s = 2;}

                        else if ( (LA14_0==AT_LEAST) ) {s = 3;}

                        else if ( (LA14_0==EXACTLY) ) {s = 4;}

                        else if ( (LA14_0==ONE) ) {s = 5;}

                        else if ( (LA14_0==TWO) ) {s = 6;}

                        else if ( (LA14_0==THREE) ) {s = 7;}

                        else if ( (LA14_0==FOUR) ) {s = 8;}

                        else if ( (LA14_0==INTEGER_NUMBER) ) {s = 9;}

                        else if ( (LA14_0==NO) ) {s = 10;}

                        else if ( (LA14_0==IDENTIFIER) ) {s = 11;}

                        else if ( (LA14_0==EACH) && (synpred6_NRLConstraintRules())) {s = 12;}

                        else if ( (LA14_0==THERE_IS) ) {s = 13;}

                        else if ( (LA14_0==LPAREN||LA14_0==FOLLOWING||LA14_0==MINUS||(LA14_0>=OPERATOR && LA14_0<=PROPERTYNAME)||(LA14_0>=SUM_OF && LA14_0<=NUMBER_OF)||(LA14_0>=FIRST && LA14_0<=ORDINAL_NUMBER)) ) {s = 14;}

                         
                        input.seek(index14_0);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA14_1 = input.LA(1);

                         
                        int index14_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred2_NRLConstraintRules()) ) {s = 26;}

                        else if ( (synpred3_NRLConstraintRules()) ) {s = 27;}

                        else if ( (synpred5_NRLConstraintRules()) ) {s = 28;}

                        else if ( (synpred6_NRLConstraintRules()) ) {s = 12;}

                         
                        input.seek(index14_1);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA14_2 = input.LA(1);

                         
                        int index14_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred2_NRLConstraintRules()) ) {s = 26;}

                        else if ( (synpred3_NRLConstraintRules()) ) {s = 27;}

                        else if ( (synpred5_NRLConstraintRules()) ) {s = 28;}

                         
                        input.seek(index14_2);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA14_3 = input.LA(1);

                         
                        int index14_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred2_NRLConstraintRules()) ) {s = 26;}

                        else if ( (synpred3_NRLConstraintRules()) ) {s = 27;}

                        else if ( (synpred5_NRLConstraintRules()) ) {s = 28;}

                         
                        input.seek(index14_3);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA14_4 = input.LA(1);

                         
                        int index14_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred2_NRLConstraintRules()) ) {s = 26;}

                        else if ( (synpred3_NRLConstraintRules()) ) {s = 27;}

                        else if ( (synpred5_NRLConstraintRules()) ) {s = 28;}

                         
                        input.seek(index14_4);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA14_5 = input.LA(1);

                         
                        int index14_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred2_NRLConstraintRules()) ) {s = 26;}

                        else if ( (synpred3_NRLConstraintRules()) ) {s = 27;}

                        else if ( (synpred5_NRLConstraintRules()) ) {s = 28;}

                         
                        input.seek(index14_5);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA14_6 = input.LA(1);

                         
                        int index14_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred2_NRLConstraintRules()) ) {s = 26;}

                        else if ( (synpred3_NRLConstraintRules()) ) {s = 27;}

                        else if ( (synpred5_NRLConstraintRules()) ) {s = 28;}

                         
                        input.seek(index14_6);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA14_7 = input.LA(1);

                         
                        int index14_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred2_NRLConstraintRules()) ) {s = 26;}

                        else if ( (synpred3_NRLConstraintRules()) ) {s = 27;}

                        else if ( (synpred5_NRLConstraintRules()) ) {s = 28;}

                         
                        input.seek(index14_7);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA14_8 = input.LA(1);

                         
                        int index14_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred2_NRLConstraintRules()) ) {s = 26;}

                        else if ( (synpred3_NRLConstraintRules()) ) {s = 27;}

                        else if ( (synpred5_NRLConstraintRules()) ) {s = 28;}

                         
                        input.seek(index14_8);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA14_9 = input.LA(1);

                         
                        int index14_9 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred2_NRLConstraintRules()) ) {s = 26;}

                        else if ( (synpred3_NRLConstraintRules()) ) {s = 27;}

                        else if ( (synpred5_NRLConstraintRules()) ) {s = 28;}

                        else if ( (true) ) {s = 14;}

                         
                        input.seek(index14_9);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA14_10 = input.LA(1);

                         
                        int index14_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred2_NRLConstraintRules()) ) {s = 26;}

                        else if ( (synpred3_NRLConstraintRules()) ) {s = 27;}

                        else if ( (synpred5_NRLConstraintRules()) ) {s = 28;}

                         
                        input.seek(index14_10);
                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA14_11 = input.LA(1);

                         
                        int index14_11 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred2_NRLConstraintRules()) ) {s = 26;}

                        else if ( (synpred3_NRLConstraintRules()) ) {s = 27;}

                        else if ( (synpred4_NRLConstraintRules()) ) {s = 29;}

                        else if ( (synpred5_NRLConstraintRules()) ) {s = 28;}

                        else if ( (true) ) {s = 14;}

                         
                        input.seek(index14_11);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 14, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA27_eotS =
        "\15\uffff";
    static final String DFA27_eofS =
        "\15\uffff";
    static final String DFA27_minS =
        "\1\51\1\52\3\55\6\34\2\uffff";
    static final String DFA27_maxS =
        "\1\130\4\62\6\130\2\uffff";
    static final String DFA27_acceptS =
        "\13\uffff\1\2\1\1";
    static final String DFA27_specialS =
        "\5\uffff\1\0\1\1\1\2\1\3\1\4\1\5\2\uffff}>";
    static final String[] DFA27_transitionS = {
            "\1\1\1\4\1\3\1\2\1\5\1\6\1\7\1\10\1\11\1\12\45\uffff\1\13",
            "\1\4\1\3\1\2\1\5\1\6\1\7\1\10\1\11\1\12",
            "\1\5\1\6\1\7\1\10\1\11\1\12",
            "\1\5\1\6\1\7\1\10\1\11\1\12",
            "\1\5\1\6\1\7\1\10\1\11\1\12",
            "\1\14\12\uffff\1\13\60\uffff\1\13",
            "\1\14\12\uffff\1\13\60\uffff\1\13",
            "\1\14\12\uffff\1\13\60\uffff\1\13",
            "\1\14\12\uffff\1\13\60\uffff\1\13",
            "\1\14\12\uffff\1\13\60\uffff\1\13",
            "\1\14\12\uffff\1\13\60\uffff\1\13",
            "",
            ""
    };

    static final short[] DFA27_eot = DFA.unpackEncodedString(DFA27_eotS);
    static final short[] DFA27_eof = DFA.unpackEncodedString(DFA27_eofS);
    static final char[] DFA27_min = DFA.unpackEncodedStringToUnsignedChars(DFA27_minS);
    static final char[] DFA27_max = DFA.unpackEncodedStringToUnsignedChars(DFA27_maxS);
    static final short[] DFA27_accept = DFA.unpackEncodedString(DFA27_acceptS);
    static final short[] DFA27_special = DFA.unpackEncodedString(DFA27_specialS);
    static final short[][] DFA27_transition;

    static {
        int numStates = DFA27_transitionS.length;
        DFA27_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA27_transition[i] = DFA.unpackEncodedString(DFA27_transitionS[i]);
        }
    }

    class DFA27 extends DFA {

        public DFA27(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 27;
            this.eot = DFA27_eot;
            this.eof = DFA27_eof;
            this.min = DFA27_min;
            this.max = DFA27_max;
            this.accept = DFA27_accept;
            this.special = DFA27_special;
            this.transition = DFA27_transition;
        }
        public String getDescription() {
            return "203:1: existsStatement : ( ( enumeratorStart HASHAVE )=> enumerator HASHAVE simpleOrComplexConstraint -> ^( VT_EXISTS enumerator simpleOrComplexConstraint ) | ( enumerator ( OF )? )? modelReference ( PRESENT | ( ( ( ( THAT )? HASHAVE ) | WHERE )? simpleOrComplexConstraint ) ) -> ^( VT_EXISTS ( enumerator )? modelReference ( simpleOrComplexConstraint )? ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA27_5 = input.LA(1);

                         
                        int index27_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA27_5==HASHAVE) && (synpred7_NRLConstraintRules())) {s = 12;}

                        else if ( (LA27_5==OF||LA27_5==IDENTIFIER) ) {s = 11;}

                         
                        input.seek(index27_5);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA27_6 = input.LA(1);

                         
                        int index27_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA27_6==HASHAVE) && (synpred7_NRLConstraintRules())) {s = 12;}

                        else if ( (LA27_6==OF||LA27_6==IDENTIFIER) ) {s = 11;}

                         
                        input.seek(index27_6);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA27_7 = input.LA(1);

                         
                        int index27_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA27_7==HASHAVE) && (synpred7_NRLConstraintRules())) {s = 12;}

                        else if ( (LA27_7==OF||LA27_7==IDENTIFIER) ) {s = 11;}

                         
                        input.seek(index27_7);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA27_8 = input.LA(1);

                         
                        int index27_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA27_8==HASHAVE) && (synpred7_NRLConstraintRules())) {s = 12;}

                        else if ( (LA27_8==OF||LA27_8==IDENTIFIER) ) {s = 11;}

                         
                        input.seek(index27_8);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA27_9 = input.LA(1);

                         
                        int index27_9 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA27_9==HASHAVE) && (synpred7_NRLConstraintRules())) {s = 12;}

                        else if ( (LA27_9==OF||LA27_9==IDENTIFIER) ) {s = 11;}

                         
                        input.seek(index27_9);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA27_10 = input.LA(1);

                         
                        int index27_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA27_10==HASHAVE) && (synpred7_NRLConstraintRules())) {s = 12;}

                        else if ( (LA27_10==OF||LA27_10==IDENTIFIER) ) {s = 11;}

                         
                        input.seek(index27_10);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 27, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA31_eotS =
        "\20\uffff";
    static final String DFA31_eofS =
        "\20\uffff";
    static final String DFA31_minS =
        "\1\36\1\0\16\uffff";
    static final String DFA31_maxS =
        "\1\130\1\0\16\uffff";
    static final String DFA31_acceptS =
        "\2\uffff\1\2\14\uffff\1\1";
    static final String DFA31_specialS =
        "\1\uffff\1\0\16\uffff}>";
    static final String[] DFA31_transitionS = {
            "\1\1\22\uffff\1\2\17\uffff\1\2\2\uffff\1\2\3\uffff\2\2\4\uffff"+
            "\2\2\3\uffff\6\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA31_eot = DFA.unpackEncodedString(DFA31_eotS);
    static final short[] DFA31_eof = DFA.unpackEncodedString(DFA31_eofS);
    static final char[] DFA31_min = DFA.unpackEncodedStringToUnsignedChars(DFA31_minS);
    static final char[] DFA31_max = DFA.unpackEncodedStringToUnsignedChars(DFA31_maxS);
    static final short[] DFA31_accept = DFA.unpackEncodedString(DFA31_acceptS);
    static final short[] DFA31_special = DFA.unpackEncodedString(DFA31_specialS);
    static final short[][] DFA31_transition;

    static {
        int numStates = DFA31_transitionS.length;
        DFA31_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA31_transition[i] = DFA.unpackEncodedString(DFA31_transitionS[i]);
        }
    }

    class DFA31 extends DFA {

        public DFA31(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 31;
            this.eot = DFA31_eot;
            this.eof = DFA31_eof;
            this.min = DFA31_min;
            this.max = DFA31_max;
            this.accept = DFA31_accept;
            this.special = DFA31_special;
            this.transition = DFA31_transition;
        }
        public String getDescription() {
            return "221:1: simpleOrComplexConstraint : ( ( LPAREN )=> LPAREN constraint RPAREN | predicateStatement );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA31_1 = input.LA(1);

                         
                        int index31_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred8_NRLConstraintRules()) ) {s = 15;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index31_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 31, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA46_eotS =
        "\25\uffff";
    static final String DFA46_eofS =
        "\25\uffff";
    static final String DFA46_minS =
        "\1\36\16\0\6\uffff";
    static final String DFA46_maxS =
        "\1\130\16\0\6\uffff";
    static final String DFA46_acceptS =
        "\17\uffff\1\1\1\2\1\6\1\3\1\4\1\5";
    static final String DFA46_specialS =
        "\1\uffff\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1"+
        "\14\1\15\6\uffff}>";
    static final String[] DFA46_transitionS = {
            "\1\5\22\uffff\1\13\17\uffff\1\16\2\uffff\1\14\3\uffff\1\1\1"+
            "\2\4\uffff\1\6\1\7\3\uffff\1\4\1\10\1\11\1\12\1\15\1\3",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA46_eot = DFA.unpackEncodedString(DFA46_eotS);
    static final short[] DFA46_eof = DFA.unpackEncodedString(DFA46_eofS);
    static final char[] DFA46_min = DFA.unpackEncodedStringToUnsignedChars(DFA46_minS);
    static final char[] DFA46_max = DFA.unpackEncodedStringToUnsignedChars(DFA46_maxS);
    static final short[] DFA46_accept = DFA.unpackEncodedString(DFA46_acceptS);
    static final short[] DFA46_special = DFA.unpackEncodedString(DFA46_specialS);
    static final short[][] DFA46_transition;

    static {
        int numStates = DFA46_transitionS.length;
        DFA46_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA46_transition[i] = DFA.unpackEncodedString(DFA46_transitionS[i]);
        }
    }

    class DFA46 extends DFA {

        public DFA46(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 46;
            this.eot = DFA46_eot;
            this.eof = DFA46_eof;
            this.min = DFA46_min;
            this.max = DFA46_max;
            this.accept = DFA46_accept;
            this.special = DFA46_special;
            this.transition = DFA46_transition;
        }
        public String getDescription() {
            return "241:1: predicateStatement : ( ( expression IS_IN )=> expression IS_IN listDefinition | ( expression IS_NOT_IN )=> expression IS_NOT_IN listDefinition | ( modelReference KIND_OF )=> isSubtypePredicate | ( FOLLOWING PRESENT )=> multipleExistsStatement | ( FOLLOWING NOT_PRESENT )=> multipleNotExistsStatement | expression ( ( EQUALS | NOT_EQUALS | LESS | LESS_EQ | GREATER | GREATER_EQ ) expression )? );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA46_1 = input.LA(1);

                         
                        int index46_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred12_NRLConstraintRules()) ) {s = 15;}

                        else if ( (synpred13_NRLConstraintRules()) ) {s = 16;}

                        else if ( (true) ) {s = 17;}

                         
                        input.seek(index46_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA46_2 = input.LA(1);

                         
                        int index46_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred12_NRLConstraintRules()) ) {s = 15;}

                        else if ( (synpred13_NRLConstraintRules()) ) {s = 16;}

                        else if ( (true) ) {s = 17;}

                         
                        input.seek(index46_2);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA46_3 = input.LA(1);

                         
                        int index46_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred12_NRLConstraintRules()) ) {s = 15;}

                        else if ( (synpred13_NRLConstraintRules()) ) {s = 16;}

                        else if ( (synpred14_NRLConstraintRules()) ) {s = 18;}

                        else if ( (true) ) {s = 17;}

                         
                        input.seek(index46_3);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA46_4 = input.LA(1);

                         
                        int index46_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred12_NRLConstraintRules()) ) {s = 15;}

                        else if ( (synpred13_NRLConstraintRules()) ) {s = 16;}

                        else if ( (true) ) {s = 17;}

                         
                        input.seek(index46_4);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA46_5 = input.LA(1);

                         
                        int index46_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred12_NRLConstraintRules()) ) {s = 15;}

                        else if ( (synpred13_NRLConstraintRules()) ) {s = 16;}

                        else if ( (true) ) {s = 17;}

                         
                        input.seek(index46_5);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA46_6 = input.LA(1);

                         
                        int index46_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred12_NRLConstraintRules()) ) {s = 15;}

                        else if ( (synpred13_NRLConstraintRules()) ) {s = 16;}

                        else if ( (true) ) {s = 17;}

                         
                        input.seek(index46_6);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA46_7 = input.LA(1);

                         
                        int index46_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred12_NRLConstraintRules()) ) {s = 15;}

                        else if ( (synpred13_NRLConstraintRules()) ) {s = 16;}

                        else if ( (true) ) {s = 17;}

                         
                        input.seek(index46_7);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA46_8 = input.LA(1);

                         
                        int index46_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred12_NRLConstraintRules()) ) {s = 15;}

                        else if ( (synpred13_NRLConstraintRules()) ) {s = 16;}

                        else if ( (true) ) {s = 17;}

                         
                        input.seek(index46_8);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA46_9 = input.LA(1);

                         
                        int index46_9 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred12_NRLConstraintRules()) ) {s = 15;}

                        else if ( (synpred13_NRLConstraintRules()) ) {s = 16;}

                        else if ( (true) ) {s = 17;}

                         
                        input.seek(index46_9);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA46_10 = input.LA(1);

                         
                        int index46_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred12_NRLConstraintRules()) ) {s = 15;}

                        else if ( (synpred13_NRLConstraintRules()) ) {s = 16;}

                        else if ( (true) ) {s = 17;}

                         
                        input.seek(index46_10);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA46_11 = input.LA(1);

                         
                        int index46_11 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred12_NRLConstraintRules()) ) {s = 15;}

                        else if ( (synpred13_NRLConstraintRules()) ) {s = 16;}

                        else if ( (true) ) {s = 17;}

                         
                        input.seek(index46_11);
                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA46_12 = input.LA(1);

                         
                        int index46_12 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred12_NRLConstraintRules()) ) {s = 15;}

                        else if ( (synpred13_NRLConstraintRules()) ) {s = 16;}

                        else if ( (true) ) {s = 17;}

                         
                        input.seek(index46_12);
                        if ( s>=0 ) return s;
                        break;
                    case 12 : 
                        int LA46_13 = input.LA(1);

                         
                        int index46_13 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred12_NRLConstraintRules()) ) {s = 15;}

                        else if ( (synpred13_NRLConstraintRules()) ) {s = 16;}

                        else if ( (true) ) {s = 17;}

                         
                        input.seek(index46_13);
                        if ( s>=0 ) return s;
                        break;
                    case 13 : 
                        int LA46_14 = input.LA(1);

                         
                        int index46_14 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred15_NRLConstraintRules()) ) {s = 19;}

                        else if ( (synpred16_NRLConstraintRules()) ) {s = 20;}

                         
                        input.seek(index46_14);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 46, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA47_eotS =
        "\21\uffff";
    static final String DFA47_eofS =
        "\1\1\20\uffff";
    static final String DFA47_minS =
        "\1\25\1\uffff\1\25\2\uffff\1\47\3\uffff\1\61\1\47\1\130\3\uffff"+
        "\1\130\1\uffff";
    static final String DFA47_maxS =
        "\1\152\1\uffff\1\152\2\uffff\1\130\3\uffff\1\126\2\130\3\uffff"+
        "\1\130\1\uffff";
    static final String DFA47_acceptS =
        "\1\uffff\1\2\1\uffff\2\1\1\uffff\3\1\3\uffff\3\1\1\uffff\1\1";
    static final String DFA47_specialS =
        "\21\uffff}>";
    static final String[] DFA47_transitionS = {
            "\1\1\1\2\1\uffff\1\1\4\uffff\12\1\2\uffff\12\1\1\uffff\1\1"+
            "\1\uffff\1\1\1\uffff\10\1\1\uffff\1\1\1\uffff\15\1\3\uffff\10"+
            "\1\13\uffff\1\1\1\uffff\3\1",
            "",
            "\1\1\10\uffff\1\1\1\uffff\2\1\7\uffff\10\1\1\3\1\1\1\uffff"+
            "\1\1\1\uffff\1\1\12\uffff\1\1\2\uffff\1\11\3\uffff\2\1\4\uffff"+
            "\2\1\3\uffff\1\5\1\6\1\7\1\10\1\12\1\4\1\1\14\uffff\1\1\1\uffff"+
            "\3\1",
            "",
            "",
            "\1\13\60\uffff\1\14",
            "",
            "",
            "",
            "\1\16\44\uffff\1\15",
            "\1\17\60\uffff\1\20",
            "\1\14",
            "",
            "",
            "",
            "\1\20",
            ""
    };

    static final short[] DFA47_eot = DFA.unpackEncodedString(DFA47_eotS);
    static final short[] DFA47_eof = DFA.unpackEncodedString(DFA47_eofS);
    static final char[] DFA47_min = DFA.unpackEncodedStringToUnsignedChars(DFA47_minS);
    static final char[] DFA47_max = DFA.unpackEncodedStringToUnsignedChars(DFA47_maxS);
    static final short[] DFA47_accept = DFA.unpackEncodedString(DFA47_acceptS);
    static final short[] DFA47_special = DFA.unpackEncodedString(DFA47_specialS);
    static final short[][] DFA47_transition;

    static {
        int numStates = DFA47_transitionS.length;
        DFA47_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA47_transition[i] = DFA.unpackEncodedString(DFA47_transitionS[i]);
        }
    }

    class DFA47 extends DFA {

        public DFA47(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 47;
            this.eot = DFA47_eot;
            this.eof = DFA47_eof;
            this.min = DFA47_min;
            this.max = DFA47_max;
            this.accept = DFA47_accept;
            this.special = DFA47_special;
            this.transition = DFA47_transition;
        }
        public String getDescription() {
            return "()* loopback of 263:16: ( COMMA identifier )*";
        }
    }
    static final String DFA54_eotS =
        "\22\uffff";
    static final String DFA54_eofS =
        "\22\uffff";
    static final String DFA54_minS =
        "\1\36\2\uffff\2\0\15\uffff";
    static final String DFA54_maxS =
        "\1\130\2\uffff\2\0\15\uffff";
    static final String DFA54_acceptS =
        "\1\uffff\1\1\1\2\2\uffff\1\7\1\10\1\uffff\1\11\5\uffff\1\3\1\4"+
        "\1\5\1\6";
    static final String DFA54_specialS =
        "\1\0\2\uffff\1\1\1\2\15\uffff}>";
    static final String[] DFA54_transitionS = {
            "\1\5\22\uffff\1\10\22\uffff\1\10\3\uffff\1\1\1\2\4\uffff\2"+
            "\6\3\uffff\1\4\4\10\1\3",
            "",
            "",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA54_eot = DFA.unpackEncodedString(DFA54_eotS);
    static final short[] DFA54_eof = DFA.unpackEncodedString(DFA54_eofS);
    static final char[] DFA54_min = DFA.unpackEncodedStringToUnsignedChars(DFA54_minS);
    static final char[] DFA54_max = DFA.unpackEncodedStringToUnsignedChars(DFA54_maxS);
    static final short[] DFA54_accept = DFA.unpackEncodedString(DFA54_acceptS);
    static final short[] DFA54_special = DFA.unpackEncodedString(DFA54_specialS);
    static final short[][] DFA54_transition;

    static {
        int numStates = DFA54_transitionS.length;
        DFA54_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA54_transition[i] = DFA.unpackEncodedString(DFA54_transitionS[i]);
        }
    }

    class DFA54 extends DFA {

        public DFA54(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 54;
            this.eot = DFA54_eot;
            this.eof = DFA54_eof;
            this.min = DFA54_min;
            this.max = DFA54_max;
            this.accept = DFA54_accept;
            this.special = DFA54_special;
            this.transition = DFA54_transition;
        }
        public String getDescription() {
            return "341:1: term : ( ( OPERATOR )=> operatorInvocation | ( PROPERTYNAME )=> propertyApplication | ( modelReference AS_A )=> castExpression | ( modelReference WHERE )=> selectionExpression | ( FIRST modelReference WHERE )=> selectionExpression | ( FIRST OF modelReference WHERE )=> selectionExpression | LPAREN constraint RPAREN | functionalExpression | identifier );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA54_0 = input.LA(1);

                         
                        int index54_0 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA54_0==OPERATOR) && (synpred17_NRLConstraintRules())) {s = 1;}

                        else if ( (LA54_0==PROPERTYNAME) && (synpred18_NRLConstraintRules())) {s = 2;}

                        else if ( (LA54_0==IDENTIFIER) ) {s = 3;}

                        else if ( (LA54_0==FIRST) ) {s = 4;}

                        else if ( (LA54_0==LPAREN) ) {s = 5;}

                        else if ( ((LA54_0>=SUM_OF && LA54_0<=NUMBER_OF)) ) {s = 6;}

                        else if ( (LA54_0==INTEGER_NUMBER||LA54_0==MINUS||(LA54_0>=SINGLE_QUOTED_STRING && LA54_0<=ORDINAL_NUMBER)) ) {s = 8;}

                         
                        input.seek(index54_0);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA54_3 = input.LA(1);

                         
                        int index54_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred19_NRLConstraintRules()) ) {s = 14;}

                        else if ( (synpred20_NRLConstraintRules()) ) {s = 15;}

                        else if ( (synpred21_NRLConstraintRules()) ) {s = 16;}

                        else if ( (synpred22_NRLConstraintRules()) ) {s = 17;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index54_3);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA54_4 = input.LA(1);

                         
                        int index54_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred20_NRLConstraintRules()) ) {s = 15;}

                        else if ( (synpred21_NRLConstraintRules()) ) {s = 16;}

                        else if ( (synpred22_NRLConstraintRules()) ) {s = 17;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index54_4);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 54, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA56_eotS =
        "\75\uffff";
    static final String DFA56_eofS =
        "\1\16\74\uffff";
    static final String DFA56_minS =
        "\1\25\74\uffff";
    static final String DFA56_maxS =
        "\1\152\74\uffff";
    static final String DFA56_acceptS =
        "\1\uffff\15\1\1\2\56\uffff";
    static final String DFA56_specialS =
        "\75\uffff}>";
    static final String[] DFA56_transitionS = {
            "\2\16\1\uffff\1\16\4\uffff\1\16\1\5\10\16\2\uffff\10\16\1\13"+
            "\1\16\1\uffff\1\16\1\uffff\1\16\1\uffff\10\16\1\uffff\1\16\1"+
            "\uffff\1\16\1\14\3\16\1\1\1\2\4\16\1\6\1\7\3\uffff\1\4\1\10"+
            "\1\11\1\12\1\15\1\3\2\16\13\uffff\1\16\1\uffff\3\16",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA56_eot = DFA.unpackEncodedString(DFA56_eotS);
    static final short[] DFA56_eof = DFA.unpackEncodedString(DFA56_eofS);
    static final char[] DFA56_min = DFA.unpackEncodedStringToUnsignedChars(DFA56_minS);
    static final char[] DFA56_max = DFA.unpackEncodedStringToUnsignedChars(DFA56_maxS);
    static final short[] DFA56_accept = DFA.unpackEncodedString(DFA56_acceptS);
    static final short[] DFA56_special = DFA.unpackEncodedString(DFA56_specialS);
    static final short[][] DFA56_transition;

    static {
        int numStates = DFA56_transitionS.length;
        DFA56_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA56_transition[i] = DFA.unpackEncodedString(DFA56_transitionS[i]);
        }
    }

    class DFA56 extends DFA {

        public DFA56(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 56;
            this.eot = DFA56_eot;
            this.eof = DFA56_eof;
            this.min = DFA56_min;
            this.max = DFA56_max;
            this.accept = DFA56_accept;
            this.special = DFA56_special;
            this.transition = DFA56_transition;
        }
        public String getDescription() {
            return "367:4: ( operatorParameterList )?";
        }
    }
    static final String DFA59_eotS =
        "\75\uffff";
    static final String DFA59_eofS =
        "\1\16\74\uffff";
    static final String DFA59_minS =
        "\1\25\74\uffff";
    static final String DFA59_maxS =
        "\1\152\74\uffff";
    static final String DFA59_acceptS =
        "\1\uffff\15\1\1\2\56\uffff";
    static final String DFA59_specialS =
        "\75\uffff}>";
    static final String[] DFA59_transitionS = {
            "\2\16\1\uffff\1\16\4\uffff\1\16\1\5\10\16\2\uffff\10\16\1\13"+
            "\1\16\1\uffff\1\16\1\uffff\1\16\1\uffff\10\16\1\uffff\1\16\1"+
            "\uffff\1\16\1\14\3\16\1\1\1\2\4\16\1\6\1\7\3\uffff\1\4\1\10"+
            "\1\11\1\12\1\15\1\3\2\16\13\uffff\1\16\1\uffff\3\16",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA59_eot = DFA.unpackEncodedString(DFA59_eotS);
    static final short[] DFA59_eof = DFA.unpackEncodedString(DFA59_eofS);
    static final char[] DFA59_min = DFA.unpackEncodedStringToUnsignedChars(DFA59_minS);
    static final char[] DFA59_max = DFA.unpackEncodedStringToUnsignedChars(DFA59_maxS);
    static final short[] DFA59_accept = DFA.unpackEncodedString(DFA59_acceptS);
    static final short[] DFA59_special = DFA.unpackEncodedString(DFA59_specialS);
    static final short[][] DFA59_transition;

    static {
        int numStates = DFA59_transitionS.length;
        DFA59_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA59_transition[i] = DFA.unpackEncodedString(DFA59_transitionS[i]);
        }
    }

    class DFA59 extends DFA {

        public DFA59(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 59;
            this.eot = DFA59_eot;
            this.eof = DFA59_eof;
            this.min = DFA59_min;
            this.max = DFA59_max;
            this.accept = DFA59_accept;
            this.special = DFA59_special;
            this.transition = DFA59_transition;
        }
        public String getDescription() {
            return "382:19: ( operatorParameterList )?";
        }
    }
 

    public static final BitSet FOLLOW_context_in_validationRuleDeclaration165 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_VALIDATION_RULE_in_validationRuleDeclaration167 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_validationRuleDeclaration170 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_validationRuleVariableDeclaration_in_validationRuleDeclaration172 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_constraint_in_validationRuleDeclaration175 = new BitSet(new long[]{0x0000000000000002L,0x0000000002000000L});
    public static final BitSet FOLLOW_constraintRuleReport_in_validationRuleDeclaration179 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleVariableDeclaration_in_validationRuleVariableDeclaration202 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_COMMA_in_validationRuleVariableDeclaration204 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_multipleContext_in_validationFragmentDeclaration233 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_VALIDATION_FRAGMENT_in_validationFragmentDeclaration235 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_validationFragmentDeclaration238 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_constraint_in_validationFragmentDeclaration240 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULESET_in_ruleSetDeclaration255 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_ruleSetDeclaration258 = new BitSet(new long[]{0x0000000002000002L});
    public static final BitSet FOLLOW_APPLIES_TO_in_ruleSetDeclaration270 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_ruleSetDeclaration273 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_WHERE_in_ruleSetDeclaration275 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_constraint_in_ruleSetDeclaration278 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleVariableDeclaration_in_globalVariableDeclaration304 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_simpleVariableDeclaration328 = new BitSet(new long[]{0x0000000018000000L});
    public static final BitSet FOLLOW_REPRESENT_in_simpleVariableDeclaration331 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_HASHAVE_in_simpleVariableDeclaration334 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_expression_in_simpleVariableDeclaration338 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CONTEXT_in_context353 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_context356 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CONTEXT_in_multipleContext371 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_multipleContextEntry_in_multipleContext374 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_COMMA_in_multipleContext378 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_multipleContextEntry_in_multipleContext381 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_modelReference_in_multipleContextEntry404 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_LPAREN_in_multipleContextEntry406 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_multipleContextEntry408 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_RPAREN_in_multipleContextEntry410 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_statement_in_constraint438 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IF_in_statement453 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_iffStatement_in_statement456 = new BitSet(new long[]{0x0000000200000000L});
    public static final BitSet FOLLOW_THEN_in_statement458 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_statement_in_statement461 = new BitSet(new long[]{0x0000000400000002L});
    public static final BitSet FOLLOW_ELSE_in_statement498 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_statement_in_statement501 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_iffStatement_in_statement513 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_impliesStatement_in_iffStatement528 = new BitSet(new long[]{0x0000000800000002L});
    public static final BitSet FOLLOW_IFF_in_iffStatement531 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_iffStatement_in_iffStatement534 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_orStatement_in_impliesStatement549 = new BitSet(new long[]{0x0000001000000002L});
    public static final BitSet FOLLOW_IMPLIES_in_impliesStatement552 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_impliesStatement_in_impliesStatement555 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_andStatement_in_orStatement572 = new BitSet(new long[]{0x0000002000000002L});
    public static final BitSet FOLLOW_OR_in_orStatement575 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_orStatement_in_orStatement578 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_logicalStatement_in_andStatement595 = new BitSet(new long[]{0x0000004000000002L});
    public static final BitSet FOLLOW_AND_in_andStatement598 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_andStatement_in_andStatement601 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_existsStatement_in_logicalStatement630 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_existsStatement_in_logicalStatement644 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_notExistsStatement_in_logicalStatement658 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_existsStatement_in_logicalStatement671 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_forallStatement_in_logicalStatement683 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_globalExistsStatement_in_logicalStatement689 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_predicateStatement_in_logicalStatement695 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_enumeratorStart_in_enumeratorDisambiguation708 = new BitSet(new long[]{0x0007FF8010000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_OF_in_enumeratorDisambiguation710 = new BitSet(new long[]{0x0007FF0010000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_THAT_in_enumeratorDisambiguation714 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_HASHAVE_in_enumeratorDisambiguation718 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modelReference_in_enumeratorDisambiguation722 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IN_in_enumeratorStart741 = new BitSet(new long[]{0x0007FC0000000000L});
    public static final BitSet FOLLOW_set_in_enumeratorStart745 = new BitSet(new long[]{0x0007E00000000000L});
    public static final BitSet FOLLOW_set_in_enumeratorStart754 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IN_in_enumerator792 = new BitSet(new long[]{0x0007FC0000000000L});
    public static final BitSet FOLLOW_AT_MOST_in_enumerator799 = new BitSet(new long[]{0x0007E00000000000L});
    public static final BitSet FOLLOW_AT_LEAST_in_enumerator805 = new BitSet(new long[]{0x0007E00000000000L});
    public static final BitSet FOLLOW_EXACTLY_in_enumerator811 = new BitSet(new long[]{0x0007E00000000000L});
    public static final BitSet FOLLOW_ONE_in_enumerator818 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TWO_in_enumerator822 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_THREE_in_enumerator826 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FOUR_in_enumerator830 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INTEGER_NUMBER_in_enumerator834 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NO_in_enumerator838 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_enumerator_in_existsStatement883 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_HASHAVE_in_existsStatement885 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_simpleOrComplexConstraint_in_existsStatement887 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_enumerator_in_existsStatement907 = new BitSet(new long[]{0x0007FE8000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_OF_in_existsStatement909 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_existsStatement914 = new BitSet(new long[]{0x005FFF0154200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_PRESENT_in_existsStatement917 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_THAT_in_existsStatement926 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_HASHAVE_in_existsStatement930 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_WHERE_in_existsStatement935 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_simpleOrComplexConstraint_in_existsStatement939 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_THERE_IS_in_globalExistsStatement975 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_NO_in_globalExistsStatement979 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_globalExistsStatement983 = new BitSet(new long[]{0x0000000044000002L});
    public static final BitSet FOLLOW_LPAREN_in_globalExistsStatement995 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_globalExistsStatement1000 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_RPAREN_in_globalExistsStatement1002 = new BitSet(new long[]{0x0000000004000002L});
    public static final BitSet FOLLOW_WHERE_in_globalExistsStatement1021 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_simpleOrComplexConstraint_in_globalExistsStatement1024 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_simpleOrComplexConstraint1052 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_constraint_in_simpleOrComplexConstraint1055 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_RPAREN_in_simpleOrComplexConstraint1057 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_predicateStatement_in_simpleOrComplexConstraint1064 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modelReference_in_notExistsStatement1077 = new BitSet(new long[]{0x0020000000000000L});
    public static final BitSet FOLLOW_NOT_PRESENT_in_notExistsStatement1079 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IN_in_forallStatement1108 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_EACH_in_forallStatement1113 = new BitSet(new long[]{0x0007FE8000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_OF_in_forallStatement1117 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_forallStatement1122 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_HASHAVE_in_forallStatement1124 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_simpleOrComplexConstraint_in_forallStatement1127 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IN_in_forallStatement1144 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_EACH_in_forallStatement1149 = new BitSet(new long[]{0x0007FE8000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_OF_in_forallStatement1153 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_forallStatement1158 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_HASHAVE_in_forallStatement1160 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_simpleOrComplexConstraint_in_forallStatement1163 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IN_in_forallStatement1178 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_EACH_in_forallStatement1183 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_forallStatement1186 = new BitSet(new long[]{0x0087FE8000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_IN_COLLECTION_in_forallStatement1189 = new BitSet(new long[]{0x0007FE8000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_OF_in_forallStatement1195 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_forallStatement1200 = new BitSet(new long[]{0x0057FE0150600000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_HASHAVE_in_forallStatement1203 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_COMMA_in_forallStatement1208 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_simpleOrComplexConstraint_in_forallStatement1213 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IN_in_forallStatement1220 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_EACH_in_forallStatement1225 = new BitSet(new long[]{0x0007FE8000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_OF_in_forallStatement1229 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_forallStatement1234 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_simpleOrComplexConstraint_in_forallStatement1236 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IN_in_forallStart1252 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_EACH_in_forallStart1256 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_predicateStatement1284 = new BitSet(new long[]{0x0100000000000000L});
    public static final BitSet FOLLOW_IS_IN_in_predicateStatement1286 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_listDefinition_in_predicateStatement1289 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_predicateStatement1303 = new BitSet(new long[]{0x0200000000000000L});
    public static final BitSet FOLLOW_IS_NOT_IN_in_predicateStatement1305 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_listDefinition_in_predicateStatement1308 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_isSubtypePredicate_in_predicateStatement1322 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_multipleExistsStatement_in_predicateStatement1336 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_multipleNotExistsStatement_in_predicateStatement1350 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_predicateStatement1356 = new BitSet(new long[]{0xFC00000000000002L});
    public static final BitSet FOLLOW_EQUALS_in_predicateStatement1369 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_NOT_EQUALS_in_predicateStatement1380 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_LESS_in_predicateStatement1391 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_LESS_EQ_in_predicateStatement1402 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_GREATER_in_predicateStatement1413 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_GREATER_EQ_in_predicateStatement1424 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_expression_in_predicateStatement1438 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_identifier_in_listDefinition1459 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_COMMA_in_listDefinition1467 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_identifier_in_listDefinition1475 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_modelReference_in_isSubtypePredicate1494 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_KIND_OF_in_isSubtypePredicate1496 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_isSubtypePredicate1499 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FOLLOWING_in_multipleExistsStatement1519 = new BitSet(new long[]{0x0008000000000000L});
    public static final BitSet FOLLOW_PRESENT_in_multipleExistsStatement1521 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_COLON_in_multipleExistsStatement1523 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReferenceList_in_multipleExistsStatement1525 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FOLLOWING_in_multipleNotExistsStatement1554 = new BitSet(new long[]{0x0020000000000000L});
    public static final BitSet FOLLOW_NOT_PRESENT_in_multipleNotExistsStatement1556 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_COLON_in_multipleNotExistsStatement1558 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReferenceList_in_multipleNotExistsStatement1560 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_addExpression_in_expression1584 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_multiplyExpression_in_addExpression1604 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000018L});
    public static final BitSet FOLLOW_ADD_in_addExpression1646 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_MINUS_in_addExpression1651 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_multiplyExpression_in_addExpression1660 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000018L});
    public static final BitSet FOLLOW_infixOperatorExpression_in_multiplyExpression1681 = new BitSet(new long[]{0x0000000000000002L,0x00000000000000E0L});
    public static final BitSet FOLLOW_TIMES_in_multiplyExpression1723 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_DIV_in_multiplyExpression1726 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_MOD_in_multiplyExpression1729 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_infixOperatorExpression_in_multiplyExpression1738 = new BitSet(new long[]{0x0000000000000002L,0x00000000000000E0L});
    public static final BitSet FOLLOW_infixPropertyApplication_in_infixOperatorExpression1764 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000100L});
    public static final BitSet FOLLOW_OPERATOR_in_infixOperatorExpression1798 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_infixPropertyApplication_in_infixOperatorExpression1801 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000100L});
    public static final BitSet FOLLOW_term_in_infixPropertyApplication1820 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000200L});
    public static final BitSet FOLLOW_PROPERTYNAME_in_infixPropertyApplication1854 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_term_in_infixPropertyApplication1857 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000200L});
    public static final BitSet FOLLOW_operatorInvocation_in_term1884 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_propertyApplication_in_term1896 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_castExpression_in_term1910 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_selectionExpression_in_term1924 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_selectionExpression_in_term1940 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_selectionExpression_in_term1958 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_term1966 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_constraint_in_term1969 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_RPAREN_in_term1971 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_functionalExpression_in_term1978 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_identifier_in_term1984 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_operatorInvocation_in_simpleTerm2005 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_functionalExpression_in_simpleTerm2011 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_identifier_in_simpleTerm2017 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_OPERATOR_in_operatorInvocation2034 = new BitSet(new long[]{0x0007FE0040000002L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_operatorParameterList_in_operatorInvocation2047 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_operatorParameterList2079 = new BitSet(new long[]{0x0000004000000002L,0x0000000000003C00L});
    public static final BitSet FOLLOW_AND_in_operatorParameterList2084 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_FROM_in_operatorParameterList2087 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_TO_in_operatorParameterList2090 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_WITH_in_operatorParameterList2093 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_USING_in_operatorParameterList2096 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_expression_in_operatorParameterList2100 = new BitSet(new long[]{0x0000004000000002L,0x0000000000003C00L});
    public static final BitSet FOLLOW_PROPERTYNAME_in_propertyApplication2120 = new BitSet(new long[]{0x0007FE0040000002L,0x0000000001F8C310L});
    public static final BitSet FOLLOW_operatorParameterList_in_propertyApplication2123 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SUM_OF_in_functionalExpression2141 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_functionalExpression2144 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NUMBER_OF_in_functionalExpression2158 = new BitSet(new long[]{0x0000000000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_UNIQUE_in_functionalExpression2161 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_functionalExpression2164 = new BitSet(new long[]{0x0000000040000002L});
    public static final BitSet FOLLOW_LPAREN_in_functionalExpression2168 = new BitSet(new long[]{0x0000000000000000L,0x0000000000020000L});
    public static final BitSet FOLLOW_BY_in_functionalExpression2171 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_functionalExpression2174 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_RPAREN_in_functionalExpression2176 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NUMBER_OF_in_functionalExpression2186 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_functionalExpression2189 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modelReference_in_castExpression2204 = new BitSet(new long[]{0x0000000000000000L,0x0000000000040000L});
    public static final BitSet FOLLOW_AS_A_in_castExpression2206 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_castExpression2209 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modelReference_in_selectionExpression2224 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_WHERE_in_selectionExpression2226 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_simpleOrComplexConstraint_in_selectionExpression2228 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FIRST_in_selectionExpression2247 = new BitSet(new long[]{0x0007FE8000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_OF_in_selectionExpression2249 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_selectionExpression2252 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_WHERE_in_selectionExpression2254 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_simpleOrComplexConstraint_in_selectionExpression2256 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modelReference_in_identifier2282 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SINGLE_QUOTED_STRING_in_identifier2288 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_BOOLEAN_in_identifier2294 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_number_in_identifier2300 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_collectionIndex_in_identifier2306 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DECIMAL_NUMBER_in_number2319 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INTEGER_NUMBER_in_number2325 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MINUS_in_number2331 = new BitSet(new long[]{0x0000000000000000L,0x0000000000400000L});
    public static final BitSet FOLLOW_DECIMAL_NUMBER_in_number2333 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MINUS_in_number2347 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_INTEGER_NUMBER_in_number2349 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ORDINAL_NUMBER_in_collectionIndex2372 = new BitSet(new long[]{0x0007FE8000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_OF_in_collectionIndex2376 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_collectionIndex2381 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FIRST_in_collectionIndex2387 = new BitSet(new long[]{0x0007FE8000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_OF_in_collectionIndex2389 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_collectionIndex2392 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_identifierSequence_in_modelReference2423 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modelReference_in_modelReferenceList2448 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_COMMA_in_modelReferenceList2482 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_modelReferenceList2485 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_IDENTIFIER_in_identifierSequence2506 = new BitSet(new long[]{0x0000008000000002L});
    public static final BitSet FOLLOW_OF_in_identifierSequence2509 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_identifierSequence_in_identifierSequence2512 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REPORT_in_constraintRuleReport2532 = new BitSet(new long[]{0x0007FE0140000000L,0x0000000003F8C314L});
    public static final BitSet FOLLOW_COLON_in_constraintRuleReport2537 = new BitSet(new long[]{0x0007FE0140000000L,0x0000000003F8C314L});
    public static final BitSet FOLLOW_compoundReport_in_constraintRuleReport2543 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleReports_in_compoundReport2558 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleReport_in_simpleReports2583 = new BitSet(new long[]{0x0007FE0140400002L,0x0000000003F8C314L});
    public static final BitSet FOLLOW_COMMA_in_simpleReports2589 = new BitSet(new long[]{0x0007FE0140000000L,0x0000000003F8C314L});
    public static final BitSet FOLLOW_simpleReport_in_simpleReports2595 = new BitSet(new long[]{0x0007FE0140400002L,0x0000000003F8C314L});
    public static final BitSet FOLLOW_concatenatedReport_in_simpleReport2611 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionalReport_in_simpleReport2617 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REPORT_in_concatenatedReport2632 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000003F8C310L});
    public static final BitSet FOLLOW_concatenatedReportTerms_in_concatenatedReport2635 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleTerm_in_concatenatedReportTerms2659 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000008L});
    public static final BitSet FOLLOW_ADD_in_concatenatedReportTerms2663 = new BitSet(new long[]{0x0007FE0040000000L,0x0000000003F8C310L});
    public static final BitSet FOLLOW_simpleTerm_in_concatenatedReportTerms2666 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000008L});
    public static final BitSet FOLLOW_IF_in_conditionalReport2686 = new BitSet(new long[]{0x0057FE0140200000L,0x0000000001F8C312L});
    public static final BitSet FOLLOW_constraint_in_conditionalReport2688 = new BitSet(new long[]{0x0000000200000000L});
    public static final BitSet FOLLOW_THEN_in_conditionalReport2690 = new BitSet(new long[]{0x0007FE0140000000L,0x0000000003F8C314L});
    public static final BitSet FOLLOW_compoundReport_in_conditionalReport2694 = new BitSet(new long[]{0x0000000400000000L,0x0000000004000000L});
    public static final BitSet FOLLOW_ELSE_in_conditionalReport2698 = new BitSet(new long[]{0x0007FE0140000000L,0x0000000003F8C314L});
    public static final BitSet FOLLOW_compoundReport_in_conditionalReport2702 = new BitSet(new long[]{0x0000000000000000L,0x0000000004000000L});
    public static final BitSet FOLLOW_SEMI_in_conditionalReport2707 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_context_in_synpred1_NRLConstraintRules125 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_VALIDATION_RULE_in_synpred1_NRLConstraintRules127 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modelReference_in_synpred2_NRLConstraintRules619 = new BitSet(new long[]{0x0008000010000000L});
    public static final BitSet FOLLOW_set_in_synpred2_NRLConstraintRules621 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modelReference_in_synpred3_NRLConstraintRules637 = new BitSet(new long[]{0x0000010000000000L});
    public static final BitSet FOLLOW_THAT_in_synpred3_NRLConstraintRules639 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modelReference_in_synpred4_NRLConstraintRules651 = new BitSet(new long[]{0x0020000000000000L});
    public static final BitSet FOLLOW_NOT_PRESENT_in_synpred4_NRLConstraintRules653 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_enumeratorDisambiguation_in_synpred5_NRLConstraintRules666 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_forallStart_in_synpred6_NRLConstraintRules678 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_enumeratorStart_in_synpred7_NRLConstraintRules876 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_HASHAVE_in_synpred7_NRLConstraintRules878 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_synpred8_NRLConstraintRules1047 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_forallStart_in_synpred9_NRLConstraintRules1096 = new BitSet(new long[]{0x0000008000000000L});
    public static final BitSet FOLLOW_OF_in_synpred9_NRLConstraintRules1098 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_synpred9_NRLConstraintRules1100 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_HASHAVE_in_synpred9_NRLConstraintRules1102 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_forallStart_in_synpred10_NRLConstraintRules1134 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_synpred10_NRLConstraintRules1136 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_HASHAVE_in_synpred10_NRLConstraintRules1138 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_forallStart_in_synpred11_NRLConstraintRules1170 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_DOUBLE_QUOTED_STRING_in_synpred11_NRLConstraintRules1172 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_synpred12_NRLConstraintRules1277 = new BitSet(new long[]{0x0100000000000000L});
    public static final BitSet FOLLOW_IS_IN_in_synpred12_NRLConstraintRules1279 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_synpred13_NRLConstraintRules1296 = new BitSet(new long[]{0x0200000000000000L});
    public static final BitSet FOLLOW_IS_NOT_IN_in_synpred13_NRLConstraintRules1298 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modelReference_in_synpred14_NRLConstraintRules1315 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_KIND_OF_in_synpred14_NRLConstraintRules1317 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FOLLOWING_in_synpred15_NRLConstraintRules1329 = new BitSet(new long[]{0x0008000000000000L});
    public static final BitSet FOLLOW_PRESENT_in_synpred15_NRLConstraintRules1331 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FOLLOWING_in_synpred16_NRLConstraintRules1343 = new BitSet(new long[]{0x0020000000000000L});
    public static final BitSet FOLLOW_NOT_PRESENT_in_synpred16_NRLConstraintRules1345 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_OPERATOR_in_synpred17_NRLConstraintRules1879 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PROPERTYNAME_in_synpred18_NRLConstraintRules1891 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modelReference_in_synpred19_NRLConstraintRules1903 = new BitSet(new long[]{0x0000000000000000L,0x0000000000040000L});
    public static final BitSet FOLLOW_AS_A_in_synpred19_NRLConstraintRules1905 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_modelReference_in_synpred20_NRLConstraintRules1917 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_WHERE_in_synpred20_NRLConstraintRules1919 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FIRST_in_synpred21_NRLConstraintRules1931 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_synpred21_NRLConstraintRules1933 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_WHERE_in_synpred21_NRLConstraintRules1935 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FIRST_in_synpred22_NRLConstraintRules1947 = new BitSet(new long[]{0x0000008000000000L});
    public static final BitSet FOLLOW_OF_in_synpred22_NRLConstraintRules1949 = new BitSet(new long[]{0x0007FE0000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_modelReference_in_synpred22_NRLConstraintRules1951 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_WHERE_in_synpred22_NRLConstraintRules1953 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_OPERATOR_in_synpred23_NRLConstraintRules2000 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NUMBER_OF_in_synpred24_NRLConstraintRules2151 = new BitSet(new long[]{0x0000000000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_UNIQUE_in_synpred24_NRLConstraintRules2153 = new BitSet(new long[]{0x0000000000000002L});

}